(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(require('axios'), require('crypto')) :
    typeof define === 'function' && define.amd ? define(['axios', 'crypto'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.axios, global.require$$0));
})(this, (function (require$$2, require$$0) { 'use strict';

    function getWindow() {
        return globalThis;
    }
    const checkForAxios = (window = null) => {
        const win = window !== null && window !== void 0 ? window : getWindow();
        if (!win.axios) {
            throw new Error('[alpinejs-ray] axios is required for alpinejs-ray to function correctly.');
        }
    };
    const encodeHtmlEntities$1 = (str) => {
        const escapeChars = {
            '¢': 'cent',
            '£': 'pound',
            '¥': 'yen',
            '€': 'euro',
            '©': 'copy',
            '®': 'reg',
            '<': 'lt',
            '>': 'gt',
            '"': 'quot',
            '&': 'amp',
            "'": '#39',
            ' ': 'nbsp',
        };
        const chars = Object.keys(escapeChars);
        const regex = new RegExp(`[${chars.join('')}]`, 'g');
        return str.replace(regex, m => `&${escapeChars[m]};`);
    };
    const filterObjectKeys = (obj, ignoreKeys) => {
        const result = {};
        Object.keys(obj)
            .filter(key => !ignoreKeys.includes(key))
            .forEach(key => {
            result[key] = obj[key];
        });
        return result;
    };
    const highlightHtmlMarkup = (str) => {
        return (encodeHtmlEntities$1(str)
            .replace(/(:?href|:?id|:?name|:?value|:?type|:?style|:?class|:?key)=/g, '<span class="text-orange-400">$1</span>=')
            .replace(/&#39;/g, "'")
            .replace(/('[^']*')/g, '<div class="text-purple-600 inline">$1</div>')
            .replace(/=&quot;(.+)(true|false)(.*)&quot;/g, '=&quot;$1<span class="text-orange-600 font-bold">$2</span>$3&quot;')
            .replace(/&quot;(.*)&quot;/g, '<span class="text-green-600">&quot;$1&quot;</span>')
            .replace(/([{,](?:&nbsp;|\s*))('\w+'|\w+):/g, '$1<div class="text-blue-800 bg-blue-200 rounded-md p-1 inline">$2</div>:')
            .replace(/:&nbsp;(-?\d+\.\d+|-?\d+)/g, ':&nbsp;<span class="text-red-800">$1</span>')
            .replace(/:&nbsp;(true|false|null)/g, ':&nbsp;<span class="text-orange-600 font-bold">$1</span>')
            .replace(/\r?\n/g, '<br>')
            .replace(/(&lt;)(\/?\s*[\w-_]+)(&gt;)?/g, '<span class="text-blue-600">$1$2$3</span>')
            .replace(/(@click|x-bind|x-cloak|x-data|x-for|x-if|x-html|x-init|x-model[\.\-\w+]*|x-on:\w+[\.\-\w+]*|x-ref|x-show|x-spread|x-transition:\w+[\-\w]+|x-text)=/g, '<span class="text-indigo-800">$1</span>=')
            .replace(/(\$el|\$refs|\$event|\$data|\$dispatch|\$nextTick|\$watch|\$ray)/g, '<span class="text-red-700">$1</span>'));
    };
    function findParentComponent(el) {
        let counter = 0;
        let e = el;
        while (counter < 30) {
            counter++;
            e = e.parentElement;
            if (e.hasAttribute('x-data')) {
                return e;
            }
        }
        return null;
    }

    var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

    var web_cjs = {};

    var md5Exports = {};
    var md5$3 = {
      get exports(){ return md5Exports; },
      set exports(v){ md5Exports = v; },
    };

    var cryptExports = {};
    var crypt = {
      get exports(){ return cryptExports; },
      set exports(v){ cryptExports = v; },
    };

    (function() {
      var base64map
          = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/',

      crypt$1 = {
        // Bit-wise rotation left
        rotl: function(n, b) {
          return (n << b) | (n >>> (32 - b));
        },

        // Bit-wise rotation right
        rotr: function(n, b) {
          return (n << (32 - b)) | (n >>> b);
        },

        // Swap big-endian to little-endian and vice versa
        endian: function(n) {
          // If number given, swap endian
          if (n.constructor == Number) {
            return crypt$1.rotl(n, 8) & 0x00FF00FF | crypt$1.rotl(n, 24) & 0xFF00FF00;
          }

          // Else, assume array and swap all items
          for (var i = 0; i < n.length; i++)
            n[i] = crypt$1.endian(n[i]);
          return n;
        },

        // Generate an array of any length of random bytes
        randomBytes: function(n) {
          for (var bytes = []; n > 0; n--)
            bytes.push(Math.floor(Math.random() * 256));
          return bytes;
        },

        // Convert a byte array to big-endian 32-bit words
        bytesToWords: function(bytes) {
          for (var words = [], i = 0, b = 0; i < bytes.length; i++, b += 8)
            words[b >>> 5] |= bytes[i] << (24 - b % 32);
          return words;
        },

        // Convert big-endian 32-bit words to a byte array
        wordsToBytes: function(words) {
          for (var bytes = [], b = 0; b < words.length * 32; b += 8)
            bytes.push((words[b >>> 5] >>> (24 - b % 32)) & 0xFF);
          return bytes;
        },

        // Convert a byte array to a hex string
        bytesToHex: function(bytes) {
          for (var hex = [], i = 0; i < bytes.length; i++) {
            hex.push((bytes[i] >>> 4).toString(16));
            hex.push((bytes[i] & 0xF).toString(16));
          }
          return hex.join('');
        },

        // Convert a hex string to a byte array
        hexToBytes: function(hex) {
          for (var bytes = [], c = 0; c < hex.length; c += 2)
            bytes.push(parseInt(hex.substr(c, 2), 16));
          return bytes;
        },

        // Convert a byte array to a base-64 string
        bytesToBase64: function(bytes) {
          for (var base64 = [], i = 0; i < bytes.length; i += 3) {
            var triplet = (bytes[i] << 16) | (bytes[i + 1] << 8) | bytes[i + 2];
            for (var j = 0; j < 4; j++)
              if (i * 8 + j * 6 <= bytes.length * 8)
                base64.push(base64map.charAt((triplet >>> 6 * (3 - j)) & 0x3F));
              else
                base64.push('=');
          }
          return base64.join('');
        },

        // Convert a base-64 string to a byte array
        base64ToBytes: function(base64) {
          // Remove non-base-64 characters
          base64 = base64.replace(/[^A-Z0-9+\/]/ig, '');

          for (var bytes = [], i = 0, imod4 = 0; i < base64.length;
              imod4 = ++i % 4) {
            if (imod4 == 0) continue;
            bytes.push(((base64map.indexOf(base64.charAt(i - 1))
                & (Math.pow(2, -2 * imod4 + 8) - 1)) << (imod4 * 2))
                | (base64map.indexOf(base64.charAt(i)) >>> (6 - imod4 * 2)));
          }
          return bytes;
        }
      };

      crypt.exports = crypt$1;
    })();

    var charenc = {
      // UTF-8 encoding
      utf8: {
        // Convert a string to a byte array
        stringToBytes: function(str) {
          return charenc.bin.stringToBytes(unescape(encodeURIComponent(str)));
        },

        // Convert a byte array to a string
        bytesToString: function(bytes) {
          return decodeURIComponent(escape(charenc.bin.bytesToString(bytes)));
        }
      },

      // Binary encoding
      bin: {
        // Convert a string to a byte array
        stringToBytes: function(str) {
          for (var bytes = [], i = 0; i < str.length; i++)
            bytes.push(str.charCodeAt(i) & 0xFF);
          return bytes;
        },

        // Convert a byte array to a string
        bytesToString: function(bytes) {
          for (var str = [], i = 0; i < bytes.length; i++)
            str.push(String.fromCharCode(bytes[i]));
          return str.join('');
        }
      }
    };

    var charenc_1 = charenc;

    /*!
     * Determine if an object is a Buffer
     *
     * @author   Feross Aboukhadijeh <https://feross.org>
     * @license  MIT
     */

    // The _isBuffer check is for Safari 5-7 support, because it's missing
    // Object.prototype.constructor. Remove this eventually
    var isBuffer_1 = function (obj) {
      return obj != null && (isBuffer(obj) || isSlowBuffer(obj) || !!obj._isBuffer)
    };

    function isBuffer (obj) {
      return !!obj.constructor && typeof obj.constructor.isBuffer === 'function' && obj.constructor.isBuffer(obj)
    }

    // For Node v0.10 support. Remove this eventually.
    function isSlowBuffer (obj) {
      return typeof obj.readFloatLE === 'function' && typeof obj.slice === 'function' && isBuffer(obj.slice(0, 0))
    }

    (function(){
      var crypt = cryptExports,
          utf8 = charenc_1.utf8,
          isBuffer = isBuffer_1,
          bin = charenc_1.bin,

      // The core
      md5 = function (message, options) {
        // Convert to byte array
        if (message.constructor == String)
          if (options && options.encoding === 'binary')
            message = bin.stringToBytes(message);
          else
            message = utf8.stringToBytes(message);
        else if (isBuffer(message))
          message = Array.prototype.slice.call(message, 0);
        else if (!Array.isArray(message) && message.constructor !== Uint8Array)
          message = message.toString();
        // else, assume byte array already

        var m = crypt.bytesToWords(message),
            l = message.length * 8,
            a =  1732584193,
            b = -271733879,
            c = -1732584194,
            d =  271733878;

        // Swap endian
        for (var i = 0; i < m.length; i++) {
          m[i] = ((m[i] <<  8) | (m[i] >>> 24)) & 0x00FF00FF |
                 ((m[i] << 24) | (m[i] >>>  8)) & 0xFF00FF00;
        }

        // Padding
        m[l >>> 5] |= 0x80 << (l % 32);
        m[(((l + 64) >>> 9) << 4) + 14] = l;

        // Method shortcuts
        var FF = md5._ff,
            GG = md5._gg,
            HH = md5._hh,
            II = md5._ii;

        for (var i = 0; i < m.length; i += 16) {

          var aa = a,
              bb = b,
              cc = c,
              dd = d;

          a = FF(a, b, c, d, m[i+ 0],  7, -680876936);
          d = FF(d, a, b, c, m[i+ 1], 12, -389564586);
          c = FF(c, d, a, b, m[i+ 2], 17,  606105819);
          b = FF(b, c, d, a, m[i+ 3], 22, -1044525330);
          a = FF(a, b, c, d, m[i+ 4],  7, -176418897);
          d = FF(d, a, b, c, m[i+ 5], 12,  1200080426);
          c = FF(c, d, a, b, m[i+ 6], 17, -1473231341);
          b = FF(b, c, d, a, m[i+ 7], 22, -45705983);
          a = FF(a, b, c, d, m[i+ 8],  7,  1770035416);
          d = FF(d, a, b, c, m[i+ 9], 12, -1958414417);
          c = FF(c, d, a, b, m[i+10], 17, -42063);
          b = FF(b, c, d, a, m[i+11], 22, -1990404162);
          a = FF(a, b, c, d, m[i+12],  7,  1804603682);
          d = FF(d, a, b, c, m[i+13], 12, -40341101);
          c = FF(c, d, a, b, m[i+14], 17, -1502002290);
          b = FF(b, c, d, a, m[i+15], 22,  1236535329);

          a = GG(a, b, c, d, m[i+ 1],  5, -165796510);
          d = GG(d, a, b, c, m[i+ 6],  9, -1069501632);
          c = GG(c, d, a, b, m[i+11], 14,  643717713);
          b = GG(b, c, d, a, m[i+ 0], 20, -373897302);
          a = GG(a, b, c, d, m[i+ 5],  5, -701558691);
          d = GG(d, a, b, c, m[i+10],  9,  38016083);
          c = GG(c, d, a, b, m[i+15], 14, -660478335);
          b = GG(b, c, d, a, m[i+ 4], 20, -405537848);
          a = GG(a, b, c, d, m[i+ 9],  5,  568446438);
          d = GG(d, a, b, c, m[i+14],  9, -1019803690);
          c = GG(c, d, a, b, m[i+ 3], 14, -187363961);
          b = GG(b, c, d, a, m[i+ 8], 20,  1163531501);
          a = GG(a, b, c, d, m[i+13],  5, -1444681467);
          d = GG(d, a, b, c, m[i+ 2],  9, -51403784);
          c = GG(c, d, a, b, m[i+ 7], 14,  1735328473);
          b = GG(b, c, d, a, m[i+12], 20, -1926607734);

          a = HH(a, b, c, d, m[i+ 5],  4, -378558);
          d = HH(d, a, b, c, m[i+ 8], 11, -2022574463);
          c = HH(c, d, a, b, m[i+11], 16,  1839030562);
          b = HH(b, c, d, a, m[i+14], 23, -35309556);
          a = HH(a, b, c, d, m[i+ 1],  4, -1530992060);
          d = HH(d, a, b, c, m[i+ 4], 11,  1272893353);
          c = HH(c, d, a, b, m[i+ 7], 16, -155497632);
          b = HH(b, c, d, a, m[i+10], 23, -1094730640);
          a = HH(a, b, c, d, m[i+13],  4,  681279174);
          d = HH(d, a, b, c, m[i+ 0], 11, -358537222);
          c = HH(c, d, a, b, m[i+ 3], 16, -722521979);
          b = HH(b, c, d, a, m[i+ 6], 23,  76029189);
          a = HH(a, b, c, d, m[i+ 9],  4, -640364487);
          d = HH(d, a, b, c, m[i+12], 11, -421815835);
          c = HH(c, d, a, b, m[i+15], 16,  530742520);
          b = HH(b, c, d, a, m[i+ 2], 23, -995338651);

          a = II(a, b, c, d, m[i+ 0],  6, -198630844);
          d = II(d, a, b, c, m[i+ 7], 10,  1126891415);
          c = II(c, d, a, b, m[i+14], 15, -1416354905);
          b = II(b, c, d, a, m[i+ 5], 21, -57434055);
          a = II(a, b, c, d, m[i+12],  6,  1700485571);
          d = II(d, a, b, c, m[i+ 3], 10, -1894986606);
          c = II(c, d, a, b, m[i+10], 15, -1051523);
          b = II(b, c, d, a, m[i+ 1], 21, -2054922799);
          a = II(a, b, c, d, m[i+ 8],  6,  1873313359);
          d = II(d, a, b, c, m[i+15], 10, -30611744);
          c = II(c, d, a, b, m[i+ 6], 15, -1560198380);
          b = II(b, c, d, a, m[i+13], 21,  1309151649);
          a = II(a, b, c, d, m[i+ 4],  6, -145523070);
          d = II(d, a, b, c, m[i+11], 10, -1120210379);
          c = II(c, d, a, b, m[i+ 2], 15,  718787259);
          b = II(b, c, d, a, m[i+ 9], 21, -343485551);

          a = (a + aa) >>> 0;
          b = (b + bb) >>> 0;
          c = (c + cc) >>> 0;
          d = (d + dd) >>> 0;
        }

        return crypt.endian([a, b, c, d]);
      };

      // Auxiliary functions
      md5._ff  = function (a, b, c, d, x, s, t) {
        var n = a + (b & c | ~b & d) + (x >>> 0) + t;
        return ((n << s) | (n >>> (32 - s))) + b;
      };
      md5._gg  = function (a, b, c, d, x, s, t) {
        var n = a + (b & d | c & ~d) + (x >>> 0) + t;
        return ((n << s) | (n >>> (32 - s))) + b;
      };
      md5._hh  = function (a, b, c, d, x, s, t) {
        var n = a + (b ^ c ^ d) + (x >>> 0) + t;
        return ((n << s) | (n >>> (32 - s))) + b;
      };
      md5._ii  = function (a, b, c, d, x, s, t) {
        var n = a + (c ^ (b | ~d)) + (x >>> 0) + t;
        return ((n << s) | (n >>> (32 - s))) + b;
      };

      // Package private blocksize
      md5._blocksize = 16;
      md5._digestsize = 16;

      md5$3.exports = function (message, options) {
        if (message === undefined || message === null)
          throw new Error('Illegal argument ' + message);

        var digestbytes = crypt.wordsToBytes(md5(message, options));
        return options && options.asBytes ? digestbytes :
            options && options.asString ? bin.bytesToString(digestbytes) :
            crypt.bytesToHex(digestbytes);
      };

    })();

    var stacktraceExports = {};
    var stacktrace = {
      get exports(){ return stacktraceExports; },
      set exports(v){ stacktraceExports = v; },
    };

    var errorStackParserExports = {};
    var errorStackParser = {
      get exports(){ return errorStackParserExports; },
      set exports(v){ errorStackParserExports = v; },
    };

    var stackframeExports$1 = {};
    var stackframe$1 = {
      get exports(){ return stackframeExports$1; },
      set exports(v){ stackframeExports$1 = v; },
    };

    var hasRequiredStackframe$1;

    function requireStackframe$1 () {
    	if (hasRequiredStackframe$1) return stackframeExports$1;
    	hasRequiredStackframe$1 = 1;
    	(function (module, exports) {
    		(function (root, factory) {
    		    // Universal Module Definition (UMD) to support AMD, CommonJS/Node.js, Rhino, and browsers.

    		    /* istanbul ignore next */
    		    {
    		        module.exports = factory();
    		    }
    		}(commonjsGlobal, function () {
    		    function _isNumber(n) {
    		        return !isNaN(parseFloat(n)) && isFinite(n);
    		    }

    		    function StackFrame(functionName, args, fileName, lineNumber, columnNumber, source) {
    		        if (functionName !== undefined) {
    		            this.setFunctionName(functionName);
    		        }
    		        if (args !== undefined) {
    		            this.setArgs(args);
    		        }
    		        if (fileName !== undefined) {
    		            this.setFileName(fileName);
    		        }
    		        if (lineNumber !== undefined) {
    		            this.setLineNumber(lineNumber);
    		        }
    		        if (columnNumber !== undefined) {
    		            this.setColumnNumber(columnNumber);
    		        }
    		        if (source !== undefined) {
    		            this.setSource(source);
    		        }
    		    }

    		    StackFrame.prototype = {
    		        getFunctionName: function () {
    		            return this.functionName;
    		        },
    		        setFunctionName: function (v) {
    		            this.functionName = String(v);
    		        },

    		        getArgs: function () {
    		            return this.args;
    		        },
    		        setArgs: function (v) {
    		            if (Object.prototype.toString.call(v) !== '[object Array]') {
    		                throw new TypeError('Args must be an Array');
    		            }
    		            this.args = v;
    		        },

    		        // NOTE: Property name may be misleading as it includes the path,
    		        // but it somewhat mirrors V8's JavaScriptStackTraceApi
    		        // https://code.google.com/p/v8/wiki/JavaScriptStackTraceApi and Gecko's
    		        // http://mxr.mozilla.org/mozilla-central/source/xpcom/base/nsIException.idl#14
    		        getFileName: function () {
    		            return this.fileName;
    		        },
    		        setFileName: function (v) {
    		            this.fileName = String(v);
    		        },

    		        getLineNumber: function () {
    		            return this.lineNumber;
    		        },
    		        setLineNumber: function (v) {
    		            if (!_isNumber(v)) {
    		                throw new TypeError('Line Number must be a Number');
    		            }
    		            this.lineNumber = Number(v);
    		        },

    		        getColumnNumber: function () {
    		            return this.columnNumber;
    		        },
    		        setColumnNumber: function (v) {
    		            if (!_isNumber(v)) {
    		                throw new TypeError('Column Number must be a Number');
    		            }
    		            this.columnNumber = Number(v);
    		        },

    		        getSource: function () {
    		            return this.source;
    		        },
    		        setSource: function (v) {
    		            this.source = String(v);
    		        },

    		        toString: function() {
    		            var functionName = this.getFunctionName() || '{anonymous}';
    		            var args = '(' + (this.getArgs() || []).join(',') + ')';
    		            var fileName = this.getFileName() ? ('@' + this.getFileName()) : '';
    		            var lineNumber = _isNumber(this.getLineNumber()) ? (':' + this.getLineNumber()) : '';
    		            var columnNumber = _isNumber(this.getColumnNumber()) ? (':' + this.getColumnNumber()) : '';
    		            return functionName + args + fileName + lineNumber + columnNumber;
    		        }
    		    };

    		    return StackFrame;
    		}));
    } (stackframe$1));
    	return stackframeExports$1;
    }

    var hasRequiredErrorStackParser;

    function requireErrorStackParser () {
    	if (hasRequiredErrorStackParser) return errorStackParserExports;
    	hasRequiredErrorStackParser = 1;
    	(function (module, exports) {
    		(function(root, factory) {
    		    // Universal Module Definition (UMD) to support AMD, CommonJS/Node.js, Rhino, and browsers.

    		    /* istanbul ignore next */
    		    {
    		        module.exports = factory(requireStackframe$1());
    		    }
    		}(commonjsGlobal, function ErrorStackParser(StackFrame) {

    		    var FIREFOX_SAFARI_STACK_REGEXP = /(^|@)\S+\:\d+/;
    		    var CHROME_IE_STACK_REGEXP = /^\s*at .*(\S+\:\d+|\(native\))/m;
    		    var SAFARI_NATIVE_CODE_REGEXP = /^(eval@)?(\[native code\])?$/;

    		    function _map(array, fn, thisArg) {
    		        if (typeof Array.prototype.map === 'function') {
    		            return array.map(fn, thisArg);
    		        } else {
    		            var output = new Array(array.length);
    		            for (var i = 0; i < array.length; i++) {
    		                output[i] = fn.call(thisArg, array[i]);
    		            }
    		            return output;
    		        }
    		    }

    		    function _filter(array, fn, thisArg) {
    		        if (typeof Array.prototype.filter === 'function') {
    		            return array.filter(fn, thisArg);
    		        } else {
    		            var output = [];
    		            for (var i = 0; i < array.length; i++) {
    		                if (fn.call(thisArg, array[i])) {
    		                    output.push(array[i]);
    		                }
    		            }
    		            return output;
    		        }
    		    }

    		    function _indexOf(array, target) {
    		        if (typeof Array.prototype.indexOf === 'function') {
    		            return array.indexOf(target);
    		        } else {
    		            for (var i = 0; i < array.length; i++) {
    		                if (array[i] === target) {
    		                    return i;
    		                }
    		            }
    		            return -1;
    		        }
    		    }

    		    return {
    		        /**
    		         * Given an Error object, extract the most information from it.
    		         *
    		         * @param {Error} error object
    		         * @return {Array} of StackFrames
    		         */
    		        parse: function ErrorStackParser$$parse(error) {
    		            if (typeof error.stacktrace !== 'undefined' || typeof error['opera#sourceloc'] !== 'undefined') {
    		                return this.parseOpera(error);
    		            } else if (error.stack && error.stack.match(CHROME_IE_STACK_REGEXP)) {
    		                return this.parseV8OrIE(error);
    		            } else if (error.stack) {
    		                return this.parseFFOrSafari(error);
    		            } else {
    		                throw new Error('Cannot parse given Error object');
    		            }
    		        },

    		        // Separate line and column numbers from a string of the form: (URI:Line:Column)
    		        extractLocation: function ErrorStackParser$$extractLocation(urlLike) {
    		            // Fail-fast but return locations like "(native)"
    		            if (urlLike.indexOf(':') === -1) {
    		                return [urlLike];
    		            }

    		            var regExp = /(.+?)(?:\:(\d+))?(?:\:(\d+))?$/;
    		            var parts = regExp.exec(urlLike.replace(/[\(\)]/g, ''));
    		            return [parts[1], parts[2] || undefined, parts[3] || undefined];
    		        },

    		        parseV8OrIE: function ErrorStackParser$$parseV8OrIE(error) {
    		            var filtered = _filter(error.stack.split('\n'), function(line) {
    		                return !!line.match(CHROME_IE_STACK_REGEXP);
    		            }, this);

    		            return _map(filtered, function(line) {
    		                if (line.indexOf('(eval ') > -1) {
    		                    // Throw away eval information until we implement stacktrace.js/stackframe#8
    		                    line = line.replace(/eval code/g, 'eval').replace(/(\(eval at [^\()]*)|(\)\,.*$)/g, '');
    		                }
    		                var tokens = line.replace(/^\s+/, '').replace(/\(eval code/g, '(').split(/\s+/).slice(1);
    		                var locationParts = this.extractLocation(tokens.pop());
    		                var functionName = tokens.join(' ') || undefined;
    		                var fileName = _indexOf(['eval', '<anonymous>'], locationParts[0]) > -1 ? undefined : locationParts[0];

    		                return new StackFrame(functionName, undefined, fileName, locationParts[1], locationParts[2], line);
    		            }, this);
    		        },

    		        parseFFOrSafari: function ErrorStackParser$$parseFFOrSafari(error) {
    		            var filtered = _filter(error.stack.split('\n'), function(line) {
    		                return !line.match(SAFARI_NATIVE_CODE_REGEXP);
    		            }, this);

    		            return _map(filtered, function(line) {
    		                // Throw away eval information until we implement stacktrace.js/stackframe#8
    		                if (line.indexOf(' > eval') > -1) {
    		                    line = line.replace(/ line (\d+)(?: > eval line \d+)* > eval\:\d+\:\d+/g, ':$1');
    		                }

    		                if (line.indexOf('@') === -1 && line.indexOf(':') === -1) {
    		                    // Safari eval frames only have function names and nothing else
    		                    return new StackFrame(line);
    		                } else {
    		                    var tokens = line.split('@');
    		                    var locationParts = this.extractLocation(tokens.pop());
    		                    var functionName = tokens.join('@') || undefined;
    		                    return new StackFrame(functionName,
    		                        undefined,
    		                        locationParts[0],
    		                        locationParts[1],
    		                        locationParts[2],
    		                        line);
    		                }
    		            }, this);
    		        },

    		        parseOpera: function ErrorStackParser$$parseOpera(e) {
    		            if (!e.stacktrace || (e.message.indexOf('\n') > -1 &&
    		                e.message.split('\n').length > e.stacktrace.split('\n').length)) {
    		                return this.parseOpera9(e);
    		            } else if (!e.stack) {
    		                return this.parseOpera10(e);
    		            } else {
    		                return this.parseOpera11(e);
    		            }
    		        },

    		        parseOpera9: function ErrorStackParser$$parseOpera9(e) {
    		            var lineRE = /Line (\d+).*script (?:in )?(\S+)/i;
    		            var lines = e.message.split('\n');
    		            var result = [];

    		            for (var i = 2, len = lines.length; i < len; i += 2) {
    		                var match = lineRE.exec(lines[i]);
    		                if (match) {
    		                    result.push(new StackFrame(undefined, undefined, match[2], match[1], undefined, lines[i]));
    		                }
    		            }

    		            return result;
    		        },

    		        parseOpera10: function ErrorStackParser$$parseOpera10(e) {
    		            var lineRE = /Line (\d+).*script (?:in )?(\S+)(?:: In function (\S+))?$/i;
    		            var lines = e.stacktrace.split('\n');
    		            var result = [];

    		            for (var i = 0, len = lines.length; i < len; i += 2) {
    		                var match = lineRE.exec(lines[i]);
    		                if (match) {
    		                    result.push(
    		                        new StackFrame(
    		                            match[3] || undefined,
    		                            undefined,
    		                            match[2],
    		                            match[1],
    		                            undefined,
    		                            lines[i]
    		                        )
    		                    );
    		                }
    		            }

    		            return result;
    		        },

    		        // Opera 10.65+ Error.stack very similar to FF/Safari
    		        parseOpera11: function ErrorStackParser$$parseOpera11(error) {
    		            var filtered = _filter(error.stack.split('\n'), function(line) {
    		                return !!line.match(FIREFOX_SAFARI_STACK_REGEXP) && !line.match(/^Error created at/);
    		            }, this);

    		            return _map(filtered, function(line) {
    		                var tokens = line.split('@');
    		                var locationParts = this.extractLocation(tokens.pop());
    		                var functionCall = (tokens.shift() || '');
    		                var functionName = functionCall
    		                        .replace(/<anonymous function(: (\w+))?>/, '$2')
    		                        .replace(/\([^\)]*\)/g, '') || undefined;
    		                var argsRaw;
    		                if (functionCall.match(/\(([^\)]*)\)/)) {
    		                    argsRaw = functionCall.replace(/^[^\(]+\(([^\)]*)\)$/, '$1');
    		                }
    		                var args = (argsRaw === undefined || argsRaw === '[arguments not available]') ?
    		                    undefined : argsRaw.split(',');
    		                return new StackFrame(
    		                    functionName,
    		                    args,
    		                    locationParts[0],
    		                    locationParts[1],
    		                    locationParts[2],
    		                    line);
    		            }, this);
    		        }
    		    };
    		}));
    } (errorStackParser));
    	return errorStackParserExports;
    }

    var stackGeneratorExports = {};
    var stackGenerator = {
      get exports(){ return stackGeneratorExports; },
      set exports(v){ stackGeneratorExports = v; },
    };

    var stackframeExports = {};
    var stackframe = {
      get exports(){ return stackframeExports; },
      set exports(v){ stackframeExports = v; },
    };

    var hasRequiredStackframe;

    function requireStackframe () {
    	if (hasRequiredStackframe) return stackframeExports;
    	hasRequiredStackframe = 1;
    	(function (module, exports) {
    		(function(root, factory) {
    		    // Universal Module Definition (UMD) to support AMD, CommonJS/Node.js, Rhino, and browsers.

    		    /* istanbul ignore next */
    		    {
    		        module.exports = factory();
    		    }
    		}(commonjsGlobal, function() {
    		    function _isNumber(n) {
    		        return !isNaN(parseFloat(n)) && isFinite(n);
    		    }

    		    function _capitalize(str) {
    		        return str.charAt(0).toUpperCase() + str.substring(1);
    		    }

    		    function _getter(p) {
    		        return function() {
    		            return this[p];
    		        };
    		    }

    		    var booleanProps = ['isConstructor', 'isEval', 'isNative', 'isToplevel'];
    		    var numericProps = ['columnNumber', 'lineNumber'];
    		    var stringProps = ['fileName', 'functionName', 'source'];
    		    var arrayProps = ['args'];
    		    var objectProps = ['evalOrigin'];

    		    var props = booleanProps.concat(numericProps, stringProps, arrayProps, objectProps);

    		    function StackFrame(obj) {
    		        if (!obj) return;
    		        for (var i = 0; i < props.length; i++) {
    		            if (obj[props[i]] !== undefined) {
    		                this['set' + _capitalize(props[i])](obj[props[i]]);
    		            }
    		        }
    		    }

    		    StackFrame.prototype = {
    		        getArgs: function() {
    		            return this.args;
    		        },
    		        setArgs: function(v) {
    		            if (Object.prototype.toString.call(v) !== '[object Array]') {
    		                throw new TypeError('Args must be an Array');
    		            }
    		            this.args = v;
    		        },

    		        getEvalOrigin: function() {
    		            return this.evalOrigin;
    		        },
    		        setEvalOrigin: function(v) {
    		            if (v instanceof StackFrame) {
    		                this.evalOrigin = v;
    		            } else if (v instanceof Object) {
    		                this.evalOrigin = new StackFrame(v);
    		            } else {
    		                throw new TypeError('Eval Origin must be an Object or StackFrame');
    		            }
    		        },

    		        toString: function() {
    		            var fileName = this.getFileName() || '';
    		            var lineNumber = this.getLineNumber() || '';
    		            var columnNumber = this.getColumnNumber() || '';
    		            var functionName = this.getFunctionName() || '';
    		            if (this.getIsEval()) {
    		                if (fileName) {
    		                    return '[eval] (' + fileName + ':' + lineNumber + ':' + columnNumber + ')';
    		                }
    		                return '[eval]:' + lineNumber + ':' + columnNumber;
    		            }
    		            if (functionName) {
    		                return functionName + ' (' + fileName + ':' + lineNumber + ':' + columnNumber + ')';
    		            }
    		            return fileName + ':' + lineNumber + ':' + columnNumber;
    		        }
    		    };

    		    StackFrame.fromString = function StackFrame$$fromString(str) {
    		        var argsStartIndex = str.indexOf('(');
    		        var argsEndIndex = str.lastIndexOf(')');

    		        var functionName = str.substring(0, argsStartIndex);
    		        var args = str.substring(argsStartIndex + 1, argsEndIndex).split(',');
    		        var locationString = str.substring(argsEndIndex + 1);

    		        if (locationString.indexOf('@') === 0) {
    		            var parts = /@(.+?)(?::(\d+))?(?::(\d+))?$/.exec(locationString, '');
    		            var fileName = parts[1];
    		            var lineNumber = parts[2];
    		            var columnNumber = parts[3];
    		        }

    		        return new StackFrame({
    		            functionName: functionName,
    		            args: args || undefined,
    		            fileName: fileName,
    		            lineNumber: lineNumber || undefined,
    		            columnNumber: columnNumber || undefined
    		        });
    		    };

    		    for (var i = 0; i < booleanProps.length; i++) {
    		        StackFrame.prototype['get' + _capitalize(booleanProps[i])] = _getter(booleanProps[i]);
    		        StackFrame.prototype['set' + _capitalize(booleanProps[i])] = (function(p) {
    		            return function(v) {
    		                this[p] = Boolean(v);
    		            };
    		        })(booleanProps[i]);
    		    }

    		    for (var j = 0; j < numericProps.length; j++) {
    		        StackFrame.prototype['get' + _capitalize(numericProps[j])] = _getter(numericProps[j]);
    		        StackFrame.prototype['set' + _capitalize(numericProps[j])] = (function(p) {
    		            return function(v) {
    		                if (!_isNumber(v)) {
    		                    throw new TypeError(p + ' must be a Number');
    		                }
    		                this[p] = Number(v);
    		            };
    		        })(numericProps[j]);
    		    }

    		    for (var k = 0; k < stringProps.length; k++) {
    		        StackFrame.prototype['get' + _capitalize(stringProps[k])] = _getter(stringProps[k]);
    		        StackFrame.prototype['set' + _capitalize(stringProps[k])] = (function(p) {
    		            return function(v) {
    		                this[p] = String(v);
    		            };
    		        })(stringProps[k]);
    		    }

    		    return StackFrame;
    		}));
    } (stackframe));
    	return stackframeExports;
    }

    var hasRequiredStackGenerator;

    function requireStackGenerator () {
    	if (hasRequiredStackGenerator) return stackGeneratorExports;
    	hasRequiredStackGenerator = 1;
    	(function (module, exports) {
    		(function (root, factory) {
    		    // Universal Module Definition (UMD) to support AMD, CommonJS/Node.js, Rhino, and browsers.

    		    /* istanbul ignore next */
    		    {
    		        module.exports = factory(requireStackframe());
    		    }
    		}(commonjsGlobal, function (StackFrame) {
    		    return {
    		        backtrace: function StackGenerator$$backtrace(opts) {
    		            var stack = [];
    		            var maxStackSize = 10;

    		            if (typeof opts === 'object' && typeof opts.maxStackSize === 'number') {
    		                maxStackSize = opts.maxStackSize;
    		            }

    		            var curr = arguments.callee;
    		            while (curr && stack.length < maxStackSize) {
    		                // Allow V8 optimizations
    		                var args = new Array(curr['arguments'].length);
    		                for(var i = 0; i < args.length; ++i) {
    		                    args[i] = curr['arguments'][i];
    		                }
    		                if (/function(?:\s+([\w$]+))+\s*\(/.test(curr.toString())) {
    		                    stack.push(new StackFrame({functionName: RegExp.$1 || undefined, args: args}));
    		                } else {
    		                    stack.push(new StackFrame({args: args}));
    		                }

    		                try {
    		                    curr = curr.caller;
    		                } catch (e) {
    		                    break;
    		                }
    		            }
    		            return stack;
    		        }
    		    };
    		}));
    } (stackGenerator));
    	return stackGeneratorExports;
    }

    var stacktraceGpsExports = {};
    var stacktraceGps = {
      get exports(){ return stacktraceGpsExports; },
      set exports(v){ stacktraceGpsExports = v; },
    };

    var sourceMapConsumer = {};

    var util = {};

    /* -*- Mode: js; js-indent-level: 2; -*- */

    var hasRequiredUtil;

    function requireUtil () {
    	if (hasRequiredUtil) return util;
    	hasRequiredUtil = 1;
    	(function (exports) {
    		/*
    		 * Copyright 2011 Mozilla Foundation and contributors
    		 * Licensed under the New BSD license. See LICENSE or:
    		 * http://opensource.org/licenses/BSD-3-Clause
    		 */

    		/**
    		 * This is a helper function for getting values from parameter/options
    		 * objects.
    		 *
    		 * @param args The object we are extracting values from
    		 * @param name The name of the property we are getting.
    		 * @param defaultValue An optional value to return if the property is missing
    		 * from the object. If this is not specified and the property is missing, an
    		 * error will be thrown.
    		 */
    		function getArg(aArgs, aName, aDefaultValue) {
    		  if (aName in aArgs) {
    		    return aArgs[aName];
    		  } else if (arguments.length === 3) {
    		    return aDefaultValue;
    		  } else {
    		    throw new Error('"' + aName + '" is a required argument.');
    		  }
    		}
    		exports.getArg = getArg;

    		var urlRegexp = /^(?:([\w+\-.]+):)?\/\/(?:(\w+:\w+)@)?([\w.]*)(?::(\d+))?(\S*)$/;
    		var dataUrlRegexp = /^data:.+\,.+$/;

    		function urlParse(aUrl) {
    		  var match = aUrl.match(urlRegexp);
    		  if (!match) {
    		    return null;
    		  }
    		  return {
    		    scheme: match[1],
    		    auth: match[2],
    		    host: match[3],
    		    port: match[4],
    		    path: match[5]
    		  };
    		}
    		exports.urlParse = urlParse;

    		function urlGenerate(aParsedUrl) {
    		  var url = '';
    		  if (aParsedUrl.scheme) {
    		    url += aParsedUrl.scheme + ':';
    		  }
    		  url += '//';
    		  if (aParsedUrl.auth) {
    		    url += aParsedUrl.auth + '@';
    		  }
    		  if (aParsedUrl.host) {
    		    url += aParsedUrl.host;
    		  }
    		  if (aParsedUrl.port) {
    		    url += ":" + aParsedUrl.port;
    		  }
    		  if (aParsedUrl.path) {
    		    url += aParsedUrl.path;
    		  }
    		  return url;
    		}
    		exports.urlGenerate = urlGenerate;

    		/**
    		 * Normalizes a path, or the path portion of a URL:
    		 *
    		 * - Replaces consecutive slashes with one slash.
    		 * - Removes unnecessary '.' parts.
    		 * - Removes unnecessary '<dir>/..' parts.
    		 *
    		 * Based on code in the Node.js 'path' core module.
    		 *
    		 * @param aPath The path or url to normalize.
    		 */
    		function normalize(aPath) {
    		  var path = aPath;
    		  var url = urlParse(aPath);
    		  if (url) {
    		    if (!url.path) {
    		      return aPath;
    		    }
    		    path = url.path;
    		  }
    		  var isAbsolute = exports.isAbsolute(path);

    		  var parts = path.split(/\/+/);
    		  for (var part, up = 0, i = parts.length - 1; i >= 0; i--) {
    		    part = parts[i];
    		    if (part === '.') {
    		      parts.splice(i, 1);
    		    } else if (part === '..') {
    		      up++;
    		    } else if (up > 0) {
    		      if (part === '') {
    		        // The first part is blank if the path is absolute. Trying to go
    		        // above the root is a no-op. Therefore we can remove all '..' parts
    		        // directly after the root.
    		        parts.splice(i + 1, up);
    		        up = 0;
    		      } else {
    		        parts.splice(i, 2);
    		        up--;
    		      }
    		    }
    		  }
    		  path = parts.join('/');

    		  if (path === '') {
    		    path = isAbsolute ? '/' : '.';
    		  }

    		  if (url) {
    		    url.path = path;
    		    return urlGenerate(url);
    		  }
    		  return path;
    		}
    		exports.normalize = normalize;

    		/**
    		 * Joins two paths/URLs.
    		 *
    		 * @param aRoot The root path or URL.
    		 * @param aPath The path or URL to be joined with the root.
    		 *
    		 * - If aPath is a URL or a data URI, aPath is returned, unless aPath is a
    		 *   scheme-relative URL: Then the scheme of aRoot, if any, is prepended
    		 *   first.
    		 * - Otherwise aPath is a path. If aRoot is a URL, then its path portion
    		 *   is updated with the result and aRoot is returned. Otherwise the result
    		 *   is returned.
    		 *   - If aPath is absolute, the result is aPath.
    		 *   - Otherwise the two paths are joined with a slash.
    		 * - Joining for example 'http://' and 'www.example.com' is also supported.
    		 */
    		function join(aRoot, aPath) {
    		  if (aRoot === "") {
    		    aRoot = ".";
    		  }
    		  if (aPath === "") {
    		    aPath = ".";
    		  }
    		  var aPathUrl = urlParse(aPath);
    		  var aRootUrl = urlParse(aRoot);
    		  if (aRootUrl) {
    		    aRoot = aRootUrl.path || '/';
    		  }

    		  // `join(foo, '//www.example.org')`
    		  if (aPathUrl && !aPathUrl.scheme) {
    		    if (aRootUrl) {
    		      aPathUrl.scheme = aRootUrl.scheme;
    		    }
    		    return urlGenerate(aPathUrl);
    		  }

    		  if (aPathUrl || aPath.match(dataUrlRegexp)) {
    		    return aPath;
    		  }

    		  // `join('http://', 'www.example.com')`
    		  if (aRootUrl && !aRootUrl.host && !aRootUrl.path) {
    		    aRootUrl.host = aPath;
    		    return urlGenerate(aRootUrl);
    		  }

    		  var joined = aPath.charAt(0) === '/'
    		    ? aPath
    		    : normalize(aRoot.replace(/\/+$/, '') + '/' + aPath);

    		  if (aRootUrl) {
    		    aRootUrl.path = joined;
    		    return urlGenerate(aRootUrl);
    		  }
    		  return joined;
    		}
    		exports.join = join;

    		exports.isAbsolute = function (aPath) {
    		  return aPath.charAt(0) === '/' || !!aPath.match(urlRegexp);
    		};

    		/**
    		 * Make a path relative to a URL or another path.
    		 *
    		 * @param aRoot The root path or URL.
    		 * @param aPath The path or URL to be made relative to aRoot.
    		 */
    		function relative(aRoot, aPath) {
    		  if (aRoot === "") {
    		    aRoot = ".";
    		  }

    		  aRoot = aRoot.replace(/\/$/, '');

    		  // It is possible for the path to be above the root. In this case, simply
    		  // checking whether the root is a prefix of the path won't work. Instead, we
    		  // need to remove components from the root one by one, until either we find
    		  // a prefix that fits, or we run out of components to remove.
    		  var level = 0;
    		  while (aPath.indexOf(aRoot + '/') !== 0) {
    		    var index = aRoot.lastIndexOf("/");
    		    if (index < 0) {
    		      return aPath;
    		    }

    		    // If the only part of the root that is left is the scheme (i.e. http://,
    		    // file:///, etc.), one or more slashes (/), or simply nothing at all, we
    		    // have exhausted all components, so the path is not relative to the root.
    		    aRoot = aRoot.slice(0, index);
    		    if (aRoot.match(/^([^\/]+:\/)?\/*$/)) {
    		      return aPath;
    		    }

    		    ++level;
    		  }

    		  // Make sure we add a "../" for each component we removed from the root.
    		  return Array(level + 1).join("../") + aPath.substr(aRoot.length + 1);
    		}
    		exports.relative = relative;

    		var supportsNullProto = (function () {
    		  var obj = Object.create(null);
    		  return !('__proto__' in obj);
    		}());

    		function identity (s) {
    		  return s;
    		}

    		/**
    		 * Because behavior goes wacky when you set `__proto__` on objects, we
    		 * have to prefix all the strings in our set with an arbitrary character.
    		 *
    		 * See https://github.com/mozilla/source-map/pull/31 and
    		 * https://github.com/mozilla/source-map/issues/30
    		 *
    		 * @param String aStr
    		 */
    		function toSetString(aStr) {
    		  if (isProtoString(aStr)) {
    		    return '$' + aStr;
    		  }

    		  return aStr;
    		}
    		exports.toSetString = supportsNullProto ? identity : toSetString;

    		function fromSetString(aStr) {
    		  if (isProtoString(aStr)) {
    		    return aStr.slice(1);
    		  }

    		  return aStr;
    		}
    		exports.fromSetString = supportsNullProto ? identity : fromSetString;

    		function isProtoString(s) {
    		  if (!s) {
    		    return false;
    		  }

    		  var length = s.length;

    		  if (length < 9 /* "__proto__".length */) {
    		    return false;
    		  }

    		  if (s.charCodeAt(length - 1) !== 95  /* '_' */ ||
    		      s.charCodeAt(length - 2) !== 95  /* '_' */ ||
    		      s.charCodeAt(length - 3) !== 111 /* 'o' */ ||
    		      s.charCodeAt(length - 4) !== 116 /* 't' */ ||
    		      s.charCodeAt(length - 5) !== 111 /* 'o' */ ||
    		      s.charCodeAt(length - 6) !== 114 /* 'r' */ ||
    		      s.charCodeAt(length - 7) !== 112 /* 'p' */ ||
    		      s.charCodeAt(length - 8) !== 95  /* '_' */ ||
    		      s.charCodeAt(length - 9) !== 95  /* '_' */) {
    		    return false;
    		  }

    		  for (var i = length - 10; i >= 0; i--) {
    		    if (s.charCodeAt(i) !== 36 /* '$' */) {
    		      return false;
    		    }
    		  }

    		  return true;
    		}

    		/**
    		 * Comparator between two mappings where the original positions are compared.
    		 *
    		 * Optionally pass in `true` as `onlyCompareGenerated` to consider two
    		 * mappings with the same original source/line/column, but different generated
    		 * line and column the same. Useful when searching for a mapping with a
    		 * stubbed out mapping.
    		 */
    		function compareByOriginalPositions(mappingA, mappingB, onlyCompareOriginal) {
    		  var cmp = mappingA.source - mappingB.source;
    		  if (cmp !== 0) {
    		    return cmp;
    		  }

    		  cmp = mappingA.originalLine - mappingB.originalLine;
    		  if (cmp !== 0) {
    		    return cmp;
    		  }

    		  cmp = mappingA.originalColumn - mappingB.originalColumn;
    		  if (cmp !== 0 || onlyCompareOriginal) {
    		    return cmp;
    		  }

    		  cmp = mappingA.generatedColumn - mappingB.generatedColumn;
    		  if (cmp !== 0) {
    		    return cmp;
    		  }

    		  cmp = mappingA.generatedLine - mappingB.generatedLine;
    		  if (cmp !== 0) {
    		    return cmp;
    		  }

    		  return mappingA.name - mappingB.name;
    		}
    		exports.compareByOriginalPositions = compareByOriginalPositions;

    		/**
    		 * Comparator between two mappings with deflated source and name indices where
    		 * the generated positions are compared.
    		 *
    		 * Optionally pass in `true` as `onlyCompareGenerated` to consider two
    		 * mappings with the same generated line and column, but different
    		 * source/name/original line and column the same. Useful when searching for a
    		 * mapping with a stubbed out mapping.
    		 */
    		function compareByGeneratedPositionsDeflated(mappingA, mappingB, onlyCompareGenerated) {
    		  var cmp = mappingA.generatedLine - mappingB.generatedLine;
    		  if (cmp !== 0) {
    		    return cmp;
    		  }

    		  cmp = mappingA.generatedColumn - mappingB.generatedColumn;
    		  if (cmp !== 0 || onlyCompareGenerated) {
    		    return cmp;
    		  }

    		  cmp = mappingA.source - mappingB.source;
    		  if (cmp !== 0) {
    		    return cmp;
    		  }

    		  cmp = mappingA.originalLine - mappingB.originalLine;
    		  if (cmp !== 0) {
    		    return cmp;
    		  }

    		  cmp = mappingA.originalColumn - mappingB.originalColumn;
    		  if (cmp !== 0) {
    		    return cmp;
    		  }

    		  return mappingA.name - mappingB.name;
    		}
    		exports.compareByGeneratedPositionsDeflated = compareByGeneratedPositionsDeflated;

    		function strcmp(aStr1, aStr2) {
    		  if (aStr1 === aStr2) {
    		    return 0;
    		  }

    		  if (aStr1 > aStr2) {
    		    return 1;
    		  }

    		  return -1;
    		}

    		/**
    		 * Comparator between two mappings with inflated source and name strings where
    		 * the generated positions are compared.
    		 */
    		function compareByGeneratedPositionsInflated(mappingA, mappingB) {
    		  var cmp = mappingA.generatedLine - mappingB.generatedLine;
    		  if (cmp !== 0) {
    		    return cmp;
    		  }

    		  cmp = mappingA.generatedColumn - mappingB.generatedColumn;
    		  if (cmp !== 0) {
    		    return cmp;
    		  }

    		  cmp = strcmp(mappingA.source, mappingB.source);
    		  if (cmp !== 0) {
    		    return cmp;
    		  }

    		  cmp = mappingA.originalLine - mappingB.originalLine;
    		  if (cmp !== 0) {
    		    return cmp;
    		  }

    		  cmp = mappingA.originalColumn - mappingB.originalColumn;
    		  if (cmp !== 0) {
    		    return cmp;
    		  }

    		  return strcmp(mappingA.name, mappingB.name);
    		}
    		exports.compareByGeneratedPositionsInflated = compareByGeneratedPositionsInflated;
    } (util));
    	return util;
    }

    var binarySearch = {};

    /* -*- Mode: js; js-indent-level: 2; -*- */

    var hasRequiredBinarySearch;

    function requireBinarySearch () {
    	if (hasRequiredBinarySearch) return binarySearch;
    	hasRequiredBinarySearch = 1;
    	(function (exports) {
    		/*
    		 * Copyright 2011 Mozilla Foundation and contributors
    		 * Licensed under the New BSD license. See LICENSE or:
    		 * http://opensource.org/licenses/BSD-3-Clause
    		 */

    		exports.GREATEST_LOWER_BOUND = 1;
    		exports.LEAST_UPPER_BOUND = 2;

    		/**
    		 * Recursive implementation of binary search.
    		 *
    		 * @param aLow Indices here and lower do not contain the needle.
    		 * @param aHigh Indices here and higher do not contain the needle.
    		 * @param aNeedle The element being searched for.
    		 * @param aHaystack The non-empty array being searched.
    		 * @param aCompare Function which takes two elements and returns -1, 0, or 1.
    		 * @param aBias Either 'binarySearch.GREATEST_LOWER_BOUND' or
    		 *     'binarySearch.LEAST_UPPER_BOUND'. Specifies whether to return the
    		 *     closest element that is smaller than or greater than the one we are
    		 *     searching for, respectively, if the exact element cannot be found.
    		 */
    		function recursiveSearch(aLow, aHigh, aNeedle, aHaystack, aCompare, aBias) {
    		  // This function terminates when one of the following is true:
    		  //
    		  //   1. We find the exact element we are looking for.
    		  //
    		  //   2. We did not find the exact element, but we can return the index of
    		  //      the next-closest element.
    		  //
    		  //   3. We did not find the exact element, and there is no next-closest
    		  //      element than the one we are searching for, so we return -1.
    		  var mid = Math.floor((aHigh - aLow) / 2) + aLow;
    		  var cmp = aCompare(aNeedle, aHaystack[mid], true);
    		  if (cmp === 0) {
    		    // Found the element we are looking for.
    		    return mid;
    		  }
    		  else if (cmp > 0) {
    		    // Our needle is greater than aHaystack[mid].
    		    if (aHigh - mid > 1) {
    		      // The element is in the upper half.
    		      return recursiveSearch(mid, aHigh, aNeedle, aHaystack, aCompare, aBias);
    		    }

    		    // The exact needle element was not found in this haystack. Determine if
    		    // we are in termination case (3) or (2) and return the appropriate thing.
    		    if (aBias == exports.LEAST_UPPER_BOUND) {
    		      return aHigh < aHaystack.length ? aHigh : -1;
    		    } else {
    		      return mid;
    		    }
    		  }
    		  else {
    		    // Our needle is less than aHaystack[mid].
    		    if (mid - aLow > 1) {
    		      // The element is in the lower half.
    		      return recursiveSearch(aLow, mid, aNeedle, aHaystack, aCompare, aBias);
    		    }

    		    // we are in termination case (3) or (2) and return the appropriate thing.
    		    if (aBias == exports.LEAST_UPPER_BOUND) {
    		      return mid;
    		    } else {
    		      return aLow < 0 ? -1 : aLow;
    		    }
    		  }
    		}

    		/**
    		 * This is an implementation of binary search which will always try and return
    		 * the index of the closest element if there is no exact hit. This is because
    		 * mappings between original and generated line/col pairs are single points,
    		 * and there is an implicit region between each of them, so a miss just means
    		 * that you aren't on the very start of a region.
    		 *
    		 * @param aNeedle The element you are looking for.
    		 * @param aHaystack The array that is being searched.
    		 * @param aCompare A function which takes the needle and an element in the
    		 *     array and returns -1, 0, or 1 depending on whether the needle is less
    		 *     than, equal to, or greater than the element, respectively.
    		 * @param aBias Either 'binarySearch.GREATEST_LOWER_BOUND' or
    		 *     'binarySearch.LEAST_UPPER_BOUND'. Specifies whether to return the
    		 *     closest element that is smaller than or greater than the one we are
    		 *     searching for, respectively, if the exact element cannot be found.
    		 *     Defaults to 'binarySearch.GREATEST_LOWER_BOUND'.
    		 */
    		exports.search = function search(aNeedle, aHaystack, aCompare, aBias) {
    		  if (aHaystack.length === 0) {
    		    return -1;
    		  }

    		  var index = recursiveSearch(-1, aHaystack.length, aNeedle, aHaystack,
    		                              aCompare, aBias || exports.GREATEST_LOWER_BOUND);
    		  if (index < 0) {
    		    return -1;
    		  }

    		  // We have found either the exact element, or the next-closest element than
    		  // the one we are searching for. However, there may be more than one such
    		  // element. Make sure we always return the smallest of these.
    		  while (index - 1 >= 0) {
    		    if (aCompare(aHaystack[index], aHaystack[index - 1], true) !== 0) {
    		      break;
    		    }
    		    --index;
    		  }

    		  return index;
    		};
    } (binarySearch));
    	return binarySearch;
    }

    var arraySet = {};

    /* -*- Mode: js; js-indent-level: 2; -*- */

    var hasRequiredArraySet;

    function requireArraySet () {
    	if (hasRequiredArraySet) return arraySet;
    	hasRequiredArraySet = 1;
    	/*
    	 * Copyright 2011 Mozilla Foundation and contributors
    	 * Licensed under the New BSD license. See LICENSE or:
    	 * http://opensource.org/licenses/BSD-3-Clause
    	 */

    	var util = requireUtil();
    	var has = Object.prototype.hasOwnProperty;

    	/**
    	 * A data structure which is a combination of an array and a set. Adding a new
    	 * member is O(1), testing for membership is O(1), and finding the index of an
    	 * element is O(1). Removing elements from the set is not supported. Only
    	 * strings are supported for membership.
    	 */
    	function ArraySet() {
    	  this._array = [];
    	  this._set = Object.create(null);
    	}

    	/**
    	 * Static method for creating ArraySet instances from an existing array.
    	 */
    	ArraySet.fromArray = function ArraySet_fromArray(aArray, aAllowDuplicates) {
    	  var set = new ArraySet();
    	  for (var i = 0, len = aArray.length; i < len; i++) {
    	    set.add(aArray[i], aAllowDuplicates);
    	  }
    	  return set;
    	};

    	/**
    	 * Return how many unique items are in this ArraySet. If duplicates have been
    	 * added, than those do not count towards the size.
    	 *
    	 * @returns Number
    	 */
    	ArraySet.prototype.size = function ArraySet_size() {
    	  return Object.getOwnPropertyNames(this._set).length;
    	};

    	/**
    	 * Add the given string to this set.
    	 *
    	 * @param String aStr
    	 */
    	ArraySet.prototype.add = function ArraySet_add(aStr, aAllowDuplicates) {
    	  var sStr = util.toSetString(aStr);
    	  var isDuplicate = has.call(this._set, sStr);
    	  var idx = this._array.length;
    	  if (!isDuplicate || aAllowDuplicates) {
    	    this._array.push(aStr);
    	  }
    	  if (!isDuplicate) {
    	    this._set[sStr] = idx;
    	  }
    	};

    	/**
    	 * Is the given string a member of this set?
    	 *
    	 * @param String aStr
    	 */
    	ArraySet.prototype.has = function ArraySet_has(aStr) {
    	  var sStr = util.toSetString(aStr);
    	  return has.call(this._set, sStr);
    	};

    	/**
    	 * What is the index of the given string in the array?
    	 *
    	 * @param String aStr
    	 */
    	ArraySet.prototype.indexOf = function ArraySet_indexOf(aStr) {
    	  var sStr = util.toSetString(aStr);
    	  if (has.call(this._set, sStr)) {
    	    return this._set[sStr];
    	  }
    	  throw new Error('"' + aStr + '" is not in the set.');
    	};

    	/**
    	 * What is the element at the given index?
    	 *
    	 * @param Number aIdx
    	 */
    	ArraySet.prototype.at = function ArraySet_at(aIdx) {
    	  if (aIdx >= 0 && aIdx < this._array.length) {
    	    return this._array[aIdx];
    	  }
    	  throw new Error('No element indexed by ' + aIdx);
    	};

    	/**
    	 * Returns the array representation of this set (which has the proper indices
    	 * indicated by indexOf). Note that this is a copy of the internal array used
    	 * for storing the members so that no one can mess with internal state.
    	 */
    	ArraySet.prototype.toArray = function ArraySet_toArray() {
    	  return this._array.slice();
    	};

    	arraySet.ArraySet = ArraySet;
    	return arraySet;
    }

    var base64Vlq = {};

    var base64 = {};

    /* -*- Mode: js; js-indent-level: 2; -*- */

    var hasRequiredBase64;

    function requireBase64 () {
    	if (hasRequiredBase64) return base64;
    	hasRequiredBase64 = 1;
    	/*
    	 * Copyright 2011 Mozilla Foundation and contributors
    	 * Licensed under the New BSD license. See LICENSE or:
    	 * http://opensource.org/licenses/BSD-3-Clause
    	 */

    	var intToCharMap = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'.split('');

    	/**
    	 * Encode an integer in the range of 0 to 63 to a single base 64 digit.
    	 */
    	base64.encode = function (number) {
    	  if (0 <= number && number < intToCharMap.length) {
    	    return intToCharMap[number];
    	  }
    	  throw new TypeError("Must be between 0 and 63: " + number);
    	};

    	/**
    	 * Decode a single base 64 character code digit to an integer. Returns -1 on
    	 * failure.
    	 */
    	base64.decode = function (charCode) {
    	  var bigA = 65;     // 'A'
    	  var bigZ = 90;     // 'Z'

    	  var littleA = 97;  // 'a'
    	  var littleZ = 122; // 'z'

    	  var zero = 48;     // '0'
    	  var nine = 57;     // '9'

    	  var plus = 43;     // '+'
    	  var slash = 47;    // '/'

    	  var littleOffset = 26;
    	  var numberOffset = 52;

    	  // 0 - 25: ABCDEFGHIJKLMNOPQRSTUVWXYZ
    	  if (bigA <= charCode && charCode <= bigZ) {
    	    return (charCode - bigA);
    	  }

    	  // 26 - 51: abcdefghijklmnopqrstuvwxyz
    	  if (littleA <= charCode && charCode <= littleZ) {
    	    return (charCode - littleA + littleOffset);
    	  }

    	  // 52 - 61: 0123456789
    	  if (zero <= charCode && charCode <= nine) {
    	    return (charCode - zero + numberOffset);
    	  }

    	  // 62: +
    	  if (charCode == plus) {
    	    return 62;
    	  }

    	  // 63: /
    	  if (charCode == slash) {
    	    return 63;
    	  }

    	  // Invalid base64 digit.
    	  return -1;
    	};
    	return base64;
    }

    /* -*- Mode: js; js-indent-level: 2; -*- */

    var hasRequiredBase64Vlq;

    function requireBase64Vlq () {
    	if (hasRequiredBase64Vlq) return base64Vlq;
    	hasRequiredBase64Vlq = 1;
    	/*
    	 * Copyright 2011 Mozilla Foundation and contributors
    	 * Licensed under the New BSD license. See LICENSE or:
    	 * http://opensource.org/licenses/BSD-3-Clause
    	 *
    	 * Based on the Base 64 VLQ implementation in Closure Compiler:
    	 * https://code.google.com/p/closure-compiler/source/browse/trunk/src/com/google/debugging/sourcemap/Base64VLQ.java
    	 *
    	 * Copyright 2011 The Closure Compiler Authors. All rights reserved.
    	 * Redistribution and use in source and binary forms, with or without
    	 * modification, are permitted provided that the following conditions are
    	 * met:
    	 *
    	 *  * Redistributions of source code must retain the above copyright
    	 *    notice, this list of conditions and the following disclaimer.
    	 *  * Redistributions in binary form must reproduce the above
    	 *    copyright notice, this list of conditions and the following
    	 *    disclaimer in the documentation and/or other materials provided
    	 *    with the distribution.
    	 *  * Neither the name of Google Inc. nor the names of its
    	 *    contributors may be used to endorse or promote products derived
    	 *    from this software without specific prior written permission.
    	 *
    	 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    	 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    	 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
    	 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
    	 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    	 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    	 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
    	 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    	 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
    	 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
    	 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
    	 */

    	var base64 = requireBase64();

    	// A single base 64 digit can contain 6 bits of data. For the base 64 variable
    	// length quantities we use in the source map spec, the first bit is the sign,
    	// the next four bits are the actual value, and the 6th bit is the
    	// continuation bit. The continuation bit tells us whether there are more
    	// digits in this value following this digit.
    	//
    	//   Continuation
    	//   |    Sign
    	//   |    |
    	//   V    V
    	//   101011

    	var VLQ_BASE_SHIFT = 5;

    	// binary: 100000
    	var VLQ_BASE = 1 << VLQ_BASE_SHIFT;

    	// binary: 011111
    	var VLQ_BASE_MASK = VLQ_BASE - 1;

    	// binary: 100000
    	var VLQ_CONTINUATION_BIT = VLQ_BASE;

    	/**
    	 * Converts from a two-complement value to a value where the sign bit is
    	 * placed in the least significant bit.  For example, as decimals:
    	 *   1 becomes 2 (10 binary), -1 becomes 3 (11 binary)
    	 *   2 becomes 4 (100 binary), -2 becomes 5 (101 binary)
    	 */
    	function toVLQSigned(aValue) {
    	  return aValue < 0
    	    ? ((-aValue) << 1) + 1
    	    : (aValue << 1) + 0;
    	}

    	/**
    	 * Converts to a two-complement value from a value where the sign bit is
    	 * placed in the least significant bit.  For example, as decimals:
    	 *   2 (10 binary) becomes 1, 3 (11 binary) becomes -1
    	 *   4 (100 binary) becomes 2, 5 (101 binary) becomes -2
    	 */
    	function fromVLQSigned(aValue) {
    	  var isNegative = (aValue & 1) === 1;
    	  var shifted = aValue >> 1;
    	  return isNegative
    	    ? -shifted
    	    : shifted;
    	}

    	/**
    	 * Returns the base 64 VLQ encoded value.
    	 */
    	base64Vlq.encode = function base64VLQ_encode(aValue) {
    	  var encoded = "";
    	  var digit;

    	  var vlq = toVLQSigned(aValue);

    	  do {
    	    digit = vlq & VLQ_BASE_MASK;
    	    vlq >>>= VLQ_BASE_SHIFT;
    	    if (vlq > 0) {
    	      // There are still more digits in this value, so we must make sure the
    	      // continuation bit is marked.
    	      digit |= VLQ_CONTINUATION_BIT;
    	    }
    	    encoded += base64.encode(digit);
    	  } while (vlq > 0);

    	  return encoded;
    	};

    	/**
    	 * Decodes the next base 64 VLQ value from the given string and returns the
    	 * value and the rest of the string via the out parameter.
    	 */
    	base64Vlq.decode = function base64VLQ_decode(aStr, aIndex, aOutParam) {
    	  var strLen = aStr.length;
    	  var result = 0;
    	  var shift = 0;
    	  var continuation, digit;

    	  do {
    	    if (aIndex >= strLen) {
    	      throw new Error("Expected more digits in base 64 VLQ value.");
    	    }

    	    digit = base64.decode(aStr.charCodeAt(aIndex++));
    	    if (digit === -1) {
    	      throw new Error("Invalid base64 digit: " + aStr.charAt(aIndex - 1));
    	    }

    	    continuation = !!(digit & VLQ_CONTINUATION_BIT);
    	    digit &= VLQ_BASE_MASK;
    	    result = result + (digit << shift);
    	    shift += VLQ_BASE_SHIFT;
    	  } while (continuation);

    	  aOutParam.value = fromVLQSigned(result);
    	  aOutParam.rest = aIndex;
    	};
    	return base64Vlq;
    }

    var quickSort = {};

    /* -*- Mode: js; js-indent-level: 2; -*- */

    var hasRequiredQuickSort;

    function requireQuickSort () {
    	if (hasRequiredQuickSort) return quickSort;
    	hasRequiredQuickSort = 1;
    	/*
    	 * Copyright 2011 Mozilla Foundation and contributors
    	 * Licensed under the New BSD license. See LICENSE or:
    	 * http://opensource.org/licenses/BSD-3-Clause
    	 */

    	// It turns out that some (most?) JavaScript engines don't self-host
    	// `Array.prototype.sort`. This makes sense because C++ will likely remain
    	// faster than JS when doing raw CPU-intensive sorting. However, when using a
    	// custom comparator function, calling back and forth between the VM's C++ and
    	// JIT'd JS is rather slow *and* loses JIT type information, resulting in
    	// worse generated code for the comparator function than would be optimal. In
    	// fact, when sorting with a comparator, these costs outweigh the benefits of
    	// sorting in C++. By using our own JS-implemented Quick Sort (below), we get
    	// a ~3500ms mean speed-up in `bench/bench.html`.

    	/**
    	 * Swap the elements indexed by `x` and `y` in the array `ary`.
    	 *
    	 * @param {Array} ary
    	 *        The array.
    	 * @param {Number} x
    	 *        The index of the first item.
    	 * @param {Number} y
    	 *        The index of the second item.
    	 */
    	function swap(ary, x, y) {
    	  var temp = ary[x];
    	  ary[x] = ary[y];
    	  ary[y] = temp;
    	}

    	/**
    	 * Returns a random integer within the range `low .. high` inclusive.
    	 *
    	 * @param {Number} low
    	 *        The lower bound on the range.
    	 * @param {Number} high
    	 *        The upper bound on the range.
    	 */
    	function randomIntInRange(low, high) {
    	  return Math.round(low + (Math.random() * (high - low)));
    	}

    	/**
    	 * The Quick Sort algorithm.
    	 *
    	 * @param {Array} ary
    	 *        An array to sort.
    	 * @param {function} comparator
    	 *        Function to use to compare two items.
    	 * @param {Number} p
    	 *        Start index of the array
    	 * @param {Number} r
    	 *        End index of the array
    	 */
    	function doQuickSort(ary, comparator, p, r) {
    	  // If our lower bound is less than our upper bound, we (1) partition the
    	  // array into two pieces and (2) recurse on each half. If it is not, this is
    	  // the empty array and our base case.

    	  if (p < r) {
    	    // (1) Partitioning.
    	    //
    	    // The partitioning chooses a pivot between `p` and `r` and moves all
    	    // elements that are less than or equal to the pivot to the before it, and
    	    // all the elements that are greater than it after it. The effect is that
    	    // once partition is done, the pivot is in the exact place it will be when
    	    // the array is put in sorted order, and it will not need to be moved
    	    // again. This runs in O(n) time.

    	    // Always choose a random pivot so that an input array which is reverse
    	    // sorted does not cause O(n^2) running time.
    	    var pivotIndex = randomIntInRange(p, r);
    	    var i = p - 1;

    	    swap(ary, pivotIndex, r);
    	    var pivot = ary[r];

    	    // Immediately after `j` is incremented in this loop, the following hold
    	    // true:
    	    //
    	    //   * Every element in `ary[p .. i]` is less than or equal to the pivot.
    	    //
    	    //   * Every element in `ary[i+1 .. j-1]` is greater than the pivot.
    	    for (var j = p; j < r; j++) {
    	      if (comparator(ary[j], pivot) <= 0) {
    	        i += 1;
    	        swap(ary, i, j);
    	      }
    	    }

    	    swap(ary, i + 1, j);
    	    var q = i + 1;

    	    // (2) Recurse on each half.

    	    doQuickSort(ary, comparator, p, q - 1);
    	    doQuickSort(ary, comparator, q + 1, r);
    	  }
    	}

    	/**
    	 * Sort the given array in-place with the given comparator function.
    	 *
    	 * @param {Array} ary
    	 *        An array to sort.
    	 * @param {function} comparator
    	 *        Function to use to compare two items.
    	 */
    	quickSort.quickSort = function (ary, comparator) {
    	  doQuickSort(ary, comparator, 0, ary.length - 1);
    	};
    	return quickSort;
    }

    /* -*- Mode: js; js-indent-level: 2; -*- */

    var hasRequiredSourceMapConsumer;

    function requireSourceMapConsumer () {
    	if (hasRequiredSourceMapConsumer) return sourceMapConsumer;
    	hasRequiredSourceMapConsumer = 1;
    	/*
    	 * Copyright 2011 Mozilla Foundation and contributors
    	 * Licensed under the New BSD license. See LICENSE or:
    	 * http://opensource.org/licenses/BSD-3-Clause
    	 */

    	var util = requireUtil();
    	var binarySearch = requireBinarySearch();
    	var ArraySet = requireArraySet().ArraySet;
    	var base64VLQ = requireBase64Vlq();
    	var quickSort = requireQuickSort().quickSort;

    	function SourceMapConsumer(aSourceMap) {
    	  var sourceMap = aSourceMap;
    	  if (typeof aSourceMap === 'string') {
    	    sourceMap = JSON.parse(aSourceMap.replace(/^\)\]\}'/, ''));
    	  }

    	  return sourceMap.sections != null
    	    ? new IndexedSourceMapConsumer(sourceMap)
    	    : new BasicSourceMapConsumer(sourceMap);
    	}

    	SourceMapConsumer.fromSourceMap = function(aSourceMap) {
    	  return BasicSourceMapConsumer.fromSourceMap(aSourceMap);
    	};

    	/**
    	 * The version of the source mapping spec that we are consuming.
    	 */
    	SourceMapConsumer.prototype._version = 3;

    	// `__generatedMappings` and `__originalMappings` are arrays that hold the
    	// parsed mapping coordinates from the source map's "mappings" attribute. They
    	// are lazily instantiated, accessed via the `_generatedMappings` and
    	// `_originalMappings` getters respectively, and we only parse the mappings
    	// and create these arrays once queried for a source location. We jump through
    	// these hoops because there can be many thousands of mappings, and parsing
    	// them is expensive, so we only want to do it if we must.
    	//
    	// Each object in the arrays is of the form:
    	//
    	//     {
    	//       generatedLine: The line number in the generated code,
    	//       generatedColumn: The column number in the generated code,
    	//       source: The path to the original source file that generated this
    	//               chunk of code,
    	//       originalLine: The line number in the original source that
    	//                     corresponds to this chunk of generated code,
    	//       originalColumn: The column number in the original source that
    	//                       corresponds to this chunk of generated code,
    	//       name: The name of the original symbol which generated this chunk of
    	//             code.
    	//     }
    	//
    	// All properties except for `generatedLine` and `generatedColumn` can be
    	// `null`.
    	//
    	// `_generatedMappings` is ordered by the generated positions.
    	//
    	// `_originalMappings` is ordered by the original positions.

    	SourceMapConsumer.prototype.__generatedMappings = null;
    	Object.defineProperty(SourceMapConsumer.prototype, '_generatedMappings', {
    	  get: function () {
    	    if (!this.__generatedMappings) {
    	      this._parseMappings(this._mappings, this.sourceRoot);
    	    }

    	    return this.__generatedMappings;
    	  }
    	});

    	SourceMapConsumer.prototype.__originalMappings = null;
    	Object.defineProperty(SourceMapConsumer.prototype, '_originalMappings', {
    	  get: function () {
    	    if (!this.__originalMappings) {
    	      this._parseMappings(this._mappings, this.sourceRoot);
    	    }

    	    return this.__originalMappings;
    	  }
    	});

    	SourceMapConsumer.prototype._charIsMappingSeparator =
    	  function SourceMapConsumer_charIsMappingSeparator(aStr, index) {
    	    var c = aStr.charAt(index);
    	    return c === ";" || c === ",";
    	  };

    	/**
    	 * Parse the mappings in a string in to a data structure which we can easily
    	 * query (the ordered arrays in the `this.__generatedMappings` and
    	 * `this.__originalMappings` properties).
    	 */
    	SourceMapConsumer.prototype._parseMappings =
    	  function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
    	    throw new Error("Subclasses must implement _parseMappings");
    	  };

    	SourceMapConsumer.GENERATED_ORDER = 1;
    	SourceMapConsumer.ORIGINAL_ORDER = 2;

    	SourceMapConsumer.GREATEST_LOWER_BOUND = 1;
    	SourceMapConsumer.LEAST_UPPER_BOUND = 2;

    	/**
    	 * Iterate over each mapping between an original source/line/column and a
    	 * generated line/column in this source map.
    	 *
    	 * @param Function aCallback
    	 *        The function that is called with each mapping.
    	 * @param Object aContext
    	 *        Optional. If specified, this object will be the value of `this` every
    	 *        time that `aCallback` is called.
    	 * @param aOrder
    	 *        Either `SourceMapConsumer.GENERATED_ORDER` or
    	 *        `SourceMapConsumer.ORIGINAL_ORDER`. Specifies whether you want to
    	 *        iterate over the mappings sorted by the generated file's line/column
    	 *        order or the original's source/line/column order, respectively. Defaults to
    	 *        `SourceMapConsumer.GENERATED_ORDER`.
    	 */
    	SourceMapConsumer.prototype.eachMapping =
    	  function SourceMapConsumer_eachMapping(aCallback, aContext, aOrder) {
    	    var context = aContext || null;
    	    var order = aOrder || SourceMapConsumer.GENERATED_ORDER;

    	    var mappings;
    	    switch (order) {
    	    case SourceMapConsumer.GENERATED_ORDER:
    	      mappings = this._generatedMappings;
    	      break;
    	    case SourceMapConsumer.ORIGINAL_ORDER:
    	      mappings = this._originalMappings;
    	      break;
    	    default:
    	      throw new Error("Unknown order of iteration.");
    	    }

    	    var sourceRoot = this.sourceRoot;
    	    mappings.map(function (mapping) {
    	      var source = mapping.source === null ? null : this._sources.at(mapping.source);
    	      if (source != null && sourceRoot != null) {
    	        source = util.join(sourceRoot, source);
    	      }
    	      return {
    	        source: source,
    	        generatedLine: mapping.generatedLine,
    	        generatedColumn: mapping.generatedColumn,
    	        originalLine: mapping.originalLine,
    	        originalColumn: mapping.originalColumn,
    	        name: mapping.name === null ? null : this._names.at(mapping.name)
    	      };
    	    }, this).forEach(aCallback, context);
    	  };

    	/**
    	 * Returns all generated line and column information for the original source,
    	 * line, and column provided. If no column is provided, returns all mappings
    	 * corresponding to a either the line we are searching for or the next
    	 * closest line that has any mappings. Otherwise, returns all mappings
    	 * corresponding to the given line and either the column we are searching for
    	 * or the next closest column that has any offsets.
    	 *
    	 * The only argument is an object with the following properties:
    	 *
    	 *   - source: The filename of the original source.
    	 *   - line: The line number in the original source.
    	 *   - column: Optional. the column number in the original source.
    	 *
    	 * and an array of objects is returned, each with the following properties:
    	 *
    	 *   - line: The line number in the generated source, or null.
    	 *   - column: The column number in the generated source, or null.
    	 */
    	SourceMapConsumer.prototype.allGeneratedPositionsFor =
    	  function SourceMapConsumer_allGeneratedPositionsFor(aArgs) {
    	    var line = util.getArg(aArgs, 'line');

    	    // When there is no exact match, BasicSourceMapConsumer.prototype._findMapping
    	    // returns the index of the closest mapping less than the needle. By
    	    // setting needle.originalColumn to 0, we thus find the last mapping for
    	    // the given line, provided such a mapping exists.
    	    var needle = {
    	      source: util.getArg(aArgs, 'source'),
    	      originalLine: line,
    	      originalColumn: util.getArg(aArgs, 'column', 0)
    	    };

    	    if (this.sourceRoot != null) {
    	      needle.source = util.relative(this.sourceRoot, needle.source);
    	    }
    	    if (!this._sources.has(needle.source)) {
    	      return [];
    	    }
    	    needle.source = this._sources.indexOf(needle.source);

    	    var mappings = [];

    	    var index = this._findMapping(needle,
    	                                  this._originalMappings,
    	                                  "originalLine",
    	                                  "originalColumn",
    	                                  util.compareByOriginalPositions,
    	                                  binarySearch.LEAST_UPPER_BOUND);
    	    if (index >= 0) {
    	      var mapping = this._originalMappings[index];

    	      if (aArgs.column === undefined) {
    	        var originalLine = mapping.originalLine;

    	        // Iterate until either we run out of mappings, or we run into
    	        // a mapping for a different line than the one we found. Since
    	        // mappings are sorted, this is guaranteed to find all mappings for
    	        // the line we found.
    	        while (mapping && mapping.originalLine === originalLine) {
    	          mappings.push({
    	            line: util.getArg(mapping, 'generatedLine', null),
    	            column: util.getArg(mapping, 'generatedColumn', null),
    	            lastColumn: util.getArg(mapping, 'lastGeneratedColumn', null)
    	          });

    	          mapping = this._originalMappings[++index];
    	        }
    	      } else {
    	        var originalColumn = mapping.originalColumn;

    	        // Iterate until either we run out of mappings, or we run into
    	        // a mapping for a different line than the one we were searching for.
    	        // Since mappings are sorted, this is guaranteed to find all mappings for
    	        // the line we are searching for.
    	        while (mapping &&
    	               mapping.originalLine === line &&
    	               mapping.originalColumn == originalColumn) {
    	          mappings.push({
    	            line: util.getArg(mapping, 'generatedLine', null),
    	            column: util.getArg(mapping, 'generatedColumn', null),
    	            lastColumn: util.getArg(mapping, 'lastGeneratedColumn', null)
    	          });

    	          mapping = this._originalMappings[++index];
    	        }
    	      }
    	    }

    	    return mappings;
    	  };

    	sourceMapConsumer.SourceMapConsumer = SourceMapConsumer;

    	/**
    	 * A BasicSourceMapConsumer instance represents a parsed source map which we can
    	 * query for information about the original file positions by giving it a file
    	 * position in the generated source.
    	 *
    	 * The only parameter is the raw source map (either as a JSON string, or
    	 * already parsed to an object). According to the spec, source maps have the
    	 * following attributes:
    	 *
    	 *   - version: Which version of the source map spec this map is following.
    	 *   - sources: An array of URLs to the original source files.
    	 *   - names: An array of identifiers which can be referrenced by individual mappings.
    	 *   - sourceRoot: Optional. The URL root from which all sources are relative.
    	 *   - sourcesContent: Optional. An array of contents of the original source files.
    	 *   - mappings: A string of base64 VLQs which contain the actual mappings.
    	 *   - file: Optional. The generated file this source map is associated with.
    	 *
    	 * Here is an example source map, taken from the source map spec[0]:
    	 *
    	 *     {
    	 *       version : 3,
    	 *       file: "out.js",
    	 *       sourceRoot : "",
    	 *       sources: ["foo.js", "bar.js"],
    	 *       names: ["src", "maps", "are", "fun"],
    	 *       mappings: "AA,AB;;ABCDE;"
    	 *     }
    	 *
    	 * [0]: https://docs.google.com/document/d/1U1RGAehQwRypUTovF1KRlpiOFze0b-_2gc6fAH0KY0k/edit?pli=1#
    	 */
    	function BasicSourceMapConsumer(aSourceMap) {
    	  var sourceMap = aSourceMap;
    	  if (typeof aSourceMap === 'string') {
    	    sourceMap = JSON.parse(aSourceMap.replace(/^\)\]\}'/, ''));
    	  }

    	  var version = util.getArg(sourceMap, 'version');
    	  var sources = util.getArg(sourceMap, 'sources');
    	  // Sass 3.3 leaves out the 'names' array, so we deviate from the spec (which
    	  // requires the array) to play nice here.
    	  var names = util.getArg(sourceMap, 'names', []);
    	  var sourceRoot = util.getArg(sourceMap, 'sourceRoot', null);
    	  var sourcesContent = util.getArg(sourceMap, 'sourcesContent', null);
    	  var mappings = util.getArg(sourceMap, 'mappings');
    	  var file = util.getArg(sourceMap, 'file', null);

    	  // Once again, Sass deviates from the spec and supplies the version as a
    	  // string rather than a number, so we use loose equality checking here.
    	  if (version != this._version) {
    	    throw new Error('Unsupported version: ' + version);
    	  }

    	  sources = sources
    	    .map(String)
    	    // Some source maps produce relative source paths like "./foo.js" instead of
    	    // "foo.js".  Normalize these first so that future comparisons will succeed.
    	    // See bugzil.la/1090768.
    	    .map(util.normalize)
    	    // Always ensure that absolute sources are internally stored relative to
    	    // the source root, if the source root is absolute. Not doing this would
    	    // be particularly problematic when the source root is a prefix of the
    	    // source (valid, but why??). See github issue #199 and bugzil.la/1188982.
    	    .map(function (source) {
    	      return sourceRoot && util.isAbsolute(sourceRoot) && util.isAbsolute(source)
    	        ? util.relative(sourceRoot, source)
    	        : source;
    	    });

    	  // Pass `true` below to allow duplicate names and sources. While source maps
    	  // are intended to be compressed and deduplicated, the TypeScript compiler
    	  // sometimes generates source maps with duplicates in them. See Github issue
    	  // #72 and bugzil.la/889492.
    	  this._names = ArraySet.fromArray(names.map(String), true);
    	  this._sources = ArraySet.fromArray(sources, true);

    	  this.sourceRoot = sourceRoot;
    	  this.sourcesContent = sourcesContent;
    	  this._mappings = mappings;
    	  this.file = file;
    	}

    	BasicSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
    	BasicSourceMapConsumer.prototype.consumer = SourceMapConsumer;

    	/**
    	 * Create a BasicSourceMapConsumer from a SourceMapGenerator.
    	 *
    	 * @param SourceMapGenerator aSourceMap
    	 *        The source map that will be consumed.
    	 * @returns BasicSourceMapConsumer
    	 */
    	BasicSourceMapConsumer.fromSourceMap =
    	  function SourceMapConsumer_fromSourceMap(aSourceMap) {
    	    var smc = Object.create(BasicSourceMapConsumer.prototype);

    	    var names = smc._names = ArraySet.fromArray(aSourceMap._names.toArray(), true);
    	    var sources = smc._sources = ArraySet.fromArray(aSourceMap._sources.toArray(), true);
    	    smc.sourceRoot = aSourceMap._sourceRoot;
    	    smc.sourcesContent = aSourceMap._generateSourcesContent(smc._sources.toArray(),
    	                                                            smc.sourceRoot);
    	    smc.file = aSourceMap._file;

    	    // Because we are modifying the entries (by converting string sources and
    	    // names to indices into the sources and names ArraySets), we have to make
    	    // a copy of the entry or else bad things happen. Shared mutable state
    	    // strikes again! See github issue #191.

    	    var generatedMappings = aSourceMap._mappings.toArray().slice();
    	    var destGeneratedMappings = smc.__generatedMappings = [];
    	    var destOriginalMappings = smc.__originalMappings = [];

    	    for (var i = 0, length = generatedMappings.length; i < length; i++) {
    	      var srcMapping = generatedMappings[i];
    	      var destMapping = new Mapping;
    	      destMapping.generatedLine = srcMapping.generatedLine;
    	      destMapping.generatedColumn = srcMapping.generatedColumn;

    	      if (srcMapping.source) {
    	        destMapping.source = sources.indexOf(srcMapping.source);
    	        destMapping.originalLine = srcMapping.originalLine;
    	        destMapping.originalColumn = srcMapping.originalColumn;

    	        if (srcMapping.name) {
    	          destMapping.name = names.indexOf(srcMapping.name);
    	        }

    	        destOriginalMappings.push(destMapping);
    	      }

    	      destGeneratedMappings.push(destMapping);
    	    }

    	    quickSort(smc.__originalMappings, util.compareByOriginalPositions);

    	    return smc;
    	  };

    	/**
    	 * The version of the source mapping spec that we are consuming.
    	 */
    	BasicSourceMapConsumer.prototype._version = 3;

    	/**
    	 * The list of original sources.
    	 */
    	Object.defineProperty(BasicSourceMapConsumer.prototype, 'sources', {
    	  get: function () {
    	    return this._sources.toArray().map(function (s) {
    	      return this.sourceRoot != null ? util.join(this.sourceRoot, s) : s;
    	    }, this);
    	  }
    	});

    	/**
    	 * Provide the JIT with a nice shape / hidden class.
    	 */
    	function Mapping() {
    	  this.generatedLine = 0;
    	  this.generatedColumn = 0;
    	  this.source = null;
    	  this.originalLine = null;
    	  this.originalColumn = null;
    	  this.name = null;
    	}

    	/**
    	 * Parse the mappings in a string in to a data structure which we can easily
    	 * query (the ordered arrays in the `this.__generatedMappings` and
    	 * `this.__originalMappings` properties).
    	 */
    	BasicSourceMapConsumer.prototype._parseMappings =
    	  function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
    	    var generatedLine = 1;
    	    var previousGeneratedColumn = 0;
    	    var previousOriginalLine = 0;
    	    var previousOriginalColumn = 0;
    	    var previousSource = 0;
    	    var previousName = 0;
    	    var length = aStr.length;
    	    var index = 0;
    	    var cachedSegments = {};
    	    var temp = {};
    	    var originalMappings = [];
    	    var generatedMappings = [];
    	    var mapping, str, segment, end, value;

    	    while (index < length) {
    	      if (aStr.charAt(index) === ';') {
    	        generatedLine++;
    	        index++;
    	        previousGeneratedColumn = 0;
    	      }
    	      else if (aStr.charAt(index) === ',') {
    	        index++;
    	      }
    	      else {
    	        mapping = new Mapping();
    	        mapping.generatedLine = generatedLine;

    	        // Because each offset is encoded relative to the previous one,
    	        // many segments often have the same encoding. We can exploit this
    	        // fact by caching the parsed variable length fields of each segment,
    	        // allowing us to avoid a second parse if we encounter the same
    	        // segment again.
    	        for (end = index; end < length; end++) {
    	          if (this._charIsMappingSeparator(aStr, end)) {
    	            break;
    	          }
    	        }
    	        str = aStr.slice(index, end);

    	        segment = cachedSegments[str];
    	        if (segment) {
    	          index += str.length;
    	        } else {
    	          segment = [];
    	          while (index < end) {
    	            base64VLQ.decode(aStr, index, temp);
    	            value = temp.value;
    	            index = temp.rest;
    	            segment.push(value);
    	          }

    	          if (segment.length === 2) {
    	            throw new Error('Found a source, but no line and column');
    	          }

    	          if (segment.length === 3) {
    	            throw new Error('Found a source and line, but no column');
    	          }

    	          cachedSegments[str] = segment;
    	        }

    	        // Generated column.
    	        mapping.generatedColumn = previousGeneratedColumn + segment[0];
    	        previousGeneratedColumn = mapping.generatedColumn;

    	        if (segment.length > 1) {
    	          // Original source.
    	          mapping.source = previousSource + segment[1];
    	          previousSource += segment[1];

    	          // Original line.
    	          mapping.originalLine = previousOriginalLine + segment[2];
    	          previousOriginalLine = mapping.originalLine;
    	          // Lines are stored 0-based
    	          mapping.originalLine += 1;

    	          // Original column.
    	          mapping.originalColumn = previousOriginalColumn + segment[3];
    	          previousOriginalColumn = mapping.originalColumn;

    	          if (segment.length > 4) {
    	            // Original name.
    	            mapping.name = previousName + segment[4];
    	            previousName += segment[4];
    	          }
    	        }

    	        generatedMappings.push(mapping);
    	        if (typeof mapping.originalLine === 'number') {
    	          originalMappings.push(mapping);
    	        }
    	      }
    	    }

    	    quickSort(generatedMappings, util.compareByGeneratedPositionsDeflated);
    	    this.__generatedMappings = generatedMappings;

    	    quickSort(originalMappings, util.compareByOriginalPositions);
    	    this.__originalMappings = originalMappings;
    	  };

    	/**
    	 * Find the mapping that best matches the hypothetical "needle" mapping that
    	 * we are searching for in the given "haystack" of mappings.
    	 */
    	BasicSourceMapConsumer.prototype._findMapping =
    	  function SourceMapConsumer_findMapping(aNeedle, aMappings, aLineName,
    	                                         aColumnName, aComparator, aBias) {
    	    // To return the position we are searching for, we must first find the
    	    // mapping for the given position and then return the opposite position it
    	    // points to. Because the mappings are sorted, we can use binary search to
    	    // find the best mapping.

    	    if (aNeedle[aLineName] <= 0) {
    	      throw new TypeError('Line must be greater than or equal to 1, got '
    	                          + aNeedle[aLineName]);
    	    }
    	    if (aNeedle[aColumnName] < 0) {
    	      throw new TypeError('Column must be greater than or equal to 0, got '
    	                          + aNeedle[aColumnName]);
    	    }

    	    return binarySearch.search(aNeedle, aMappings, aComparator, aBias);
    	  };

    	/**
    	 * Compute the last column for each generated mapping. The last column is
    	 * inclusive.
    	 */
    	BasicSourceMapConsumer.prototype.computeColumnSpans =
    	  function SourceMapConsumer_computeColumnSpans() {
    	    for (var index = 0; index < this._generatedMappings.length; ++index) {
    	      var mapping = this._generatedMappings[index];

    	      // Mappings do not contain a field for the last generated columnt. We
    	      // can come up with an optimistic estimate, however, by assuming that
    	      // mappings are contiguous (i.e. given two consecutive mappings, the
    	      // first mapping ends where the second one starts).
    	      if (index + 1 < this._generatedMappings.length) {
    	        var nextMapping = this._generatedMappings[index + 1];

    	        if (mapping.generatedLine === nextMapping.generatedLine) {
    	          mapping.lastGeneratedColumn = nextMapping.generatedColumn - 1;
    	          continue;
    	        }
    	      }

    	      // The last mapping for each line spans the entire line.
    	      mapping.lastGeneratedColumn = Infinity;
    	    }
    	  };

    	/**
    	 * Returns the original source, line, and column information for the generated
    	 * source's line and column positions provided. The only argument is an object
    	 * with the following properties:
    	 *
    	 *   - line: The line number in the generated source.
    	 *   - column: The column number in the generated source.
    	 *   - bias: Either 'SourceMapConsumer.GREATEST_LOWER_BOUND' or
    	 *     'SourceMapConsumer.LEAST_UPPER_BOUND'. Specifies whether to return the
    	 *     closest element that is smaller than or greater than the one we are
    	 *     searching for, respectively, if the exact element cannot be found.
    	 *     Defaults to 'SourceMapConsumer.GREATEST_LOWER_BOUND'.
    	 *
    	 * and an object is returned with the following properties:
    	 *
    	 *   - source: The original source file, or null.
    	 *   - line: The line number in the original source, or null.
    	 *   - column: The column number in the original source, or null.
    	 *   - name: The original identifier, or null.
    	 */
    	BasicSourceMapConsumer.prototype.originalPositionFor =
    	  function SourceMapConsumer_originalPositionFor(aArgs) {
    	    var needle = {
    	      generatedLine: util.getArg(aArgs, 'line'),
    	      generatedColumn: util.getArg(aArgs, 'column')
    	    };

    	    var index = this._findMapping(
    	      needle,
    	      this._generatedMappings,
    	      "generatedLine",
    	      "generatedColumn",
    	      util.compareByGeneratedPositionsDeflated,
    	      util.getArg(aArgs, 'bias', SourceMapConsumer.GREATEST_LOWER_BOUND)
    	    );

    	    if (index >= 0) {
    	      var mapping = this._generatedMappings[index];

    	      if (mapping.generatedLine === needle.generatedLine) {
    	        var source = util.getArg(mapping, 'source', null);
    	        if (source !== null) {
    	          source = this._sources.at(source);
    	          if (this.sourceRoot != null) {
    	            source = util.join(this.sourceRoot, source);
    	          }
    	        }
    	        var name = util.getArg(mapping, 'name', null);
    	        if (name !== null) {
    	          name = this._names.at(name);
    	        }
    	        return {
    	          source: source,
    	          line: util.getArg(mapping, 'originalLine', null),
    	          column: util.getArg(mapping, 'originalColumn', null),
    	          name: name
    	        };
    	      }
    	    }

    	    return {
    	      source: null,
    	      line: null,
    	      column: null,
    	      name: null
    	    };
    	  };

    	/**
    	 * Return true if we have the source content for every source in the source
    	 * map, false otherwise.
    	 */
    	BasicSourceMapConsumer.prototype.hasContentsOfAllSources =
    	  function BasicSourceMapConsumer_hasContentsOfAllSources() {
    	    if (!this.sourcesContent) {
    	      return false;
    	    }
    	    return this.sourcesContent.length >= this._sources.size() &&
    	      !this.sourcesContent.some(function (sc) { return sc == null; });
    	  };

    	/**
    	 * Returns the original source content. The only argument is the url of the
    	 * original source file. Returns null if no original source content is
    	 * available.
    	 */
    	BasicSourceMapConsumer.prototype.sourceContentFor =
    	  function SourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
    	    if (!this.sourcesContent) {
    	      return null;
    	    }

    	    if (this.sourceRoot != null) {
    	      aSource = util.relative(this.sourceRoot, aSource);
    	    }

    	    if (this._sources.has(aSource)) {
    	      return this.sourcesContent[this._sources.indexOf(aSource)];
    	    }

    	    var url;
    	    if (this.sourceRoot != null
    	        && (url = util.urlParse(this.sourceRoot))) {
    	      // XXX: file:// URIs and absolute paths lead to unexpected behavior for
    	      // many users. We can help them out when they expect file:// URIs to
    	      // behave like it would if they were running a local HTTP server. See
    	      // https://bugzilla.mozilla.org/show_bug.cgi?id=885597.
    	      var fileUriAbsPath = aSource.replace(/^file:\/\//, "");
    	      if (url.scheme == "file"
    	          && this._sources.has(fileUriAbsPath)) {
    	        return this.sourcesContent[this._sources.indexOf(fileUriAbsPath)]
    	      }

    	      if ((!url.path || url.path == "/")
    	          && this._sources.has("/" + aSource)) {
    	        return this.sourcesContent[this._sources.indexOf("/" + aSource)];
    	      }
    	    }

    	    // This function is used recursively from
    	    // IndexedSourceMapConsumer.prototype.sourceContentFor. In that case, we
    	    // don't want to throw if we can't find the source - we just want to
    	    // return null, so we provide a flag to exit gracefully.
    	    if (nullOnMissing) {
    	      return null;
    	    }
    	    else {
    	      throw new Error('"' + aSource + '" is not in the SourceMap.');
    	    }
    	  };

    	/**
    	 * Returns the generated line and column information for the original source,
    	 * line, and column positions provided. The only argument is an object with
    	 * the following properties:
    	 *
    	 *   - source: The filename of the original source.
    	 *   - line: The line number in the original source.
    	 *   - column: The column number in the original source.
    	 *   - bias: Either 'SourceMapConsumer.GREATEST_LOWER_BOUND' or
    	 *     'SourceMapConsumer.LEAST_UPPER_BOUND'. Specifies whether to return the
    	 *     closest element that is smaller than or greater than the one we are
    	 *     searching for, respectively, if the exact element cannot be found.
    	 *     Defaults to 'SourceMapConsumer.GREATEST_LOWER_BOUND'.
    	 *
    	 * and an object is returned with the following properties:
    	 *
    	 *   - line: The line number in the generated source, or null.
    	 *   - column: The column number in the generated source, or null.
    	 */
    	BasicSourceMapConsumer.prototype.generatedPositionFor =
    	  function SourceMapConsumer_generatedPositionFor(aArgs) {
    	    var source = util.getArg(aArgs, 'source');
    	    if (this.sourceRoot != null) {
    	      source = util.relative(this.sourceRoot, source);
    	    }
    	    if (!this._sources.has(source)) {
    	      return {
    	        line: null,
    	        column: null,
    	        lastColumn: null
    	      };
    	    }
    	    source = this._sources.indexOf(source);

    	    var needle = {
    	      source: source,
    	      originalLine: util.getArg(aArgs, 'line'),
    	      originalColumn: util.getArg(aArgs, 'column')
    	    };

    	    var index = this._findMapping(
    	      needle,
    	      this._originalMappings,
    	      "originalLine",
    	      "originalColumn",
    	      util.compareByOriginalPositions,
    	      util.getArg(aArgs, 'bias', SourceMapConsumer.GREATEST_LOWER_BOUND)
    	    );

    	    if (index >= 0) {
    	      var mapping = this._originalMappings[index];

    	      if (mapping.source === needle.source) {
    	        return {
    	          line: util.getArg(mapping, 'generatedLine', null),
    	          column: util.getArg(mapping, 'generatedColumn', null),
    	          lastColumn: util.getArg(mapping, 'lastGeneratedColumn', null)
    	        };
    	      }
    	    }

    	    return {
    	      line: null,
    	      column: null,
    	      lastColumn: null
    	    };
    	  };

    	sourceMapConsumer.BasicSourceMapConsumer = BasicSourceMapConsumer;

    	/**
    	 * An IndexedSourceMapConsumer instance represents a parsed source map which
    	 * we can query for information. It differs from BasicSourceMapConsumer in
    	 * that it takes "indexed" source maps (i.e. ones with a "sections" field) as
    	 * input.
    	 *
    	 * The only parameter is a raw source map (either as a JSON string, or already
    	 * parsed to an object). According to the spec for indexed source maps, they
    	 * have the following attributes:
    	 *
    	 *   - version: Which version of the source map spec this map is following.
    	 *   - file: Optional. The generated file this source map is associated with.
    	 *   - sections: A list of section definitions.
    	 *
    	 * Each value under the "sections" field has two fields:
    	 *   - offset: The offset into the original specified at which this section
    	 *       begins to apply, defined as an object with a "line" and "column"
    	 *       field.
    	 *   - map: A source map definition. This source map could also be indexed,
    	 *       but doesn't have to be.
    	 *
    	 * Instead of the "map" field, it's also possible to have a "url" field
    	 * specifying a URL to retrieve a source map from, but that's currently
    	 * unsupported.
    	 *
    	 * Here's an example source map, taken from the source map spec[0], but
    	 * modified to omit a section which uses the "url" field.
    	 *
    	 *  {
    	 *    version : 3,
    	 *    file: "app.js",
    	 *    sections: [{
    	 *      offset: {line:100, column:10},
    	 *      map: {
    	 *        version : 3,
    	 *        file: "section.js",
    	 *        sources: ["foo.js", "bar.js"],
    	 *        names: ["src", "maps", "are", "fun"],
    	 *        mappings: "AAAA,E;;ABCDE;"
    	 *      }
    	 *    }],
    	 *  }
    	 *
    	 * [0]: https://docs.google.com/document/d/1U1RGAehQwRypUTovF1KRlpiOFze0b-_2gc6fAH0KY0k/edit#heading=h.535es3xeprgt
    	 */
    	function IndexedSourceMapConsumer(aSourceMap) {
    	  var sourceMap = aSourceMap;
    	  if (typeof aSourceMap === 'string') {
    	    sourceMap = JSON.parse(aSourceMap.replace(/^\)\]\}'/, ''));
    	  }

    	  var version = util.getArg(sourceMap, 'version');
    	  var sections = util.getArg(sourceMap, 'sections');

    	  if (version != this._version) {
    	    throw new Error('Unsupported version: ' + version);
    	  }

    	  this._sources = new ArraySet();
    	  this._names = new ArraySet();

    	  var lastOffset = {
    	    line: -1,
    	    column: 0
    	  };
    	  this._sections = sections.map(function (s) {
    	    if (s.url) {
    	      // The url field will require support for asynchronicity.
    	      // See https://github.com/mozilla/source-map/issues/16
    	      throw new Error('Support for url field in sections not implemented.');
    	    }
    	    var offset = util.getArg(s, 'offset');
    	    var offsetLine = util.getArg(offset, 'line');
    	    var offsetColumn = util.getArg(offset, 'column');

    	    if (offsetLine < lastOffset.line ||
    	        (offsetLine === lastOffset.line && offsetColumn < lastOffset.column)) {
    	      throw new Error('Section offsets must be ordered and non-overlapping.');
    	    }
    	    lastOffset = offset;

    	    return {
    	      generatedOffset: {
    	        // The offset fields are 0-based, but we use 1-based indices when
    	        // encoding/decoding from VLQ.
    	        generatedLine: offsetLine + 1,
    	        generatedColumn: offsetColumn + 1
    	      },
    	      consumer: new SourceMapConsumer(util.getArg(s, 'map'))
    	    }
    	  });
    	}

    	IndexedSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
    	IndexedSourceMapConsumer.prototype.constructor = SourceMapConsumer;

    	/**
    	 * The version of the source mapping spec that we are consuming.
    	 */
    	IndexedSourceMapConsumer.prototype._version = 3;

    	/**
    	 * The list of original sources.
    	 */
    	Object.defineProperty(IndexedSourceMapConsumer.prototype, 'sources', {
    	  get: function () {
    	    var sources = [];
    	    for (var i = 0; i < this._sections.length; i++) {
    	      for (var j = 0; j < this._sections[i].consumer.sources.length; j++) {
    	        sources.push(this._sections[i].consumer.sources[j]);
    	      }
    	    }
    	    return sources;
    	  }
    	});

    	/**
    	 * Returns the original source, line, and column information for the generated
    	 * source's line and column positions provided. The only argument is an object
    	 * with the following properties:
    	 *
    	 *   - line: The line number in the generated source.
    	 *   - column: The column number in the generated source.
    	 *
    	 * and an object is returned with the following properties:
    	 *
    	 *   - source: The original source file, or null.
    	 *   - line: The line number in the original source, or null.
    	 *   - column: The column number in the original source, or null.
    	 *   - name: The original identifier, or null.
    	 */
    	IndexedSourceMapConsumer.prototype.originalPositionFor =
    	  function IndexedSourceMapConsumer_originalPositionFor(aArgs) {
    	    var needle = {
    	      generatedLine: util.getArg(aArgs, 'line'),
    	      generatedColumn: util.getArg(aArgs, 'column')
    	    };

    	    // Find the section containing the generated position we're trying to map
    	    // to an original position.
    	    var sectionIndex = binarySearch.search(needle, this._sections,
    	      function(needle, section) {
    	        var cmp = needle.generatedLine - section.generatedOffset.generatedLine;
    	        if (cmp) {
    	          return cmp;
    	        }

    	        return (needle.generatedColumn -
    	                section.generatedOffset.generatedColumn);
    	      });
    	    var section = this._sections[sectionIndex];

    	    if (!section) {
    	      return {
    	        source: null,
    	        line: null,
    	        column: null,
    	        name: null
    	      };
    	    }

    	    return section.consumer.originalPositionFor({
    	      line: needle.generatedLine -
    	        (section.generatedOffset.generatedLine - 1),
    	      column: needle.generatedColumn -
    	        (section.generatedOffset.generatedLine === needle.generatedLine
    	         ? section.generatedOffset.generatedColumn - 1
    	         : 0),
    	      bias: aArgs.bias
    	    });
    	  };

    	/**
    	 * Return true if we have the source content for every source in the source
    	 * map, false otherwise.
    	 */
    	IndexedSourceMapConsumer.prototype.hasContentsOfAllSources =
    	  function IndexedSourceMapConsumer_hasContentsOfAllSources() {
    	    return this._sections.every(function (s) {
    	      return s.consumer.hasContentsOfAllSources();
    	    });
    	  };

    	/**
    	 * Returns the original source content. The only argument is the url of the
    	 * original source file. Returns null if no original source content is
    	 * available.
    	 */
    	IndexedSourceMapConsumer.prototype.sourceContentFor =
    	  function IndexedSourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
    	    for (var i = 0; i < this._sections.length; i++) {
    	      var section = this._sections[i];

    	      var content = section.consumer.sourceContentFor(aSource, true);
    	      if (content) {
    	        return content;
    	      }
    	    }
    	    if (nullOnMissing) {
    	      return null;
    	    }
    	    else {
    	      throw new Error('"' + aSource + '" is not in the SourceMap.');
    	    }
    	  };

    	/**
    	 * Returns the generated line and column information for the original source,
    	 * line, and column positions provided. The only argument is an object with
    	 * the following properties:
    	 *
    	 *   - source: The filename of the original source.
    	 *   - line: The line number in the original source.
    	 *   - column: The column number in the original source.
    	 *
    	 * and an object is returned with the following properties:
    	 *
    	 *   - line: The line number in the generated source, or null.
    	 *   - column: The column number in the generated source, or null.
    	 */
    	IndexedSourceMapConsumer.prototype.generatedPositionFor =
    	  function IndexedSourceMapConsumer_generatedPositionFor(aArgs) {
    	    for (var i = 0; i < this._sections.length; i++) {
    	      var section = this._sections[i];

    	      // Only consider this section if the requested source is in the list of
    	      // sources of the consumer.
    	      if (section.consumer.sources.indexOf(util.getArg(aArgs, 'source')) === -1) {
    	        continue;
    	      }
    	      var generatedPosition = section.consumer.generatedPositionFor(aArgs);
    	      if (generatedPosition) {
    	        var ret = {
    	          line: generatedPosition.line +
    	            (section.generatedOffset.generatedLine - 1),
    	          column: generatedPosition.column +
    	            (section.generatedOffset.generatedLine === generatedPosition.line
    	             ? section.generatedOffset.generatedColumn - 1
    	             : 0)
    	        };
    	        return ret;
    	      }
    	    }

    	    return {
    	      line: null,
    	      column: null
    	    };
    	  };

    	/**
    	 * Parse the mappings in a string in to a data structure which we can easily
    	 * query (the ordered arrays in the `this.__generatedMappings` and
    	 * `this.__originalMappings` properties).
    	 */
    	IndexedSourceMapConsumer.prototype._parseMappings =
    	  function IndexedSourceMapConsumer_parseMappings(aStr, aSourceRoot) {
    	    this.__generatedMappings = [];
    	    this.__originalMappings = [];
    	    for (var i = 0; i < this._sections.length; i++) {
    	      var section = this._sections[i];
    	      var sectionMappings = section.consumer._generatedMappings;
    	      for (var j = 0; j < sectionMappings.length; j++) {
    	        var mapping = sectionMappings[j];

    	        var source = section.consumer._sources.at(mapping.source);
    	        if (section.consumer.sourceRoot !== null) {
    	          source = util.join(section.consumer.sourceRoot, source);
    	        }
    	        this._sources.add(source);
    	        source = this._sources.indexOf(source);

    	        var name = section.consumer._names.at(mapping.name);
    	        this._names.add(name);
    	        name = this._names.indexOf(name);

    	        // The mappings coming from the consumer for the section have
    	        // generated positions relative to the start of the section, so we
    	        // need to offset them to be relative to the start of the concatenated
    	        // generated file.
    	        var adjustedMapping = {
    	          source: source,
    	          generatedLine: mapping.generatedLine +
    	            (section.generatedOffset.generatedLine - 1),
    	          generatedColumn: mapping.generatedColumn +
    	            (section.generatedOffset.generatedLine === mapping.generatedLine
    	            ? section.generatedOffset.generatedColumn - 1
    	            : 0),
    	          originalLine: mapping.originalLine,
    	          originalColumn: mapping.originalColumn,
    	          name: name
    	        };

    	        this.__generatedMappings.push(adjustedMapping);
    	        if (typeof adjustedMapping.originalLine === 'number') {
    	          this.__originalMappings.push(adjustedMapping);
    	        }
    	      }
    	    }

    	    quickSort(this.__generatedMappings, util.compareByGeneratedPositionsDeflated);
    	    quickSort(this.__originalMappings, util.compareByOriginalPositions);
    	  };

    	sourceMapConsumer.IndexedSourceMapConsumer = IndexedSourceMapConsumer;
    	return sourceMapConsumer;
    }

    var hasRequiredStacktraceGps;

    function requireStacktraceGps () {
    	if (hasRequiredStacktraceGps) return stacktraceGpsExports;
    	hasRequiredStacktraceGps = 1;
    	(function (module, exports) {
    		(function(root, factory) {
    		    // Universal Module Definition (UMD) to support AMD, CommonJS/Node.js, Rhino, and browsers.

    		    /* istanbul ignore next */
    		    {
    		        module.exports = factory(requireSourceMapConsumer(), requireStackframe$1());
    		    }
    		}(commonjsGlobal, function(SourceMap, StackFrame) {

    		    /**
    		     * Make a X-Domain request to url and callback.
    		     *
    		     * @param {String} url
    		     * @returns {Promise} with response text if fulfilled
    		     */
    		    function _xdr(url) {
    		        return new Promise(function(resolve, reject) {
    		            var req = new XMLHttpRequest();
    		            req.open('get', url);
    		            req.onerror = reject;
    		            req.onreadystatechange = function onreadystatechange() {
    		                if (req.readyState === 4) {
    		                    if (req.status >= 200 && req.status < 300) {
    		                        resolve(req.responseText);
    		                    } else {
    		                        reject(new Error('HTTP status: ' + req.status + ' retrieving ' + url));
    		                    }
    		                }
    		            };
    		            req.send();
    		        });

    		    }

    		    /**
    		     * Convert a Base64-encoded string into its original representation.
    		     * Used for inline sourcemaps.
    		     *
    		     * @param {String} b64str Base-64 encoded string
    		     * @returns {String} original representation of the base64-encoded string.
    		     */
    		    function _atob(b64str) {
    		        if (typeof window !== 'undefined' && window.atob) {
    		            return window.atob(b64str);
    		        } else {
    		            throw new Error('You must supply a polyfill for window.atob in this environment');
    		        }
    		    }

    		    function _parseJson(string) {
    		        if (typeof JSON !== 'undefined' && JSON.parse) {
    		            return JSON.parse(string);
    		        } else {
    		            throw new Error('You must supply a polyfill for JSON.parse in this environment');
    		        }
    		    }

    		    function _findFunctionName(source, lineNumber/*, columnNumber*/) {
    		        // function {name}({args}) m[1]=name m[2]=args
    		        var reFunctionDeclaration = /function\s+([^(]*?)\s*\(([^)]*)\)/;
    		        // {name} = function ({args}) TODO args capture
    		        var reFunctionExpression = /['"]?([$_A-Za-z][$_A-Za-z0-9]*)['"]?\s*[:=]\s*function\b/;
    		        // {name} = eval()
    		        var reFunctionEvaluation = /['"]?([$_A-Za-z][$_A-Za-z0-9]*)['"]?\s*[:=]\s*(?:eval|new Function)\b/;
    		        var lines = source.split('\n');

    		        // Walk backwards in the source lines until we find the line which matches one of the patterns above
    		        var code = '';
    		        var maxLines = Math.min(lineNumber, 20);
    		        var m;
    		        for (var i = 0; i < maxLines; ++i) {
    		            // lineNo is 1-based, source[] is 0-based
    		            var line = lines[lineNumber - i - 1];
    		            var commentPos = line.indexOf('//');
    		            if (commentPos >= 0) {
    		                line = line.substr(0, commentPos);
    		            }

    		            if (line) {
    		                code = line + code;
    		                m = reFunctionExpression.exec(code);
    		                if (m && m[1]) {
    		                    return m[1];
    		                }
    		                m = reFunctionDeclaration.exec(code);
    		                if (m && m[1]) {
    		                    return m[1];
    		                }
    		                m = reFunctionEvaluation.exec(code);
    		                if (m && m[1]) {
    		                    return m[1];
    		                }
    		            }
    		        }
    		        return undefined;
    		    }

    		    function _ensureSupportedEnvironment() {
    		        if (typeof Object.defineProperty !== 'function' || typeof Object.create !== 'function') {
    		            throw new Error('Unable to consume source maps in older browsers');
    		        }
    		    }

    		    function _ensureStackFrameIsLegit(stackframe) {
    		        if (typeof stackframe !== 'object') {
    		            throw new TypeError('Given StackFrame is not an object');
    		        } else if (typeof stackframe.fileName !== 'string') {
    		            throw new TypeError('Given file name is not a String');
    		        } else if (typeof stackframe.lineNumber !== 'number' ||
    		            stackframe.lineNumber % 1 !== 0 ||
    		            stackframe.lineNumber < 1) {
    		            throw new TypeError('Given line number must be a positive integer');
    		        } else if (typeof stackframe.columnNumber !== 'number' ||
    		            stackframe.columnNumber % 1 !== 0 ||
    		            stackframe.columnNumber < 0) {
    		            throw new TypeError('Given column number must be a non-negative integer');
    		        }
    		        return true;
    		    }

    		    function _findSourceMappingURL(source) {
    		        var m = /\/\/[#@] ?sourceMappingURL=([^\s'"]+)\s*$/.exec(source);
    		        if (m && m[1]) {
    		            return m[1];
    		        } else {
    		            throw new Error('sourceMappingURL not found');
    		        }
    		    }

    		    function _extractLocationInfoFromSourceMap(stackframe, rawSourceMap, sourceCache) {
    		        return new Promise(function(resolve, reject) {
    		            var mapConsumer = new SourceMap.SourceMapConsumer(rawSourceMap);

    		            var loc = mapConsumer.originalPositionFor({
    		                line: stackframe.lineNumber,
    		                column: stackframe.columnNumber
    		            });

    		            if (loc.source) {
    		                var mappedSource = mapConsumer.sourceContentFor(loc.source);
    		                if (mappedSource) {
    		                    sourceCache[loc.source] = mappedSource;
    		                }
    		                resolve(
    		                    new StackFrame(
    		                        loc.name || stackframe.functionName,
    		                        stackframe.args,
    		                        loc.source,
    		                        loc.line,
    		                        loc.column));
    		            } else {
    		                reject(new Error('Could not get original source for given stackframe and source map'));
    		            }
    		        });
    		    }

    		    /**
    		     * @constructor
    		     * @param {Object} opts
    		     *      opts.sourceCache = {url: "Source String"} => preload source cache
    		     *      opts.offline = True to prevent network requests.
    		     *              Best effort without sources or source maps.
    		     *      opts.ajax = Promise returning function to make X-Domain requests
    		     */
    		    return function StackTraceGPS(opts) {
    		        if (!(this instanceof StackTraceGPS)) {
    		            return new StackTraceGPS(opts);
    		        }
    		        opts = opts || {};

    		        this.sourceCache = opts.sourceCache || {};

    		        this.ajax = opts.ajax || _xdr;

    		        this._atob = opts.atob || _atob;

    		        this._get = function _get(location) {
    		            return new Promise(function(resolve, reject) {
    		                var isDataUrl = location.substr(0, 5) === 'data:';
    		                if (this.sourceCache[location]) {
    		                    resolve(this.sourceCache[location]);
    		                } else if (opts.offline && !isDataUrl) {
    		                    reject(new Error('Cannot make network requests in offline mode'));
    		                } else {
    		                    if (isDataUrl) {
    		                        // data URLs can have parameters.
    		                        // see http://tools.ietf.org/html/rfc2397
    		                        var supportedEncodingRegexp =
    		                            /^data:application\/json;([\w=:"-]+;)*base64,/;
    		                        var match = location.match(supportedEncodingRegexp);
    		                        if (match) {
    		                            var sourceMapStart = match[0].length;
    		                            var encodedSource = location.substr(sourceMapStart);
    		                            var source = this._atob(encodedSource);
    		                            this.sourceCache[location] = source;
    		                            resolve(source);
    		                        } else {
    		                            reject(new Error('The encoding of the inline sourcemap is not supported'));
    		                        }
    		                    } else {
    		                        var xhrPromise = this.ajax(location, {method: 'get'});
    		                        // Cache the Promise to prevent duplicate in-flight requests
    		                        this.sourceCache[location] = xhrPromise;
    		                        xhrPromise.then(resolve, reject);
    		                    }
    		                }
    		            }.bind(this));
    		        };

    		        /**
    		         * Given a StackFrame, enhance function name and use source maps for a
    		         * better StackFrame.
    		         *
    		         * @param {StackFrame} stackframe object
    		         * @returns {Promise} that resolves with with source-mapped StackFrame
    		         */
    		        this.pinpoint = function StackTraceGPS$$pinpoint(stackframe) {
    		            return new Promise(function(resolve, reject) {
    		                this.getMappedLocation(stackframe).then(function(mappedStackFrame) {
    		                    function resolveMappedStackFrame() {
    		                        resolve(mappedStackFrame);
    		                    }

    		                    this.findFunctionName(mappedStackFrame)
    		                        .then(resolve, resolveMappedStackFrame)
    		                        ['catch'](resolveMappedStackFrame);
    		                }.bind(this), reject);
    		            }.bind(this));
    		        };

    		        /**
    		         * Given a StackFrame, guess function name from location information.
    		         *
    		         * @param {StackFrame} stackframe
    		         * @returns {Promise} that resolves with enhanced StackFrame.
    		         */
    		        this.findFunctionName = function StackTraceGPS$$findFunctionName(stackframe) {
    		            return new Promise(function(resolve, reject) {
    		                _ensureStackFrameIsLegit(stackframe);
    		                this._get(stackframe.fileName).then(function getSourceCallback(source) {
    		                    var lineNumber = stackframe.lineNumber;
    		                    var columnNumber = stackframe.columnNumber;
    		                    var guessedFunctionName = _findFunctionName(source, lineNumber);
    		                    // Only replace functionName if we found something
    		                    if (guessedFunctionName) {
    		                        resolve(new StackFrame(guessedFunctionName,
    		                            stackframe.args,
    		                            stackframe.fileName,
    		                            lineNumber,
    		                            columnNumber));
    		                    } else {
    		                        resolve(stackframe);
    		                    }
    		                }, reject)['catch'](reject);
    		            }.bind(this));
    		        };

    		        /**
    		         * Given a StackFrame, seek source-mapped location and return new enhanced StackFrame.
    		         *
    		         * @param {StackFrame} stackframe
    		         * @returns {Promise} that resolves with enhanced StackFrame.
    		         */
    		        this.getMappedLocation = function StackTraceGPS$$getMappedLocation(stackframe) {
    		            return new Promise(function(resolve, reject) {
    		                _ensureSupportedEnvironment();
    		                _ensureStackFrameIsLegit(stackframe);

    		                var sourceCache = this.sourceCache;
    		                var fileName = stackframe.fileName;
    		                this._get(fileName).then(function(source) {
    		                    var sourceMappingURL = _findSourceMappingURL(source);
    		                    var isDataUrl = sourceMappingURL.substr(0, 5) === 'data:';
    		                    var base = fileName.substring(0, fileName.lastIndexOf('/') + 1);

    		                    if (sourceMappingURL[0] !== '/' && !isDataUrl && !(/^https?:\/\/|^\/\//i).test(sourceMappingURL)) {
    		                        sourceMappingURL = base + sourceMappingURL;
    		                    }

    		                    this._get(sourceMappingURL).then(function(sourceMap) {
    		                        if (typeof sourceMap === 'string') {
    		                            sourceMap = _parseJson(sourceMap.replace(/^\)\]\}'/, ''));
    		                        }
    		                        if (typeof sourceMap.sourceRoot === 'undefined') {
    		                            sourceMap.sourceRoot = base;
    		                        }

    		                        _extractLocationInfoFromSourceMap(stackframe, sourceMap, sourceCache)
    		                            .then(resolve)['catch'](function() {
    		                            resolve(stackframe);
    		                        });
    		                    }, reject)['catch'](reject);
    		                }.bind(this), reject)['catch'](reject);
    		            }.bind(this));
    		        };
    		    };
    		}));
    } (stacktraceGps));
    	return stacktraceGpsExports;
    }

    (function (module, exports) {
    	(function(root, factory) {
    	    // Universal Module Definition (UMD) to support AMD, CommonJS/Node.js, Rhino, and browsers.

    	    /* istanbul ignore next */
    	    {
    	        module.exports = factory(requireErrorStackParser(), requireStackGenerator(), requireStacktraceGps());
    	    }
    	}(commonjsGlobal, function StackTrace(ErrorStackParser, StackGenerator, StackTraceGPS) {
    	    var _options = {
    	        filter: function(stackframe) {
    	            // Filter out stackframes for this library by default
    	            return (stackframe.functionName || '').indexOf('StackTrace$$') === -1 &&
    	                (stackframe.functionName || '').indexOf('ErrorStackParser$$') === -1 &&
    	                (stackframe.functionName || '').indexOf('StackTraceGPS$$') === -1 &&
    	                (stackframe.functionName || '').indexOf('StackGenerator$$') === -1;
    	        },
    	        sourceCache: {}
    	    };

    	    var _generateError = function StackTrace$$GenerateError() {
    	        try {
    	            // Error must be thrown to get stack in IE
    	            throw new Error();
    	        } catch (err) {
    	            return err;
    	        }
    	    };

    	    /**
    	     * Merge 2 given Objects. If a conflict occurs the second object wins.
    	     * Does not do deep merges.
    	     *
    	     * @param {Object} first base object
    	     * @param {Object} second overrides
    	     * @returns {Object} merged first and second
    	     * @private
    	     */
    	    function _merge(first, second) {
    	        var target = {};

    	        [first, second].forEach(function(obj) {
    	            for (var prop in obj) {
    	                if (obj.hasOwnProperty(prop)) {
    	                    target[prop] = obj[prop];
    	                }
    	            }
    	            return target;
    	        });

    	        return target;
    	    }

    	    function _isShapedLikeParsableError(err) {
    	        return err.stack || err['opera#sourceloc'];
    	    }

    	    function _filtered(stackframes, filter) {
    	        if (typeof filter === 'function') {
    	            return stackframes.filter(filter);
    	        }
    	        return stackframes;
    	    }

    	    return {
    	        /**
    	         * Get a backtrace from invocation point.
    	         *
    	         * @param {Object} opts
    	         * @returns {Array} of StackFrame
    	         */
    	        get: function StackTrace$$get(opts) {
    	            var err = _generateError();
    	            return _isShapedLikeParsableError(err) ? this.fromError(err, opts) : this.generateArtificially(opts);
    	        },

    	        /**
    	         * Get a backtrace from invocation point.
    	         * IMPORTANT: Does not handle source maps or guess function names!
    	         *
    	         * @param {Object} opts
    	         * @returns {Array} of StackFrame
    	         */
    	        getSync: function StackTrace$$getSync(opts) {
    	            opts = _merge(_options, opts);
    	            var err = _generateError();
    	            var stack = _isShapedLikeParsableError(err) ? ErrorStackParser.parse(err) : StackGenerator.backtrace(opts);
    	            return _filtered(stack, opts.filter);
    	        },

    	        /**
    	         * Given an error object, parse it.
    	         *
    	         * @param {Error} error object
    	         * @param {Object} opts
    	         * @returns {Promise} for Array[StackFrame}
    	         */
    	        fromError: function StackTrace$$fromError(error, opts) {
    	            opts = _merge(_options, opts);
    	            var gps = new StackTraceGPS(opts);
    	            return new Promise(function(resolve) {
    	                var stackframes = _filtered(ErrorStackParser.parse(error), opts.filter);
    	                resolve(Promise.all(stackframes.map(function(sf) {
    	                    return new Promise(function(resolve) {
    	                        function resolveOriginal() {
    	                            resolve(sf);
    	                        }

    	                        gps.pinpoint(sf).then(resolve, resolveOriginal)['catch'](resolveOriginal);
    	                    });
    	                })));
    	            }.bind(this));
    	        },

    	        /**
    	         * Use StackGenerator to generate a backtrace.
    	         *
    	         * @param {Object} opts
    	         * @returns {Promise} of Array[StackFrame]
    	         */
    	        generateArtificially: function StackTrace$$generateArtificially(opts) {
    	            opts = _merge(_options, opts);
    	            var stackFrames = StackGenerator.backtrace(opts);
    	            if (typeof opts.filter === 'function') {
    	                stackFrames = stackFrames.filter(opts.filter);
    	            }
    	            return Promise.resolve(stackFrames);
    	        },

    	        /**
    	         * Given a function, wrap it such that invocations trigger a callback that
    	         * is called with a stack trace.
    	         *
    	         * @param {Function} fn to be instrumented
    	         * @param {Function} callback function to call with a stack trace on invocation
    	         * @param {Function} errback optional function to call with error if unable to get stack trace.
    	         * @param {Object} thisArg optional context object (e.g. window)
    	         */
    	        instrument: function StackTrace$$instrument(fn, callback, errback, thisArg) {
    	            if (typeof fn !== 'function') {
    	                throw new Error('Cannot instrument non-function object');
    	            } else if (typeof fn.__stacktraceOriginalFn === 'function') {
    	                // Already instrumented, return given Function
    	                return fn;
    	            }

    	            var instrumented = function StackTrace$$instrumented() {
    	                try {
    	                    this.get().then(callback, errback)['catch'](errback);
    	                    return fn.apply(thisArg || this, arguments);
    	                } catch (e) {
    	                    if (_isShapedLikeParsableError(e)) {
    	                        this.fromError(e).then(callback, errback)['catch'](errback);
    	                    }
    	                    throw e;
    	                }
    	            }.bind(this);
    	            instrumented.__stacktraceOriginalFn = fn;

    	            return instrumented;
    	        },

    	        /**
    	         * Given a function that has been instrumented,
    	         * revert the function to it's original (non-instrumented) state.
    	         *
    	         * @param {Function} fn to de-instrument
    	         */
    	        deinstrument: function StackTrace$$deinstrument(fn) {
    	            if (typeof fn !== 'function') {
    	                throw new Error('Cannot de-instrument non-function object');
    	            } else if (typeof fn.__stacktraceOriginalFn === 'function') {
    	                return fn.__stacktraceOriginalFn;
    	            } else {
    	                // Function not instrumented, return original
    	                return fn;
    	            }
    	        },

    	        /**
    	         * Given an error message and Array of StackFrames, serialize and POST to given URL.
    	         *
    	         * @param {Array} stackframes
    	         * @param {String} url
    	         * @param {String} errorMsg
    	         */
    	        report: function StackTrace$$report(stackframes, url, errorMsg) {
    	            return new Promise(function(resolve, reject) {
    	                var req = new XMLHttpRequest();
    	                req.onerror = reject;
    	                req.onreadystatechange = function onreadystatechange() {
    	                    if (req.readyState === 4) {
    	                        if (req.status >= 200 && req.status < 400) {
    	                            resolve(req.responseText);
    	                        } else {
    	                            reject(new Error('POST to ' + url + ' failed with status: ' + req.status));
    	                        }
    	                    }
    	                };
    	                req.open('post', url);
    	                req.setRequestHeader('Content-Type', 'application/json');

    	                var reportPayload = {stack: stackframes};
    	                if (errorMsg !== undefined) {
    	                    reportPayload.message = errorMsg;
    	                }

    	                req.send(JSON.stringify(reportPayload));
    	            });
    	        }
    	    };
    	}));
    } (stacktrace));

    var dayjs_minExports = {};
    var dayjs_min = {
      get exports(){ return dayjs_minExports; },
      set exports(v){ dayjs_minExports = v; },
    };

    (function (module, exports) {
    	!function(t,e){module.exports=e();}(commonjsGlobal,(function(){var t=1e3,e=6e4,n=36e5,r="millisecond",i="second",s="minute",u="hour",a="day",o="week",f="month",h="quarter",c="year",d="date",l="Invalid Date",$=/^(\d{4})[-/]?(\d{1,2})?[-/]?(\d{0,2})[Tt\s]*(\d{1,2})?:?(\d{1,2})?:?(\d{1,2})?[.:]?(\d+)?$/,y=/\[([^\]]+)]|Y{1,4}|M{1,4}|D{1,2}|d{1,4}|H{1,2}|h{1,2}|a|A|m{1,2}|s{1,2}|Z{1,2}|SSS/g,M={name:"en",weekdays:"Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),months:"January_February_March_April_May_June_July_August_September_October_November_December".split("_"),ordinal:function(t){var e=["th","st","nd","rd"],n=t%100;return "["+t+(e[(n-20)%10]||e[n]||e[0])+"]"}},m=function(t,e,n){var r=String(t);return !r||r.length>=e?t:""+Array(e+1-r.length).join(n)+t},v={s:m,z:function(t){var e=-t.utcOffset(),n=Math.abs(e),r=Math.floor(n/60),i=n%60;return (e<=0?"+":"-")+m(r,2,"0")+":"+m(i,2,"0")},m:function t(e,n){if(e.date()<n.date())return -t(n,e);var r=12*(n.year()-e.year())+(n.month()-e.month()),i=e.clone().add(r,f),s=n-i<0,u=e.clone().add(r+(s?-1:1),f);return +(-(r+(n-i)/(s?i-u:u-i))||0)},a:function(t){return t<0?Math.ceil(t)||0:Math.floor(t)},p:function(t){return {M:f,y:c,w:o,d:a,D:d,h:u,m:s,s:i,ms:r,Q:h}[t]||String(t||"").toLowerCase().replace(/s$/,"")},u:function(t){return void 0===t}},g="en",D={};D[g]=M;var p=function(t){return t instanceof _},S=function t(e,n,r){var i;if(!e)return g;if("string"==typeof e){var s=e.toLowerCase();D[s]&&(i=s),n&&(D[s]=n,i=s);var u=e.split("-");if(!i&&u.length>1)return t(u[0])}else {var a=e.name;D[a]=e,i=a;}return !r&&i&&(g=i),i||!r&&g},w=function(t,e){if(p(t))return t.clone();var n="object"==typeof e?e:{};return n.date=t,n.args=arguments,new _(n)},O=v;O.l=S,O.i=p,O.w=function(t,e){return w(t,{locale:e.$L,utc:e.$u,x:e.$x,$offset:e.$offset})};var _=function(){function M(t){this.$L=S(t.locale,null,!0),this.parse(t);}var m=M.prototype;return m.parse=function(t){this.$d=function(t){var e=t.date,n=t.utc;if(null===e)return new Date(NaN);if(O.u(e))return new Date;if(e instanceof Date)return new Date(e);if("string"==typeof e&&!/Z$/i.test(e)){var r=e.match($);if(r){var i=r[2]-1||0,s=(r[7]||"0").substring(0,3);return n?new Date(Date.UTC(r[1],i,r[3]||1,r[4]||0,r[5]||0,r[6]||0,s)):new Date(r[1],i,r[3]||1,r[4]||0,r[5]||0,r[6]||0,s)}}return new Date(e)}(t),this.$x=t.x||{},this.init();},m.init=function(){var t=this.$d;this.$y=t.getFullYear(),this.$M=t.getMonth(),this.$D=t.getDate(),this.$W=t.getDay(),this.$H=t.getHours(),this.$m=t.getMinutes(),this.$s=t.getSeconds(),this.$ms=t.getMilliseconds();},m.$utils=function(){return O},m.isValid=function(){return !(this.$d.toString()===l)},m.isSame=function(t,e){var n=w(t);return this.startOf(e)<=n&&n<=this.endOf(e)},m.isAfter=function(t,e){return w(t)<this.startOf(e)},m.isBefore=function(t,e){return this.endOf(e)<w(t)},m.$g=function(t,e,n){return O.u(t)?this[e]:this.set(n,t)},m.unix=function(){return Math.floor(this.valueOf()/1e3)},m.valueOf=function(){return this.$d.getTime()},m.startOf=function(t,e){var n=this,r=!!O.u(e)||e,h=O.p(t),l=function(t,e){var i=O.w(n.$u?Date.UTC(n.$y,e,t):new Date(n.$y,e,t),n);return r?i:i.endOf(a)},$=function(t,e){return O.w(n.toDate()[t].apply(n.toDate("s"),(r?[0,0,0,0]:[23,59,59,999]).slice(e)),n)},y=this.$W,M=this.$M,m=this.$D,v="set"+(this.$u?"UTC":"");switch(h){case c:return r?l(1,0):l(31,11);case f:return r?l(1,M):l(0,M+1);case o:var g=this.$locale().weekStart||0,D=(y<g?y+7:y)-g;return l(r?m-D:m+(6-D),M);case a:case d:return $(v+"Hours",0);case u:return $(v+"Minutes",1);case s:return $(v+"Seconds",2);case i:return $(v+"Milliseconds",3);default:return this.clone()}},m.endOf=function(t){return this.startOf(t,!1)},m.$set=function(t,e){var n,o=O.p(t),h="set"+(this.$u?"UTC":""),l=(n={},n[a]=h+"Date",n[d]=h+"Date",n[f]=h+"Month",n[c]=h+"FullYear",n[u]=h+"Hours",n[s]=h+"Minutes",n[i]=h+"Seconds",n[r]=h+"Milliseconds",n)[o],$=o===a?this.$D+(e-this.$W):e;if(o===f||o===c){var y=this.clone().set(d,1);y.$d[l]($),y.init(),this.$d=y.set(d,Math.min(this.$D,y.daysInMonth())).$d;}else l&&this.$d[l]($);return this.init(),this},m.set=function(t,e){return this.clone().$set(t,e)},m.get=function(t){return this[O.p(t)]()},m.add=function(r,h){var d,l=this;r=Number(r);var $=O.p(h),y=function(t){var e=w(l);return O.w(e.date(e.date()+Math.round(t*r)),l)};if($===f)return this.set(f,this.$M+r);if($===c)return this.set(c,this.$y+r);if($===a)return y(1);if($===o)return y(7);var M=(d={},d[s]=e,d[u]=n,d[i]=t,d)[$]||1,m=this.$d.getTime()+r*M;return O.w(m,this)},m.subtract=function(t,e){return this.add(-1*t,e)},m.format=function(t){var e=this,n=this.$locale();if(!this.isValid())return n.invalidDate||l;var r=t||"YYYY-MM-DDTHH:mm:ssZ",i=O.z(this),s=this.$H,u=this.$m,a=this.$M,o=n.weekdays,f=n.months,h=function(t,n,i,s){return t&&(t[n]||t(e,r))||i[n].slice(0,s)},c=function(t){return O.s(s%12||12,t,"0")},d=n.meridiem||function(t,e,n){var r=t<12?"AM":"PM";return n?r.toLowerCase():r},$={YY:String(this.$y).slice(-2),YYYY:this.$y,M:a+1,MM:O.s(a+1,2,"0"),MMM:h(n.monthsShort,a,f,3),MMMM:h(f,a),D:this.$D,DD:O.s(this.$D,2,"0"),d:String(this.$W),dd:h(n.weekdaysMin,this.$W,o,2),ddd:h(n.weekdaysShort,this.$W,o,3),dddd:o[this.$W],H:String(s),HH:O.s(s,2,"0"),h:c(1),hh:c(2),a:d(s,u,!0),A:d(s,u,!1),m:String(u),mm:O.s(u,2,"0"),s:String(this.$s),ss:O.s(this.$s,2,"0"),SSS:O.s(this.$ms,3,"0"),Z:i};return r.replace(y,(function(t,e){return e||$[t]||i.replace(":","")}))},m.utcOffset=function(){return 15*-Math.round(this.$d.getTimezoneOffset()/15)},m.diff=function(r,d,l){var $,y=O.p(d),M=w(r),m=(M.utcOffset()-this.utcOffset())*e,v=this-M,g=O.m(this,M);return g=($={},$[c]=g/12,$[f]=g,$[h]=g/3,$[o]=(v-m)/6048e5,$[a]=(v-m)/864e5,$[u]=v/n,$[s]=v/e,$[i]=v/t,$)[y]||v,l?g:O.a(g)},m.daysInMonth=function(){return this.endOf(f).$D},m.$locale=function(){return D[this.$L]},m.locale=function(t,e){if(!t)return this.$L;var n=this.clone(),r=S(t,e,!0);return r&&(n.$L=r),n},m.clone=function(){return O.w(this.$d,this)},m.toDate=function(){return new Date(this.valueOf())},m.toJSON=function(){return this.isValid()?this.toISOString():null},m.toISOString=function(){return this.$d.toISOString()},m.toString=function(){return this.$d.toUTCString()},M}(),T=_.prototype;return w.prototype=T,[["$ms",r],["$s",i],["$m",s],["$H",u],["$W",a],["$M",f],["$y",c],["$D",d]].forEach((function(t){T[t[1]]=function(e){return this.$g(e,t[0],t[1])};})),w.extend=function(t,e){return t.$i||(t(e,_,w),t.$i=!0),w},w.locale=S,w.isDayjs=p,w.unix=function(t){return w(1e3*t)},w.en=D[g],w.Ls=D,w.p={},w}));
    } (dayjs_min));

    var index_cjs = {};

    var ansiRegex$1 = ({onlyFirst = false} = {}) => {
    	const pattern = [
    		'[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)',
    		'(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))'
    	].join('|');

    	return new RegExp(pattern, onlyFirst ? undefined : 'g');
    };

    var ansiStylesExports = {};
    var ansiStyles = {
      get exports(){ return ansiStylesExports; },
      set exports(v){ ansiStylesExports = v; },
    };

    (function (module) {

    	const ANSI_BACKGROUND_OFFSET = 10;

    	const wrapAnsi256 = (offset = 0) => code => `\u001B[${38 + offset};5;${code}m`;

    	const wrapAnsi16m = (offset = 0) => (red, green, blue) => `\u001B[${38 + offset};2;${red};${green};${blue}m`;

    	function assembleStyles() {
    		const codes = new Map();
    		const styles = {
    			modifier: {
    				reset: [0, 0],
    				// 21 isn't widely supported and 22 does the same thing
    				bold: [1, 22],
    				dim: [2, 22],
    				italic: [3, 23],
    				underline: [4, 24],
    				overline: [53, 55],
    				inverse: [7, 27],
    				hidden: [8, 28],
    				strikethrough: [9, 29]
    			},
    			color: {
    				black: [30, 39],
    				red: [31, 39],
    				green: [32, 39],
    				yellow: [33, 39],
    				blue: [34, 39],
    				magenta: [35, 39],
    				cyan: [36, 39],
    				white: [37, 39],

    				// Bright color
    				blackBright: [90, 39],
    				redBright: [91, 39],
    				greenBright: [92, 39],
    				yellowBright: [93, 39],
    				blueBright: [94, 39],
    				magentaBright: [95, 39],
    				cyanBright: [96, 39],
    				whiteBright: [97, 39]
    			},
    			bgColor: {
    				bgBlack: [40, 49],
    				bgRed: [41, 49],
    				bgGreen: [42, 49],
    				bgYellow: [43, 49],
    				bgBlue: [44, 49],
    				bgMagenta: [45, 49],
    				bgCyan: [46, 49],
    				bgWhite: [47, 49],

    				// Bright color
    				bgBlackBright: [100, 49],
    				bgRedBright: [101, 49],
    				bgGreenBright: [102, 49],
    				bgYellowBright: [103, 49],
    				bgBlueBright: [104, 49],
    				bgMagentaBright: [105, 49],
    				bgCyanBright: [106, 49],
    				bgWhiteBright: [107, 49]
    			}
    		};

    		// Alias bright black as gray (and grey)
    		styles.color.gray = styles.color.blackBright;
    		styles.bgColor.bgGray = styles.bgColor.bgBlackBright;
    		styles.color.grey = styles.color.blackBright;
    		styles.bgColor.bgGrey = styles.bgColor.bgBlackBright;

    		for (const [groupName, group] of Object.entries(styles)) {
    			for (const [styleName, style] of Object.entries(group)) {
    				styles[styleName] = {
    					open: `\u001B[${style[0]}m`,
    					close: `\u001B[${style[1]}m`
    				};

    				group[styleName] = styles[styleName];

    				codes.set(style[0], style[1]);
    			}

    			Object.defineProperty(styles, groupName, {
    				value: group,
    				enumerable: false
    			});
    		}

    		Object.defineProperty(styles, 'codes', {
    			value: codes,
    			enumerable: false
    		});

    		styles.color.close = '\u001B[39m';
    		styles.bgColor.close = '\u001B[49m';

    		styles.color.ansi256 = wrapAnsi256();
    		styles.color.ansi16m = wrapAnsi16m();
    		styles.bgColor.ansi256 = wrapAnsi256(ANSI_BACKGROUND_OFFSET);
    		styles.bgColor.ansi16m = wrapAnsi16m(ANSI_BACKGROUND_OFFSET);

    		// From https://github.com/Qix-/color-convert/blob/3f0e0d4e92e235796ccb17f6e85c72094a651f49/conversions.js
    		Object.defineProperties(styles, {
    			rgbToAnsi256: {
    				value: (red, green, blue) => {
    					// We use the extended greyscale palette here, with the exception of
    					// black and white. normal palette only has 4 greyscale shades.
    					if (red === green && green === blue) {
    						if (red < 8) {
    							return 16;
    						}

    						if (red > 248) {
    							return 231;
    						}

    						return Math.round(((red - 8) / 247) * 24) + 232;
    					}

    					return 16 +
    						(36 * Math.round(red / 255 * 5)) +
    						(6 * Math.round(green / 255 * 5)) +
    						Math.round(blue / 255 * 5);
    				},
    				enumerable: false
    			},
    			hexToRgb: {
    				value: hex => {
    					const matches = /(?<colorString>[a-f\d]{6}|[a-f\d]{3})/i.exec(hex.toString(16));
    					if (!matches) {
    						return [0, 0, 0];
    					}

    					let {colorString} = matches.groups;

    					if (colorString.length === 3) {
    						colorString = colorString.split('').map(character => character + character).join('');
    					}

    					const integer = Number.parseInt(colorString, 16);

    					return [
    						(integer >> 16) & 0xFF,
    						(integer >> 8) & 0xFF,
    						integer & 0xFF
    					];
    				},
    				enumerable: false
    			},
    			hexToAnsi256: {
    				value: hex => styles.rgbToAnsi256(...styles.hexToRgb(hex)),
    				enumerable: false
    			}
    		});

    		return styles;
    	}

    	// Make the export immutable
    	Object.defineProperty(module, 'exports', {
    		enumerable: true,
    		get: assembleStyles
    	});
    } (ansiStyles));

    Object.defineProperty(index_cjs, '__esModule', { value: true });

    const getKeysOfEnumerableProperties = (object) => {
        const keys = Object.keys(object).sort();
        if (Object.getOwnPropertySymbols) {
            Object.getOwnPropertySymbols(object).forEach(symbol => {
                if (Object.getOwnPropertyDescriptor(object, symbol).enumerable) {
                    keys.push(symbol);
                }
            });
        }
        return keys;
    };
    function printIteratorEntries(iterator, config, indentation, depth, refs, printer, separator = ': ') {
        let result = '';
        let current = iterator.next();
        if (!current.done) {
            result += config.spacingOuter;
            const indentationNext = indentation + config.indent;
            while (!current.done) {
                const name = printer(current.value[0], config, indentationNext, depth, refs);
                const value = printer(current.value[1], config, indentationNext, depth, refs);
                result += indentationNext + name + separator + value;
                current = iterator.next();
                if (!current.done) {
                    result += ',' + config.spacingInner;
                }
                else if (!config.min) {
                    result += ',';
                }
            }
            result += config.spacingOuter + indentation;
        }
        return result;
    }
    function printIteratorValues(iterator, config, indentation, depth, refs, printer) {
        let result = '';
        let current = iterator.next();
        if (!current.done) {
            result += config.spacingOuter;
            const indentationNext = indentation + config.indent;
            while (!current.done) {
                result += indentationNext + printer(current.value, config, indentationNext, depth, refs);
                current = iterator.next();
                if (!current.done) {
                    result += ',' + config.spacingInner;
                }
                else if (!config.min) {
                    result += ',';
                }
            }
            result += config.spacingOuter + indentation;
        }
        return result;
    }
    function printListItems(list, config, indentation, depth, refs, printer) {
        let result = '';
        if (list.length) {
            result += config.spacingOuter;
            const indentationNext = indentation + config.indent;
            for (let i = 0; i < list.length; i++) {
                result += indentationNext + printer(list[i], config, indentationNext, depth, refs);
                if (i < list.length - 1) {
                    result += ',' + config.spacingInner;
                }
                else if (!config.min) {
                    result += ',';
                }
            }
            result += config.spacingOuter + indentation;
        }
        return result;
    }
    function printObjectProperties(val, config, indentation, depth, refs, printer) {
        let result = '';
        const keys = getKeysOfEnumerableProperties(val);
        if (keys.length) {
            result += config.spacingOuter;
            const indentationNext = indentation + config.indent;
            for (let i = 0; i < keys.length; i++) {
                const key = keys[i];
                const name = printer(key, config, indentationNext, depth, refs);
                const value = printer(val[key], config, indentationNext, depth, refs);
                result += indentationNext + name + ': ' + value;
                if (i < keys.length - 1) {
                    result += ',' + config.spacingInner;
                }
                else if (!config.min) {
                    result += ',';
                }
            }
            result += config.spacingOuter + indentation;
        }
        return result;
    }

    const ansiRegex = ansiRegex$1;
    const style$1 = ansiStylesExports;
    const toHumanReadableAnsi = (text) => text.replace(ansiRegex(), match => {
        switch (match) {
            case style$1.red.close:
            case style$1.green.close:
            case style$1.cyan.close:
            case style$1.gray.close:
            case style$1.white.close:
            case style$1.yellow.close:
            case style$1.bgRed.close:
            case style$1.bgGreen.close:
            case style$1.bgYellow.close:
            case style$1.inverse.close:
            case style$1.dim.close:
            case style$1.bold.close:
            case style$1.reset.open:
            case style$1.reset.close:
                return '</>';
            case style$1.red.open:
                return '<red>';
            case style$1.green.open:
                return '<green>';
            case style$1.cyan.open:
                return '<cyan>';
            case style$1.gray.open:
                return '<gray>';
            case style$1.white.open:
                return '<white>';
            case style$1.yellow.open:
                return '<yellow>';
            case style$1.bgRed.open:
                return '<bgRed>';
            case style$1.bgGreen.open:
                return '<bgGreen>';
            case style$1.bgYellow.open:
                return '<bgYellow>';
            case style$1.inverse.open:
                return '<inverse>';
            case style$1.dim.open:
                return '<dim>';
            case style$1.bold.open:
                return '<bold>';
            default:
                return '';
        }
    });
    const test$2 = (val) => typeof val === 'string' && !!val.match(ansiRegex());
    const serialize$2 = (val, config, indentation, depth, refs, printer) => printer(toHumanReadableAnsi(val), config, indentation, depth, refs);
    const plugin$2 = { serialize: serialize$2, test: test$2 };

    const SPACE = ' ';
    const OBJECT_NAMES = ['DOMStringMap', 'NamedNodeMap'];
    const ARRAY_REGEXP = /^(HTML\w*Collection|NodeList)$/;
    const testName = (name) => OBJECT_NAMES.indexOf(name) !== -1 || ARRAY_REGEXP.test(name);
    const test$1 = (val) => val && val.constructor && !!val.constructor.name && testName(val.constructor.name);
    const isNamedNodeMap = (collection) => collection.constructor.name === 'NamedNodeMap';
    const serialize$1 = (collection, config, indentation, depth, refs, printer) => {
        const name = collection.constructor.name;
        if (++depth > config.maxDepth) {
            return '[' + name + ']';
        }
        return ((config.min ? '' : name + SPACE) +
            (OBJECT_NAMES.indexOf(name) !== -1
                ? '{' +
                    printObjectProperties(isNamedNodeMap(collection)
                        ? Array.from(collection).reduce((props, attribute) => {
                            props[attribute.name] = attribute.value;
                            return props;
                        }, {})
                        : Object.assign({}, collection), config, indentation, depth, refs, printer) +
                    '}'
                : '[' + printListItems(Array.from(collection), config, indentation, depth, refs, printer) + ']'));
    };
    const plugin$1 = { serialize: serialize$1, test: test$1 };

    function escapeHTML(str) {
        return str.replace(/</g, '&lt;').replace(/>/g, '&gt;');
    }

    const printProps = (keys, props, config, indentation, depth, refs, printer) => {
        const indentationNext = indentation + config.indent;
        const colors = config.colors;
        return keys
            .map(key => {
            const value = props[key];
            let printed = printer(value, config, indentationNext, depth, refs);
            if (typeof value !== 'string') {
                if (printed.indexOf('\n') !== -1) {
                    printed = config.spacingOuter + indentationNext + printed + config.spacingOuter + indentation;
                }
                printed = '{' + printed + '}';
            }
            return config.spacingInner + indentation + colors.prop.open + key + colors.prop.close + '=' + colors.value.open + printed + colors.value.close;
        })
            .join('');
    };
    const printChildren = (children, config, indentation, depth, refs, printer) => children
        .map(child => config.spacingOuter +
        indentation +
        (typeof child === 'string' ? printText(child, config) : printer(child, config, indentation, depth, refs)))
        .join('');
    const printText = (text, config) => {
        const contentColor = config.colors.content;
        return contentColor.open + escapeHTML(text) + contentColor.close;
    };
    const printComment = (comment, config) => {
        const commentColor = config.colors.comment;
        return commentColor.open + '<!--' + escapeHTML(comment) + '-->' + commentColor.close;
    };
    const printElement = (type, printedProps, printedChildren, config, indentation) => {
        const tagColor = config.colors.tag;
        return (tagColor.open +
            '<' +
            type +
            (printedProps && tagColor.close + printedProps + config.spacingOuter + indentation + tagColor.open) +
            (printedChildren
                ? '>' + tagColor.close + printedChildren + config.spacingOuter + indentation + tagColor.open + '</' + type
                : (printedProps && !config.min ? '' : ' ') + '/') +
            '>' +
            tagColor.close);
    };
    const printElementAsLeaf = (type, config) => {
        const tagColor = config.colors.tag;
        return tagColor.open + '<' + type + tagColor.close + ' …' + tagColor.open + ' />' + tagColor.close;
    };

    const ELEMENT_NODE = 1;
    const TEXT_NODE = 3;
    const COMMENT_NODE = 8;
    const FRAGMENT_NODE = 11;
    const ELEMENT_REGEXP = /^((HTML|SVG)\w*)?Element$/;
    const testNode = (val) => {
        const constructorName = val.constructor.name;
        const { nodeType, tagName } = val;
        const isCustomElement = (typeof tagName === 'string' && tagName.includes('-')) || (typeof val.hasAttribute === 'function' && val.hasAttribute('is'));
        return ((nodeType === ELEMENT_NODE && (ELEMENT_REGEXP.test(constructorName) || isCustomElement)) ||
            (nodeType === TEXT_NODE && constructorName === 'Text') ||
            (nodeType === COMMENT_NODE && constructorName === 'Comment') ||
            (nodeType === FRAGMENT_NODE && constructorName === 'DocumentFragment'));
    };
    const test = (val) => { var _a; return ((_a = val === null || val === void 0 ? void 0 : val.constructor) === null || _a === void 0 ? void 0 : _a.name) && testNode(val); };
    function nodeIsText(node) {
        return node.nodeType === TEXT_NODE;
    }
    function nodeIsComment(node) {
        return node.nodeType === COMMENT_NODE;
    }
    function nodeIsFragment(node) {
        return node.nodeType === FRAGMENT_NODE;
    }
    const serialize = (node, config, indentation, depth, refs, printer) => {
        if (nodeIsText(node)) {
            return printText(node.data, config);
        }
        if (nodeIsComment(node)) {
            return printComment(node.data, config);
        }
        const type = nodeIsFragment(node) ? `DocumentFragment` : node.tagName.toLowerCase();
        if (++depth > config.maxDepth) {
            return printElementAsLeaf(type, config);
        }
        return printElement(type, printProps(nodeIsFragment(node)
            ? []
            : Array.from(node.attributes)
                .map(attr => attr.name)
                .sort(), nodeIsFragment(node)
            ? {}
            : Array.from(node.attributes).reduce((props, attribute) => {
                props[attribute.name] = attribute.value;
                return props;
            }, {}), config, indentation + config.indent, depth, refs, printer), printChildren(Array.prototype.slice.call(node.childNodes || node.children), config, indentation + config.indent, depth, refs, printer), config, indentation);
    };
    const plugin = { serialize, test };

    const style = ansiStylesExports;
    const toString = Object.prototype.toString;
    const toISOString = Date.prototype.toISOString;
    const errorToString = Error.prototype.toString;
    const regExpToString = RegExp.prototype.toString;
    const getConstructorName = (val) => (typeof val.constructor === 'function' && val.constructor.name) || 'Object';
    const isWindow = (val) => typeof window !== 'undefined' && val === window;
    const SYMBOL_REGEXP = /^Symbol\((.*)\)(.*)$/;
    const NEWLINE_REGEXP = /\n/gi;
    class PrettyFormatPluginError extends Error {
        constructor(message, stack) {
            super(message);
            this.stack = stack;
            this.name = this.constructor.name;
        }
    }
    function isToStringedArrayType(toStringed) {
        return (toStringed === '[object Array]' ||
            toStringed === '[object ArrayBuffer]' ||
            toStringed === '[object DataView]' ||
            toStringed === '[object Float32Array]' ||
            toStringed === '[object Float64Array]' ||
            toStringed === '[object Int8Array]' ||
            toStringed === '[object Int16Array]' ||
            toStringed === '[object Int32Array]' ||
            toStringed === '[object Uint8Array]' ||
            toStringed === '[object Uint8ClampedArray]' ||
            toStringed === '[object Uint16Array]' ||
            toStringed === '[object Uint32Array]');
    }
    function printNumber(val) {
        return Object.is(val, -0) ? '-0' : String(val);
    }
    function printBigInt(val) {
        return String(`${val}n`);
    }
    function printFunction(val, printFunctionName) {
        if (!printFunctionName) {
            return '[Function]';
        }
        return '[Function ' + (val.name || 'anonymous') + ']';
    }
    function printSymbol(val) {
        return String(val).replace(SYMBOL_REGEXP, 'Symbol($1)');
    }
    function printError(val) {
        return '[' + errorToString.call(val) + ']';
    }
    function printBasicValue(val, printFunctionName, escapeRegex, escapeString) {
        if (val === true || val === false) {
            return '' + val;
        }
        if (val === undefined) {
            return 'undefined';
        }
        if (val === null) {
            return 'null';
        }
        const typeOf = typeof val;
        if (typeOf === 'number') {
            return printNumber(val);
        }
        if (typeOf === 'bigint') {
            return printBigInt(val);
        }
        if (typeOf === 'string') {
            if (escapeString) {
                return '"' + val.replace(/"|\\/g, '\\$&') + '"';
            }
            return '"' + val + '"';
        }
        if (typeOf === 'function') {
            return printFunction(val, printFunctionName);
        }
        if (typeOf === 'symbol') {
            return printSymbol(val);
        }
        const toStringed = toString.call(val);
        if (toStringed === '[object WeakMap]') {
            return 'WeakMap {}';
        }
        if (toStringed === '[object WeakSet]') {
            return 'WeakSet {}';
        }
        if (toStringed === '[object Function]' || toStringed === '[object GeneratorFunction]') {
            return printFunction(val, printFunctionName);
        }
        if (toStringed === '[object Symbol]') {
            return printSymbol(val);
        }
        if (toStringed === '[object Date]') {
            return isNaN(+val) ? 'Date { NaN }' : toISOString.call(val);
        }
        if (toStringed === '[object Error]') {
            return printError(val);
        }
        if (toStringed === '[object RegExp]') {
            if (escapeRegex) {
                return regExpToString.call(val).replace(/[\\^$*+?.()|[\]{}]/g, '\\$&');
            }
            return regExpToString.call(val);
        }
        if (val instanceof Error) {
            return printError(val);
        }
        return null;
    }
    function printComplexValue(val, config, indentation, depth, refs, hasCalledToJSON) {
        if (refs.indexOf(val) !== -1) {
            return '[Circular]';
        }
        refs = refs.slice();
        refs.push(val);
        const hitMaxDepth = ++depth > config.maxDepth;
        const min = config.min;
        if (config.callToJSON && !hitMaxDepth && val.toJSON && typeof val.toJSON === 'function' && !hasCalledToJSON) {
            return printer(val.toJSON(), config, indentation, depth, refs, true);
        }
        const toStringed = toString.call(val);
        if (toStringed === '[object Arguments]') {
            return hitMaxDepth ? '[Arguments]' : (min ? '' : 'Arguments ') + '[' + printListItems(val, config, indentation, depth, refs, printer) + ']';
        }
        if (isToStringedArrayType(toStringed)) {
            return hitMaxDepth
                ? '[' + val.constructor.name + ']'
                : (min ? '' : val.constructor.name + ' ') + '[' + printListItems(val, config, indentation, depth, refs, printer) + ']';
        }
        if (toStringed === '[object Map]') {
            return hitMaxDepth ? '[Map]' : 'Map {' + printIteratorEntries(val.entries(), config, indentation, depth, refs, printer, ' => ') + '}';
        }
        if (toStringed === '[object Set]') {
            return hitMaxDepth ? '[Set]' : 'Set {' + printIteratorValues(val.values(), config, indentation, depth, refs, printer) + '}';
        }
        return hitMaxDepth || isWindow(val)
            ? '[' + getConstructorName(val) + ']'
            : (min ? '' : getConstructorName(val) + ' ') + '{' + printObjectProperties(val, config, indentation, depth, refs, printer) + '}';
    }
    function isNewPlugin(plugin) {
        return plugin.serialize != null;
    }
    function printPlugin(plugin, val, config, indentation, depth, refs) {
        let printed;
        try {
            printed = isNewPlugin(plugin)
                ? plugin.serialize(val, config, indentation, depth, refs, printer)
                : plugin.print(val, valChild => printer(valChild, config, indentation, depth, refs), str => {
                    const indentationNext = indentation + config.indent;
                    return indentationNext + str.replace(NEWLINE_REGEXP, '\n' + indentationNext);
                }, {
                    edgeSpacing: config.spacingOuter,
                    min: config.min,
                    spacing: config.spacingInner,
                }, config.colors);
        }
        catch (error) {
            throw new PrettyFormatPluginError(error.message, error.stack);
        }
        if (typeof printed !== 'string') {
            throw new Error(`pretty-format: Plugin must return type "string" but instead returned "${typeof printed}".`);
        }
        return printed;
    }
    function findPlugin(plugins, val) {
        for (let p = 0; p < plugins.length; p++) {
            try {
                if (plugins[p].test(val)) {
                    return plugins[p];
                }
            }
            catch (error) {
                throw new PrettyFormatPluginError(error.message, error.stack);
            }
        }
        return null;
    }
    function printer(val, config, indentation, depth, refs, hasCalledToJSON) {
        const plugin = findPlugin(config.plugins, val);
        if (plugin !== null) {
            return printPlugin(plugin, val, config, indentation, depth, refs);
        }
        const basicResult = printBasicValue(val, config.printFunctionName, config.escapeRegex, config.escapeString);
        if (basicResult !== null) {
            return basicResult;
        }
        return printComplexValue(val, config, indentation, depth, refs, hasCalledToJSON);
    }
    const DEFAULT_THEME = {
        comment: 'gray',
        content: 'reset',
        prop: 'yellow',
        tag: 'cyan',
        value: 'green',
    };
    const DEFAULT_THEME_KEYS = Object.keys(DEFAULT_THEME);
    const DEFAULT_OPTIONS = {
        callToJSON: true,
        escapeRegex: false,
        escapeString: true,
        highlight: false,
        indent: 2,
        maxDepth: Infinity,
        min: false,
        plugins: [],
        printFunctionName: true,
        theme: DEFAULT_THEME,
    };
    function validateOptions(options) {
        Object.keys(options).forEach(key => {
            if (!DEFAULT_OPTIONS.hasOwnProperty(key)) {
                throw new Error(`pretty-format: Unknown option "${key}".`);
            }
        });
        if (options.min && options.indent !== undefined && options.indent !== 0) {
            throw new Error('pretty-format: Options "min" and "indent" cannot be used together.');
        }
        if (options.theme !== undefined) {
            if (options.theme === null) {
                throw new Error(`pretty-format: Option "theme" must not be null.`);
            }
            if (typeof options.theme !== 'object') {
                throw new Error(`pretty-format: Option "theme" must be of type "object" but instead received "${typeof options.theme}".`);
            }
        }
    }
    const getColorsHighlight = (options) => DEFAULT_THEME_KEYS.reduce((colors, key) => {
        const value = options.theme && options.theme[key] !== undefined ? options.theme[key] : DEFAULT_THEME[key];
        const color = value && style[value];
        if (color && typeof color.close === 'string' && typeof color.open === 'string') {
            colors[key] = color;
        }
        else {
            throw new Error(`pretty-format: Option "theme" has a key "${key}" whose value "${value}" is undefined in ansi-styles.`);
        }
        return colors;
    }, Object.create(null));
    const getColorsEmpty = () => DEFAULT_THEME_KEYS.reduce((colors, key) => {
        colors[key] = { close: '', open: '' };
        return colors;
    }, Object.create(null));
    const getPrintFunctionName = (options) => options && options.printFunctionName !== undefined ? options.printFunctionName : DEFAULT_OPTIONS.printFunctionName;
    const getEscapeRegex = (options) => (options && options.escapeRegex !== undefined ? options.escapeRegex : DEFAULT_OPTIONS.escapeRegex);
    const getEscapeString = (options) => options && options.escapeString !== undefined ? options.escapeString : DEFAULT_OPTIONS.escapeString;
    const getConfig = (options) => ({
        callToJSON: options && options.callToJSON !== undefined ? options.callToJSON : DEFAULT_OPTIONS.callToJSON,
        colors: options && options.highlight ? getColorsHighlight(options) : getColorsEmpty(),
        escapeRegex: getEscapeRegex(options),
        escapeString: getEscapeString(options),
        indent: options && options.min ? '' : createIndent(options && options.indent !== undefined ? options.indent : DEFAULT_OPTIONS.indent),
        maxDepth: options && options.maxDepth !== undefined ? options.maxDepth : DEFAULT_OPTIONS.maxDepth,
        min: options && options.min !== undefined ? options.min : DEFAULT_OPTIONS.min,
        plugins: options && options.plugins !== undefined ? options.plugins : DEFAULT_OPTIONS.plugins,
        printFunctionName: getPrintFunctionName(options),
        spacingInner: options && options.min ? ' ' : '\n',
        spacingOuter: options && options.min ? '' : '\n',
    });
    function createIndent(indent) {
        return new Array(indent + 1).join(' ');
    }
    function format$1(val, options) {
        if (options) {
            validateOptions(options);
            if (options.plugins) {
                const plugin = findPlugin(options.plugins, val);
                if (plugin !== null) {
                    return printPlugin(plugin, val, getConfig(options), '', 0, []);
                }
            }
        }
        const basicResult = printBasicValue(val, getPrintFunctionName(options), getEscapeRegex(options), getEscapeString(options));
        if (basicResult !== null) {
            return basicResult;
        }
        return printComplexValue(val, getConfig(options), '', 0, []);
    }
    const plugins = {
        ConvertAnsi: plugin$2,
        DOMCollection: plugin$1,
        DOMElement: plugin,
    };

    index_cjs.default = format$1;
    index_cjs.format = format$1;
    index_cjs.plugins = plugins;

    var dist$1 = {};

    var v1$1 = {};

    var rng$1 = {};

    Object.defineProperty(rng$1, "__esModule", {
      value: true
    });
    rng$1.default = rng;

    var _crypto$3 = _interopRequireDefault$c(require$$0);

    function _interopRequireDefault$c(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    const rnds8Pool = new Uint8Array(256); // # of random values to pre-allocate

    let poolPtr = rnds8Pool.length;

    function rng() {
      if (poolPtr > rnds8Pool.length - 16) {
        _crypto$3.default.randomFillSync(rnds8Pool);

        poolPtr = 0;
      }

      return rnds8Pool.slice(poolPtr, poolPtr += 16);
    }

    var stringify$1 = {};

    var validate$1 = {};

    var regex = {};

    Object.defineProperty(regex, "__esModule", {
      value: true
    });
    regex.default = void 0;
    var _default$c = /^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;
    regex.default = _default$c;

    Object.defineProperty(validate$1, "__esModule", {
      value: true
    });
    validate$1.default = void 0;

    var _regex = _interopRequireDefault$b(regex);

    function _interopRequireDefault$b(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    function validate(uuid) {
      return typeof uuid === 'string' && _regex.default.test(uuid);
    }

    var _default$b = validate;
    validate$1.default = _default$b;

    Object.defineProperty(stringify$1, "__esModule", {
      value: true
    });
    stringify$1.default = void 0;
    stringify$1.unsafeStringify = unsafeStringify;

    var _validate$2 = _interopRequireDefault$a(validate$1);

    function _interopRequireDefault$a(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    /**
     * Convert array of 16 byte values to UUID string format of the form:
     * XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX
     */
    const byteToHex = [];

    for (let i = 0; i < 256; ++i) {
      byteToHex.push((i + 0x100).toString(16).slice(1));
    }

    function unsafeStringify(arr, offset = 0) {
      // Note: Be careful editing this code!  It's been tuned for performance
      // and works in ways you may not expect. See https://github.com/uuidjs/uuid/pull/434
      return (byteToHex[arr[offset + 0]] + byteToHex[arr[offset + 1]] + byteToHex[arr[offset + 2]] + byteToHex[arr[offset + 3]] + '-' + byteToHex[arr[offset + 4]] + byteToHex[arr[offset + 5]] + '-' + byteToHex[arr[offset + 6]] + byteToHex[arr[offset + 7]] + '-' + byteToHex[arr[offset + 8]] + byteToHex[arr[offset + 9]] + '-' + byteToHex[arr[offset + 10]] + byteToHex[arr[offset + 11]] + byteToHex[arr[offset + 12]] + byteToHex[arr[offset + 13]] + byteToHex[arr[offset + 14]] + byteToHex[arr[offset + 15]]).toLowerCase();
    }

    function stringify(arr, offset = 0) {
      const uuid = unsafeStringify(arr, offset); // Consistency check for valid UUID.  If this throws, it's likely due to one
      // of the following:
      // - One or more input array values don't map to a hex octet (leading to
      // "undefined" in the uuid)
      // - Invalid input values for the RFC `version` or `variant` fields

      if (!(0, _validate$2.default)(uuid)) {
        throw TypeError('Stringified UUID is invalid');
      }

      return uuid;
    }

    var _default$a = stringify;
    stringify$1.default = _default$a;

    Object.defineProperty(v1$1, "__esModule", {
      value: true
    });
    v1$1.default = void 0;

    var _rng$1 = _interopRequireDefault$9(rng$1);

    var _stringify$2 = stringify$1;

    function _interopRequireDefault$9(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    // **`v1()` - Generate time-based UUID**
    //
    // Inspired by https://github.com/LiosK/UUID.js
    // and http://docs.python.org/library/uuid.html
    let _nodeId;

    let _clockseq; // Previous uuid creation time


    let _lastMSecs = 0;
    let _lastNSecs = 0; // See https://github.com/uuidjs/uuid for API details

    function v1(options, buf, offset) {
      let i = buf && offset || 0;
      const b = buf || new Array(16);
      options = options || {};
      let node = options.node || _nodeId;
      let clockseq = options.clockseq !== undefined ? options.clockseq : _clockseq; // node and clockseq need to be initialized to random values if they're not
      // specified.  We do this lazily to minimize issues related to insufficient
      // system entropy.  See #189

      if (node == null || clockseq == null) {
        const seedBytes = options.random || (options.rng || _rng$1.default)();

        if (node == null) {
          // Per 4.5, create and 48-bit node id, (47 random bits + multicast bit = 1)
          node = _nodeId = [seedBytes[0] | 0x01, seedBytes[1], seedBytes[2], seedBytes[3], seedBytes[4], seedBytes[5]];
        }

        if (clockseq == null) {
          // Per 4.2.2, randomize (14 bit) clockseq
          clockseq = _clockseq = (seedBytes[6] << 8 | seedBytes[7]) & 0x3fff;
        }
      } // UUID timestamps are 100 nano-second units since the Gregorian epoch,
      // (1582-10-15 00:00).  JSNumbers aren't precise enough for this, so
      // time is handled internally as 'msecs' (integer milliseconds) and 'nsecs'
      // (100-nanoseconds offset from msecs) since unix epoch, 1970-01-01 00:00.


      let msecs = options.msecs !== undefined ? options.msecs : Date.now(); // Per 4.2.1.2, use count of uuid's generated during the current clock
      // cycle to simulate higher resolution clock

      let nsecs = options.nsecs !== undefined ? options.nsecs : _lastNSecs + 1; // Time since last uuid creation (in msecs)

      const dt = msecs - _lastMSecs + (nsecs - _lastNSecs) / 10000; // Per 4.2.1.2, Bump clockseq on clock regression

      if (dt < 0 && options.clockseq === undefined) {
        clockseq = clockseq + 1 & 0x3fff;
      } // Reset nsecs if clock regresses (new clockseq) or we've moved onto a new
      // time interval


      if ((dt < 0 || msecs > _lastMSecs) && options.nsecs === undefined) {
        nsecs = 0;
      } // Per 4.2.1.2 Throw error if too many uuids are requested


      if (nsecs >= 10000) {
        throw new Error("uuid.v1(): Can't create more than 10M uuids/sec");
      }

      _lastMSecs = msecs;
      _lastNSecs = nsecs;
      _clockseq = clockseq; // Per 4.1.4 - Convert from unix epoch to Gregorian epoch

      msecs += 12219292800000; // `time_low`

      const tl = ((msecs & 0xfffffff) * 10000 + nsecs) % 0x100000000;
      b[i++] = tl >>> 24 & 0xff;
      b[i++] = tl >>> 16 & 0xff;
      b[i++] = tl >>> 8 & 0xff;
      b[i++] = tl & 0xff; // `time_mid`

      const tmh = msecs / 0x100000000 * 10000 & 0xfffffff;
      b[i++] = tmh >>> 8 & 0xff;
      b[i++] = tmh & 0xff; // `time_high_and_version`

      b[i++] = tmh >>> 24 & 0xf | 0x10; // include version

      b[i++] = tmh >>> 16 & 0xff; // `clock_seq_hi_and_reserved` (Per 4.2.2 - include variant)

      b[i++] = clockseq >>> 8 | 0x80; // `clock_seq_low`

      b[i++] = clockseq & 0xff; // `node`

      for (let n = 0; n < 6; ++n) {
        b[i + n] = node[n];
      }

      return buf || (0, _stringify$2.unsafeStringify)(b);
    }

    var _default$9 = v1;
    v1$1.default = _default$9;

    var v3$1 = {};

    var v35$1 = {};

    var parse$1 = {};

    Object.defineProperty(parse$1, "__esModule", {
      value: true
    });
    parse$1.default = void 0;

    var _validate$1 = _interopRequireDefault$8(validate$1);

    function _interopRequireDefault$8(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    function parse(uuid) {
      if (!(0, _validate$1.default)(uuid)) {
        throw TypeError('Invalid UUID');
      }

      let v;
      const arr = new Uint8Array(16); // Parse ########-....-....-....-............

      arr[0] = (v = parseInt(uuid.slice(0, 8), 16)) >>> 24;
      arr[1] = v >>> 16 & 0xff;
      arr[2] = v >>> 8 & 0xff;
      arr[3] = v & 0xff; // Parse ........-####-....-....-............

      arr[4] = (v = parseInt(uuid.slice(9, 13), 16)) >>> 8;
      arr[5] = v & 0xff; // Parse ........-....-####-....-............

      arr[6] = (v = parseInt(uuid.slice(14, 18), 16)) >>> 8;
      arr[7] = v & 0xff; // Parse ........-....-....-####-............

      arr[8] = (v = parseInt(uuid.slice(19, 23), 16)) >>> 8;
      arr[9] = v & 0xff; // Parse ........-....-....-....-############
      // (Use "/" to avoid 32-bit truncation when bit-shifting high-order bytes)

      arr[10] = (v = parseInt(uuid.slice(24, 36), 16)) / 0x10000000000 & 0xff;
      arr[11] = v / 0x100000000 & 0xff;
      arr[12] = v >>> 24 & 0xff;
      arr[13] = v >>> 16 & 0xff;
      arr[14] = v >>> 8 & 0xff;
      arr[15] = v & 0xff;
      return arr;
    }

    var _default$8 = parse;
    parse$1.default = _default$8;

    Object.defineProperty(v35$1, "__esModule", {
      value: true
    });
    v35$1.URL = v35$1.DNS = void 0;
    v35$1.default = v35;

    var _stringify$1 = stringify$1;

    var _parse = _interopRequireDefault$7(parse$1);

    function _interopRequireDefault$7(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    function stringToBytes(str) {
      str = unescape(encodeURIComponent(str)); // UTF8 escape

      const bytes = [];

      for (let i = 0; i < str.length; ++i) {
        bytes.push(str.charCodeAt(i));
      }

      return bytes;
    }

    const DNS = '6ba7b810-9dad-11d1-80b4-00c04fd430c8';
    v35$1.DNS = DNS;
    const URL = '6ba7b811-9dad-11d1-80b4-00c04fd430c8';
    v35$1.URL = URL;

    function v35(name, version, hashfunc) {
      function generateUUID(value, namespace, buf, offset) {
        var _namespace;

        if (typeof value === 'string') {
          value = stringToBytes(value);
        }

        if (typeof namespace === 'string') {
          namespace = (0, _parse.default)(namespace);
        }

        if (((_namespace = namespace) === null || _namespace === void 0 ? void 0 : _namespace.length) !== 16) {
          throw TypeError('Namespace must be array-like (16 iterable integer values, 0-255)');
        } // Compute hash of namespace and value, Per 4.3
        // Future: Use spread syntax when supported on all platforms, e.g. `bytes =
        // hashfunc([...namespace, ... value])`


        let bytes = new Uint8Array(16 + value.length);
        bytes.set(namespace);
        bytes.set(value, namespace.length);
        bytes = hashfunc(bytes);
        bytes[6] = bytes[6] & 0x0f | version;
        bytes[8] = bytes[8] & 0x3f | 0x80;

        if (buf) {
          offset = offset || 0;

          for (let i = 0; i < 16; ++i) {
            buf[offset + i] = bytes[i];
          }

          return buf;
        }

        return (0, _stringify$1.unsafeStringify)(bytes);
      } // Function#name is not settable on some platforms (#270)


      try {
        generateUUID.name = name; // eslint-disable-next-line no-empty
      } catch (err) {} // For CommonJS default export support


      generateUUID.DNS = DNS;
      generateUUID.URL = URL;
      return generateUUID;
    }

    var md5$2 = {};

    Object.defineProperty(md5$2, "__esModule", {
      value: true
    });
    md5$2.default = void 0;

    var _crypto$2 = _interopRequireDefault$6(require$$0);

    function _interopRequireDefault$6(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    function md5$1(bytes) {
      if (Array.isArray(bytes)) {
        bytes = Buffer.from(bytes);
      } else if (typeof bytes === 'string') {
        bytes = Buffer.from(bytes, 'utf8');
      }

      return _crypto$2.default.createHash('md5').update(bytes).digest();
    }

    var _default$7 = md5$1;
    md5$2.default = _default$7;

    Object.defineProperty(v3$1, "__esModule", {
      value: true
    });
    v3$1.default = void 0;

    var _v$1 = _interopRequireDefault$5(v35$1);

    var _md = _interopRequireDefault$5(md5$2);

    function _interopRequireDefault$5(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    const v3 = (0, _v$1.default)('v3', 0x30, _md.default);
    var _default$6 = v3;
    v3$1.default = _default$6;

    var v4$1 = {};

    var native = {};

    Object.defineProperty(native, "__esModule", {
      value: true
    });
    native.default = void 0;

    var _crypto$1 = _interopRequireDefault$4(require$$0);

    function _interopRequireDefault$4(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    var _default$5 = {
      randomUUID: _crypto$1.default.randomUUID
    };
    native.default = _default$5;

    Object.defineProperty(v4$1, "__esModule", {
      value: true
    });
    v4$1.default = void 0;

    var _native = _interopRequireDefault$3(native);

    var _rng = _interopRequireDefault$3(rng$1);

    var _stringify = stringify$1;

    function _interopRequireDefault$3(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    function v4(options, buf, offset) {
      if (_native.default.randomUUID && !buf && !options) {
        return _native.default.randomUUID();
      }

      options = options || {};

      const rnds = options.random || (options.rng || _rng.default)(); // Per 4.4, set bits for version and `clock_seq_hi_and_reserved`


      rnds[6] = rnds[6] & 0x0f | 0x40;
      rnds[8] = rnds[8] & 0x3f | 0x80; // Copy bytes to buffer, if provided

      if (buf) {
        offset = offset || 0;

        for (let i = 0; i < 16; ++i) {
          buf[offset + i] = rnds[i];
        }

        return buf;
      }

      return (0, _stringify.unsafeStringify)(rnds);
    }

    var _default$4 = v4;
    v4$1.default = _default$4;

    var v5$1 = {};

    var sha1$1 = {};

    Object.defineProperty(sha1$1, "__esModule", {
      value: true
    });
    sha1$1.default = void 0;

    var _crypto = _interopRequireDefault$2(require$$0);

    function _interopRequireDefault$2(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    function sha1(bytes) {
      if (Array.isArray(bytes)) {
        bytes = Buffer.from(bytes);
      } else if (typeof bytes === 'string') {
        bytes = Buffer.from(bytes, 'utf8');
      }

      return _crypto.default.createHash('sha1').update(bytes).digest();
    }

    var _default$3 = sha1;
    sha1$1.default = _default$3;

    Object.defineProperty(v5$1, "__esModule", {
      value: true
    });
    v5$1.default = void 0;

    var _v = _interopRequireDefault$1(v35$1);

    var _sha = _interopRequireDefault$1(sha1$1);

    function _interopRequireDefault$1(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    const v5 = (0, _v.default)('v5', 0x50, _sha.default);
    var _default$2 = v5;
    v5$1.default = _default$2;

    var nil = {};

    Object.defineProperty(nil, "__esModule", {
      value: true
    });
    nil.default = void 0;
    var _default$1 = '00000000-0000-0000-0000-000000000000';
    nil.default = _default$1;

    var version$1 = {};

    Object.defineProperty(version$1, "__esModule", {
      value: true
    });
    version$1.default = void 0;

    var _validate = _interopRequireDefault(validate$1);

    function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

    function version(uuid) {
      if (!(0, _validate.default)(uuid)) {
        throw TypeError('Invalid UUID');
      }

      return parseInt(uuid.slice(14, 15), 16);
    }

    var _default = version;
    version$1.default = _default;

    (function (exports) {

    	Object.defineProperty(exports, "__esModule", {
    	  value: true
    	});
    	Object.defineProperty(exports, "NIL", {
    	  enumerable: true,
    	  get: function () {
    	    return _nil.default;
    	  }
    	});
    	Object.defineProperty(exports, "parse", {
    	  enumerable: true,
    	  get: function () {
    	    return _parse.default;
    	  }
    	});
    	Object.defineProperty(exports, "stringify", {
    	  enumerable: true,
    	  get: function () {
    	    return _stringify.default;
    	  }
    	});
    	Object.defineProperty(exports, "v1", {
    	  enumerable: true,
    	  get: function () {
    	    return _v.default;
    	  }
    	});
    	Object.defineProperty(exports, "v3", {
    	  enumerable: true,
    	  get: function () {
    	    return _v2.default;
    	  }
    	});
    	Object.defineProperty(exports, "v4", {
    	  enumerable: true,
    	  get: function () {
    	    return _v3.default;
    	  }
    	});
    	Object.defineProperty(exports, "v5", {
    	  enumerable: true,
    	  get: function () {
    	    return _v4.default;
    	  }
    	});
    	Object.defineProperty(exports, "validate", {
    	  enumerable: true,
    	  get: function () {
    	    return _validate.default;
    	  }
    	});
    	Object.defineProperty(exports, "version", {
    	  enumerable: true,
    	  get: function () {
    	    return _version.default;
    	  }
    	});

    	var _v = _interopRequireDefault(v1$1);

    	var _v2 = _interopRequireDefault(v3$1);

    	var _v3 = _interopRequireDefault(v4$1);

    	var _v4 = _interopRequireDefault(v5$1);

    	var _nil = _interopRequireDefault(nil);

    	var _version = _interopRequireDefault(version$1);

    	var _validate = _interopRequireDefault(validate$1);

    	var _stringify = _interopRequireDefault(stringify$1);

    	var _parse = _interopRequireDefault(parse$1);

    	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
    } (dist$1));

    var dist = {};

    var stopwatch = {};

    var taskinfo = {};

    Object.defineProperty(taskinfo, "__esModule", { value: true });
    taskinfo.TaskInfo = void 0;
    /**
    * class to hold data about one task executed within the stop watch.
    */
    class TaskInfo {
        constructor(taskName, timeMillis) {
            this._taskName = taskName;
            this._timeMillis = timeMillis;
        }
        get taskName() {
            return this._taskName;
        }
        get timeMills() {
            return this._timeMillis;
        }
        get percentage() {
            return this._percentage;
        }
        calculatePercentage(totalTimeMillis) {
            this._percentage = (this._timeMillis * 100 / totalTimeMillis).toFixed(2);
            return this._percentage;
        }
    }
    taskinfo.TaskInfo = TaskInfo;

    Object.defineProperty(stopwatch, "__esModule", { value: true });
    stopwatch.StopWatch = void 0;
    const taskinfo_1 = taskinfo;
    class StopWatch {
        constructor(id = '') {
            this.currentTaskName = null;
            this.startTimeMillis = 0;
            this.totalTimeMillis = 0;
            this.taskList = [];
            this.id = id;
        }
        /**
         * start a task
         */
        start(taskName = '') {
            this.currentTaskName !== null && this.throwError('Can\'t start StopWatch: it\'s already running');
            this.currentTaskName = taskName;
            this.startTimeMillis = Date.now();
        }
        /**
         * stop the current task
         */
        stop() {
            this.currentTaskName === null && this.throwError('Can\'t stop StopWatch: it\'s not running');
            const lastTime = Date.now() - this.startTimeMillis;
            this.totalTimeMillis += lastTime;
            const lastTaskInfo = new taskinfo_1.TaskInfo(this.currentTaskName, lastTime);
            this.taskList.push(lastTaskInfo);
            this.currentTaskName = null;
        }
        /**
         * Return a string with a table describing all tasks performed.
         */
        prettyPrint() {
            const output = [this.shortSummary()];
            if (this.taskList.length) {
                output.push('------------------------------------------');
                output.push('ms \t\t % \t\t Task name');
                output.push('------------------------------------------');
                this.taskList.forEach((task) => {
                    let percentage = '0';
                    try {
                        percentage = task.calculatePercentage(this.totalTimeMillis);
                    }
                    catch (e) {
                    }
                    output.push(`${task.timeMills} \t\t ${percentage} \t\t ${task.taskName}`);
                });
            }
            else {
                output.push(StopWatch.NoTaskMessage);
            }
            const outputString = output.join('\n');
            console.info(outputString);
            return outputString;
        }
        /**
         * Return a task matching the given name
         */
        getTask(taskName) {
            const task = this.taskList.find(task => task.taskName === taskName);
            task === null || task === void 0 ? void 0 : task.calculatePercentage(this.totalTimeMillis);
            return task;
        }
        /**
         * Return the total running time in milliseconds
         */
        getTotalTime() {
            return this.totalTimeMillis;
        }
        /**
         * Return a short description of the total running time.
         */
        shortSummary() {
            return `StopWatch '${this.id}' running time (millis) = ${this.totalTimeMillis}`;
        }
        /**
         * Return whether the stop watch is currently running
         */
        isRunning() {
            return this.currentTaskName !== null;
        }
        /**
         * Return the number of tasks timed.
         */
        getTaskCount() {
            return this.taskList.length;
        }
        throwError(msg) {
            throw new Error(msg);
        }
    }
    stopwatch.StopWatch = StopWatch;
    StopWatch.NoTaskMessage = 'No task info kept';

    (function (exports) {
    	Object.defineProperty(exports, "__esModule", { value: true });
    	exports.StopWatch = void 0;
    	var stopwatch_1 = stopwatch;
    	Object.defineProperty(exports, "StopWatch", { enumerable: true, get: function () { return stopwatch_1.StopWatch; } });
    	
    } (dist));

    /**
     * @typedef {Object} ParsingOptions
     *  @property {function(node)} filter Returns false to exclude a node. Default is true.
     */

    var xmlParserXo;
    var hasRequiredXmlParserXo;

    function requireXmlParserXo () {
    	if (hasRequiredXmlParserXo) return xmlParserXo;
    	hasRequiredXmlParserXo = 1;
    	/**
    	 * Parse the given XML string into an object.
    	 *
    	 * @param {String} xml
    	 * @param {ParsingOptions} [options]
    	 * @return {Object}
    	 * @api public
    	 */
    	function parse(xml, options = {}) {

    	    options.filter = options.filter || (() => true);

    	    function nextChild() {
    	        return tag() || content() || comment() || cdata();
    	    }

    	    function nextRootChild() {
    	        match(/\s*/);
    	        return tag(true) || comment() || doctype() || processingInstruction(false);
    	    }

    	    function document() {
    	        const decl = declaration();
    	        const children = [];
    	        let documentRootNode;
    	        let child = nextRootChild();

    	        while (child) {
    	            if (child.node.type === 'Element') {
    	                if (documentRootNode) {
    	                    throw new Error('Found multiple root nodes');
    	                }
    	                documentRootNode = child.node;
    	            }

    	            if (!child.excluded) {
    	                children.push(child.node);
    	            }

    	            child = nextRootChild();
    	        }

    	        if (!documentRootNode) {
    	            throw new Error('Failed to parse XML');
    	        }

    	        return {
    	            declaration: decl ? decl.node : null,
    	            root: documentRootNode,
    	            children
    	        };
    	    }

    	    function declaration() {
    	        return processingInstruction(true);
    	    }

    	    function processingInstruction(matchDeclaration) {
    	        const m = matchDeclaration ? match(/^<\?(xml)\s*/) : match(/^<\?([\w-:.]+)\s*/);
    	        if (!m) return;

    	        // tag
    	        const node = {
    	            name: m[1],
    	            type: 'ProcessingInstruction',
    	            attributes: {}
    	        };

    	        // attributes
    	        while (!(eos() || is('?>'))) {
    	            const attr = attribute();
    	            if (!attr) return node;
    	            node.attributes[attr.name] = attr.value;
    	        }

    	        match(/\?>/);

    	        return {
    	            excluded: matchDeclaration ? false : options.filter(node) === false,
    	            node
    	        };
    	    }

    	    function tag(matchRoot) {
    	        const m = match(/^<([\w-:.]+)\s*/);
    	        if (!m) return;

    	        // name
    	        const node = {
    	            type: 'Element',
    	            name: m[1],
    	            attributes: {},
    	            children: []
    	        };

    	        // attributes
    	        while (!(eos() || is('>') || is('?>') || is('/>'))) {
    	            const attr = attribute();
    	            if (!attr) return node;
    	            node.attributes[attr.name] = attr.value;
    	        }

    	        const excluded = matchRoot ? false : options.filter(node) === false;

    	        // self closing tag
    	        if (match(/^\s*\/>/)) {
    	            node.children = null;
    	            return {
    	                excluded,
    	                node
    	            };
    	        }

    	        match(/\??>/);

    	        if (!excluded) {
    	            // children
    	            let child = nextChild();
    	            while (child) {
    	                if (!child.excluded) {
    	                    node.children.push(child.node);
    	                }
    	                child = nextChild();
    	            }
    	        }

    	        // closing
    	        match(/^<\/[\w-:.]+>/);

    	        return {
    	            excluded,
    	            node
    	        };
    	    }

    	    function doctype() {
    	        const m = match(/^<!DOCTYPE\s+[^>]*>/);
    	        if (m) {
    	            const node = {
    	                type: 'DocumentType',
    	                content: m[0]
    	            };
    	            return {
    	                excluded: options.filter(node) === false,
    	                node
    	            };
    	        }
    	    }

    	    function cdata() {
    	        if (xml.startsWith('<![CDATA[')) {
    	            const endPositionStart = xml.indexOf(']]>');
    	            if (endPositionStart > -1) {
    	                const endPositionFinish  = endPositionStart + 3;
    	                const node = {
    	                    type: 'CDATA',
    	                    content: xml.substring(0, endPositionFinish)
    	                };
    	                xml = xml.slice(endPositionFinish);
    	                return {
    	                    excluded: options.filter(node) === false,
    	                    node
    	                };
    	            }
    	        }
    	    }

    	    function comment() {
    	        const m = match(/^<!--[\s\S]*?-->/);
    	        if (m) {
    	            const node = {
    	                type: 'Comment',
    	                content: m[0]
    	            };
    	            return {
    	                excluded: options.filter(node) === false,
    	                node
    	            };
    	        }
    	    }

    	    function content() {
    	        const m = match(/^([^<]+)/);
    	        if (m) {
    	            const node = {
    	                type: 'Text',
    	                content: m[1]
    	            };
    	            return {
    	                excluded: options.filter(node) === false,
    	                node
    	            };
    	        }
    	    }

    	    function attribute() {
    	        const m = match(/([\w-:.]+)\s*=\s*("[^"]*"|'[^']*'|\w+)\s*/);
    	        if (!m) return;
    	        return {name: m[1], value: strip(m[2])}
    	    }

    	    /**
    	     * Strip quotes from `val`.
    	     */
    	    function strip(val) {
    	        return val.replace(/^['"]|['"]$/g, '');
    	    }

    	    /**
    	     * Match `re` and advance the string.
    	     */
    	    function match(re) {
    	        const m = xml.match(re);
    	        if (!m) return;
    	        xml = xml.slice(m[0].length);
    	        return m;
    	    }

    	    /**
    	     * End-of-source.
    	     */
    	    function eos() {
    	        return 0 === xml.length;
    	    }

    	    /**
    	     * Check for `prefix`.
    	     */
    	    function is(prefix) {
    	        return 0 === xml.indexOf(prefix);
    	    }

    	    xml = xml.trim();

    	    return document();
    	}

    	xmlParserXo = parse;
    	return xmlParserXo;
    }

    /**
     * @typedef {Object} XMLFormatterOptions
     *  @property {String} [indentation='    '] The value used for indentation
     *  @property {function(node): boolean} [filter] Return false to exclude the node.
     *  @property {Boolean} [collapseContent=false] True to keep content in the same line as the element. Only works if element contains at least one text node
     *  @property {String} [lineSeparator='\r\n'] The line separator to use
     *  @property {String} [whiteSpaceAtEndOfSelfclosingTag=false] to either end ad self closing tag with `<tag/>` or `<tag />`
     */

    /**
     * @typedef {Object} XMLFormatterState
     * @param {String} content
     * @param {Number} level
     * @param {XMLFormatterOptions} options
     */

    /**
     * @param {XMLFormatterState} state
     * @return {void}
     */
    function newLine(state) {
        if (!state.options.indentation && !state.options.lineSeparator) return;
        state.content += state.options.lineSeparator;
        let i;
        for (i = 0; i < state.level; i++) {
            state.content += state.options.indentation;
        }
    }

    /**
     * @param {XMLFormatterState} state
     * @param {String} content
     * @return {void}
     */
    function appendContent(state, content) {
        state.content += content;
    }

    /**
     * @param {Object} node
     * @param {XMLFormatterState} state
     * @param {Boolean} preserveSpace
     * @return {void}
     */
    function processNode(node, state, preserveSpace) {
        if (typeof node.content === 'string') {
            processContentNode(node, state, preserveSpace);
        } else if (node.type === 'Element') {
            processElementNode(node, state, preserveSpace);
        } else if (node.type === 'ProcessingInstruction') {
            processProcessingIntruction(node, state);
        } else {
            throw new Error('Unknown node type: ' + node.type);
        }
    }

    /**
     * @param {Object} node
     * @param {XMLFormatterState} state
     * @param {Boolean} preserveSpace
     * @return {void}
     */
    function processContentNode(node, state, preserveSpace) {
        if (!preserveSpace) {
            node.content = node.content.trim();
        }
        if (node.content.length > 0) {
            if (!preserveSpace && state.content.length > 0) {
                newLine(state);
            }
            appendContent(state, node.content);
        }
    }

    /**
     * @param {Object} node
     * @param {XMLFormatterState} state
     * @param {Boolean} preserveSpace
     * @return {void}
     */
    function processElementNode(node, state, preserveSpace) {
        if (!preserveSpace && state.content.length > 0) {
            newLine(state);
        }

        appendContent(state, '<' + node.name);
        processAttributes(state, node.attributes);

        if (node.children === null) {
            const selfClosingNodeClosingTag = state.options.whiteSpaceAtEndOfSelfclosingTag ? ' />' : '/>';
            // self-closing node
            appendContent(state, selfClosingNodeClosingTag);
        } else if (node.children.length === 0) {
            // empty node
            appendContent(state, '></' + node.name + '>');
        } else {

            appendContent(state, '>');

            state.level++;

            let nodePreserveSpace = node.attributes['xml:space'] === 'preserve';

            if (!nodePreserveSpace && state.options.collapseContent) {
                let containsTextNodes = false;
                let containsTextNodesWithLineBreaks = false;
                let containsNonTextNodes = false;

                node.children.forEach(function(child, index) {
                    if (child.type === 'Text') {
                        if (child.content.includes('\n')) {
                            containsTextNodesWithLineBreaks = true;
                            child.content = child.content.trim();
                        } else if (index === 0 || index === node.children.length - 1) {
                            if (child.content.trim().length === 0) {
                                // If the text node is at the start or end and is empty, it should be ignored when formatting
                                child.content = '';
                            }
                        }
                        if (child.content.length > 0) {
                            containsTextNodes = true;
                        }
                    } else if (child.type === 'CDATA') {
                        containsTextNodes = true;
                    } else {
                        containsNonTextNodes = true;
                    }
                });

                if (containsTextNodes && (!containsNonTextNodes || !containsTextNodesWithLineBreaks)) {
                    nodePreserveSpace = true;
                }
            }

            node.children.forEach(function(child) {
                processNode(child, state, preserveSpace || nodePreserveSpace, state.options);
            });

            state.level--;

            if (!preserveSpace && !nodePreserveSpace) {
                newLine(state);
            }
            appendContent(state, '</' + node.name + '>');
        }
    }

    /**
     * @param {XMLFormatterState} state
     * @param {Record<String, String>} attributes
     * @return {void}
     */
    function processAttributes(state, attributes) {
        Object.keys(attributes).forEach(function(attr) {
            const escaped = attributes[attr].replace(/"/g, '&quot;');
            appendContent(state, ' ' + attr + '="' + escaped + '"');
        });
    }

    /**
     * @param {Object} node
     * @param {XMLFormatterState} state
     * @return {void}
     */
    function processProcessingIntruction(node, state) {
        if (state.content.length > 0) {
            newLine(state);
        }
        appendContent(state, '<?' + node.name);
        processAttributes(state, node.attributes);
        appendContent(state, '?>');
    }


    /**
     * Converts the given XML into human readable format.
     *
     * @param {String} xml
     * @param {XMLFormatterOptions} options
     * @returns {string}
     */
    function format(xml, options = {}) {
        options.indentation = 'indentation' in options ? options.indentation : '    ';
        options.collapseContent = options.collapseContent === true;
        options.lineSeparator = 'lineSeparator' in options ? options.lineSeparator : '\r\n';
        options.whiteSpaceAtEndOfSelfclosingTag = !!options.whiteSpaceAtEndOfSelfclosingTag;

        const parser = requireXmlParserXo();
        const parsedXml = parser(xml, {filter: options.filter});
        const state = {content: '', level: 0, options: options};

        if (parsedXml.declaration) {
            processProcessingIntruction(parsedXml.declaration, state);
        }

        parsedXml.children.forEach(function(child) {
            processNode(child, state, false);
        });

        return state.content
            .replace(/\r\n/g, '\n')
            .replace(/\n/g, options.lineSeparator);
    }


    var xmlFormatter = format;

    var md5 = md5Exports;
    var StackTrace = stacktraceExports;
    var axios = require$$2;
    var dayjs = dayjs_minExports;
    var prettyFormat = index_cjs;
    var uuid = dist$1;
    var stopwatchNode = dist;
    var formatXml = xmlFormatter;

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (g && (g = 0, op[0] && (_ = 0)), _) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    var PACKAGE_VERSION = '1.19.4';

    var Payload = (function () {
        function Payload() {
            this.remotePath = null;
            this.localPath = null;
            this.initialized = false;
            this.data = {
                type: '',
                content: '',
                origin: { function_name: '', file: '', line_number: 0, hostname: 'remote' },
            };
        }
        Payload.prototype.replaceRemotePathWithLocalPath = function (filePath) {
            if (this.remotePath === null || this.localPath === null) {
                return filePath;
            }
            var pattern = new RegExp('^' + this.remotePath);
            return filePath.replace(pattern, this.localPath);
        };
        Payload.prototype.getContent = function () {
            return {};
        };
        Payload.prototype.toArray = function () {
            if (!this.initialized) {
                this.initialized = true;
                this.data.type = this.getType();
                this.data.content = this.getContent();
                this.data.origin.file = this.replaceRemotePathWithLocalPath(this.data.origin.file);
            }
            return this.data;
        };
        Payload.prototype.toJson = function () {
            return JSON.stringify(this.toArray());
        };
        return Payload;
    }());

    var ClearAllPayload = (function (_super) {
        __extends(ClearAllPayload, _super);
        function ClearAllPayload() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ClearAllPayload.prototype.getType = function () {
            return 'clear_all';
        };
        return ClearAllPayload;
    }(Payload));

    var Client = (function () {
        function Client(portNumber, host, scheme) {
            if (portNumber === void 0) { portNumber = 23517; }
            if (host === void 0) { host = 'localhost'; }
            if (scheme === void 0) { scheme = 'http'; }
            this.scheme = 'http';
            this.portNumber = portNumber;
            this.host = host;
            this.scheme = scheme;
        }
        Client.prototype.init = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, this.updateRayAvailabilty()];
                        case 1:
                            _a.sent();
                            return [2];
                    }
                });
            });
        };
        Client.prototype.isRayAvailable = function () {
            this.attemptAvailableReset();
            if (Client.rayState === null) {
                this.updateRayAvailabilty();
            }
            if (Client.rayState !== null) {
                return Client.rayState;
            }
            return true;
        };
        Client.prototype.attemptAvailableReset = function () {
            if (Client.lastRayStateCheck !== null && new Date().getTime() - Client.lastRayStateCheck >= 30000) {
                Client.rayState = null;
            }
        };
        Client.prototype.updateRayAvailabilty = function () {
            return __awaiter(this, void 0, void 0, function () {
                var result, err_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            result = true;
                            if (Client.lastRayStateCheck !== null && new Date().getTime() - Client.lastRayStateCheck < 30000) {
                                return [2, true];
                            }
                            Client.lastRayStateCheck = new Date().getTime();
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, 4, 5]);
                            return [4, axios.get(this.getUrlForPath('/locks/__availabilty_check'), {})];
                        case 2:
                            _a.sent();
                            return [3, 5];
                        case 3:
                            err_1 = _a.sent();
                            if (err_1.response) {
                                result = true;
                            }
                            else if (err_1.request) {
                                result = false;
                            }
                            else {
                                result = false;
                            }
                            return [3, 5];
                        case 4:
                            Client.rayState = result;
                            return [7];
                        case 5: return [2];
                    }
                });
            });
        };
        Client.prototype.getUrlForPath = function (path) {
            var _a;
            path = path.replace(/^\//, '');
            return "".concat((_a = this.scheme) !== null && _a !== void 0 ? _a : 'http', "://").concat(this.host, ":").concat(this.portNumber, "/").concat(path);
        };
        Client.prototype.send = function (request) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (Client.rayState === null || Client.lastRayStateCheck === null) {
                                this.updateRayAvailabilty();
                            }
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            request.payloads = this.ensureAllPayloadsHaveAnOrigin(request.payloads);
                            return [4, axios.post(this.getUrlForPath('/'), request.toArray(), { withCredentials: false })];
                        case 2:
                            _a.sent();
                            return [3, 4];
                        case 3:
                            _a.sent();
                            return [3, 4];
                        case 4: return [2];
                    }
                });
            });
        };
        Client.prototype.ensureAllPayloadsHaveAnOrigin = function (payloads) {
            payloads.forEach(function (payload) {
                if (payload.data.origin.file === null ||
                    payload.data.origin.file === '' ||
                    typeof payload.data.origin['file'] === 'undefined') {
                    payload.data.origin['file'] = '/unknown-file.js';
                    payload.data.origin['line_number'] = 1;
                    payload.data.origin['function_name'] = 'unknown';
                }
            });
            return payloads;
        };
        Client.prototype.lockExists = function (lockName) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    return [2, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                            var resp;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        _a.trys.push([0, 2, , 3]);
                                        return [4, axios.get(this.getUrlForPath("/locks/".concat(lockName)))];
                                    case 1:
                                        resp = _a.sent();
                                        return [3, 3];
                                    case 2:
                                        _a.sent();
                                        return [2, false];
                                    case 3:
                                        if (resp.data.stop_execution) {
                                            reject(new Error('stopping execution'));
                                            return [2];
                                        }
                                        if (typeof resp.data['active'] === 'undefined') {
                                            resolve(resp.data);
                                            return [2];
                                        }
                                        resolve(resp.data);
                                        return [2];
                                }
                            });
                        }); })];
                });
            });
        };
        Client.rayState = true;
        Client.lastRayStateCheck = null;
        return Client;
    }());

    var RemovesRayFrames = (function () {
        function RemovesRayFrames() {
        }
        RemovesRayFrames.removeRayFrames = function (frames) {
            var result = frames.filter(function (frame) { return !RemovesRayFrames.isRayFrame(frame) && !RemovesRayFrames.isNodeFrame(frame); });
            return result;
        };
        RemovesRayFrames.isRayFrame = function (frame) {
            var _a;
            for (var _i = 0, _b = this.rayNamespaces(); _i < _b.length; _i++) {
                var rayNamespace = _b[_i];
                if ((_a = frame.fileName) === null || _a === void 0 ? void 0 : _a.includes(rayNamespace)) {
                    return true;
                }
            }
            return false;
        };
        RemovesRayFrames.isNodeFrame = function (frame) {
            var _a;
            return ((_a = frame.fileName) === null || _a === void 0 ? void 0 : _a.indexOf('node:')) === 0;
        };
        RemovesRayFrames.rayNamespaces = function () {
            return ['ray-node/dist', 'node-ray/dist', 'vue-ray/dist'];
        };
        return RemovesRayFrames;
    }());

    var CallerPayload = (function (_super) {
        __extends(CallerPayload, _super);
        function CallerPayload(frames) {
            var _this = _super.call(this) || this;
            _this.frames = RemovesRayFrames.removeRayFrames(frames);
            return _this;
        }
        CallerPayload.prototype.getType = function () {
            return 'caller';
        };
        CallerPayload.prototype.getContent = function () {
            var frames = this.frames.slice(0);
            var frame = frames[0];
            var funcNameParts = frame.getFunctionName().replace('Proxy.', '').split('.').slice(0);
            var className = funcNameParts.length ? funcNameParts.shift() : '';
            var methodName = funcNameParts.join('.');
            return {
                frame: {
                    file_name: this.replaceRemotePathWithLocalPath(frame.getFileName()),
                    line_number: frame.getLineNumber(),
                    class: className,
                    method: methodName,
                    vendor_frame: frame.getFileName().includes('node_modules'),
                },
            };
        };
        return CallerPayload;
    }(Payload));

    var ColorPayload = (function (_super) {
        __extends(ColorPayload, _super);
        function ColorPayload(color) {
            var _this = _super.call(this) || this;
            _this.color = color;
            return _this;
        }
        ColorPayload.prototype.getType = function () {
            return 'color';
        };
        ColorPayload.prototype.getContent = function () {
            return {
                color: this.color,
            };
        };
        return ColorPayload;
    }(Payload));

    var ConfettiPayload = (function (_super) {
        __extends(ConfettiPayload, _super);
        function ConfettiPayload() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ConfettiPayload.prototype.getType = function () {
            return 'confetti';
        };
        return ConfettiPayload;
    }(Payload));

    var consoleLog = console.log.bind({});
    var consoleWrapper = function () {
        var _a;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (typeof Ray$1.client !== 'undefined' && Ray$1.client.isRayAvailable()) {
            (_a = Ray$1.create()).send.apply(_a, args);
        }
        consoleLog.apply(void 0, args);
    };
    var ConsoleInterceptor = (function () {
        function ConsoleInterceptor() {
        }
        ConsoleInterceptor.prototype.enable = function () {
            ConsoleInterceptor.active = true;
            console.log = consoleWrapper;
        };
        ConsoleInterceptor.prototype.disable = function () {
            ConsoleInterceptor.active = false;
            console.log = consoleLog;
        };
        ConsoleInterceptor.prototype.active = function () {
            return ConsoleInterceptor.active;
        };
        ConsoleInterceptor.active = false;
        return ConsoleInterceptor;
    }());

    var Counters = (function () {
        function Counters() {
            this.counters = {};
        }
        Counters.prototype.increment = function (name) {
            if (typeof this.counters[name] === 'undefined') {
                this.counters[name] = [ray$2(), 0];
            }
            var data = this.counters[name];
            var ray$1 = data[0];
            var times = data[1];
            var newTimes = times + 1;
            this.counters[name] = [ray$1, newTimes];
            return [ray$1, newTimes];
        };
        Counters.prototype.get = function (name) {
            if (typeof this.counters[name] === 'undefined') {
                return 0;
            }
            return this.counters[name][1];
        };
        Counters.prototype.clear = function () {
            this.counters = [];
        };
        Counters.prototype.setRay = function (name, ray) {
            this.counters[name][0] = ray;
        };
        Counters.prototype.getCounters = function () {
            return this.counters;
        };
        return Counters;
    }());

    var CreateLockPayload = (function (_super) {
        __extends(CreateLockPayload, _super);
        function CreateLockPayload(name) {
            var _this = _super.call(this) || this;
            _this.name = name;
            return _this;
        }
        CreateLockPayload.prototype.getType = function () {
            return 'create_lock';
        };
        CreateLockPayload.prototype.getContent = function () {
            return {
                name: this.name,
            };
        };
        return CreateLockPayload;
    }(Payload));

    var CustomPayload = (function (_super) {
        __extends(CustomPayload, _super);
        function CustomPayload(content, label) {
            if (label === void 0) { label = ''; }
            var _this = _super.call(this) || this;
            _this.content = content;
            _this.label = label;
            return _this;
        }
        CustomPayload.prototype.getType = function () {
            return 'custom';
        };
        CustomPayload.prototype.getContent = function () {
            return {
                content: this.content,
                label: this.label,
            };
        };
        return CustomPayload;
    }(Payload));

    var DatePayload = (function (_super) {
        __extends(DatePayload, _super);
        function DatePayload(date, format) {
            if (format === void 0) { format = 'YYYY-MM-DD hh:mm:ss'; }
            var _this = _super.call(this) || this;
            _this.date = date;
            _this.format = format;
            return _this;
        }
        DatePayload.prototype.getType = function () {
            return 'carbon';
        };
        DatePayload.prototype.getContent = function () {
            return {
                formatted: this.date ? this.getFormatted() : null,
                timestamp: this.date ? this.getTimestamp() : null,
                timezone: this.date ? this.getTimezoneName() : null,
            };
        };
        DatePayload.prototype.getTimestamp = function () {
            var _a;
            return dayjs((_a = this.date) === null || _a === void 0 ? void 0 : _a.toISOString()).unix();
        };
        DatePayload.prototype.getFormatted = function () {
            var _a;
            return dayjs((_a = this.date) === null || _a === void 0 ? void 0 : _a.toISOString()).format(this.format);
        };
        DatePayload.prototype.getTimezoneName = function () {
            if (this.date === null) {
                return '--';
            }
            var dateObj = this.date ? this.date : new Date();
            var matches = /\((.*)\)/.exec(dateObj.toString());
            return matches ? matches[1] : '--';
        };
        return DatePayload;
    }(Payload));

    var DecodedJsonPayload = (function (_super) {
        __extends(DecodedJsonPayload, _super);
        function DecodedJsonPayload(value) {
            var _this = _super.call(this) || this;
            _this.value = value;
            return _this;
        }
        DecodedJsonPayload.prototype.getType = function () {
            return 'custom';
        };
        DecodedJsonPayload.prototype.getContent = function () {
            var decodedJson = JSON.parse(this.value);
            return {
                content: decodedJson,
                label: 'JSON',
            };
        };
        return DecodedJsonPayload;
    }(Payload));

    var ErrorPayload = (function (_super) {
        __extends(ErrorPayload, _super);
        function ErrorPayload(err, label) {
            if (label === void 0) { label = 'Error'; }
            var _this = _super.call(this) || this;
            _this.err = err;
            _this.label = label;
            return _this;
        }
        ErrorPayload.prototype.getType = function () {
            return 'custom';
        };
        ErrorPayload.prototype.getContent = function () {
            return {
                content: this.formatError(),
                label: this.label,
            };
        };
        ErrorPayload.prototype.formatError = function () {
            return ("<span class=\"text-red-400 bold\">".concat(this.err.name, "</span>: <br>") +
                "<span class=\"pl-5 text-gray-500\">".concat(this.err.message, "</span>"));
        };
        return ErrorPayload;
    }(Payload));

    var ArgumentConverter = (function () {
        function ArgumentConverter() {
        }
        ArgumentConverter.convertToPrimitive = function (arg) {
            if (arg === null) {
                return { value: null, isHtml: false };
            }
            if (typeof arg === 'string') {
                return { value: arg, isHtml: false };
            }
            if (typeof arg === 'number') {
                return { value: arg, isHtml: false };
            }
            if (typeof arg === 'boolean') {
                return { value: arg, isHtml: false };
            }
            return { value: ArgumentConverter.prettyFormatForHtml(arg), isHtml: true };
        };
        ArgumentConverter.prettyFormatForHtml = function (arg) {
            var formatted = prettyFormat.format(arg, {
                indent: 4,
            })
                .replace(/ /g, '&nbsp;')
                .replace(/\r\n|\r|\n/g, '<br>')
                .replace(/("[^"]+")/g, '<code style="font-size: 0.8rem!important;" class="bold text-green-600 p-0">$1</code>')
                .replace(/Array(&nbsp;|\s)+(\[[^\]]+\])/g, '<code style="font-size: 0.8rem!important;" class="text-gray-500 p-0">Array$1$2</code>')
                .replace(/^(\[[^\]]+\])$/g, '<code style="font-size: 0.8rem!important;"class="text-gray-500 p-0">$1</code>')
                .replace(/(\{.+\})/g, '<code style="font-size: 0.8rem!important;" class="text-gray-600 ">$1</code>')
                .replace(/(Array|Object|Function|Circular|Symbol|WeakMap|Map)/g, '<span style="font-size: 0.8rem!important;" class="text-yellow-600 bold">$1</span>')
                .replace(/(true|false|null)/g, '<span style="font-size: 0.8rem!important;" class="text-indigo-600 bold">$1</span>')
                .replace(/(:&nbsp;|[,[\]{}])/g, '<span style="font-size: 0.8rem!important;" class="text-orange-400 bold">$1</span>');
            return "<code style=\"font-size: 0.8rem!important;\">".concat(formatted, "</code>");
        };
        return ArgumentConverter;
    }());

    var EventPayload = (function (_super) {
        __extends(EventPayload, _super);
        function EventPayload(eventName, payload) {
            var _this = _super.call(this) || this;
            _this.eventName = eventName;
            _this.payload = payload;
            return _this;
        }
        EventPayload.prototype.getType = function () {
            return 'event';
        };
        EventPayload.prototype.getContent = function () {
            return {
                name: this.eventName,
                event: this.payload[0],
                payload: ArgumentConverter.convertToPrimitive(this.payload).value,
                class_based_event: true,
            };
        };
        return EventPayload;
    }(Payload));

    var ExceptionPayload = (function (_super) {
        __extends(ExceptionPayload, _super);
        function ExceptionPayload(exception, meta) {
            if (meta === void 0) { meta = {}; }
            var _this = _super.call(this) || this;
            _this.meta = {};
            _this.stack = StackTrace.getSync();
            _this.exception = exception;
            _this.meta = meta;
            return _this;
        }
        ExceptionPayload.prototype.getType = function () {
            return 'exception';
        };
        ExceptionPayload.prototype.getContent = function () {
            return {
                class: this.exception.name,
                message: this.exception.message,
                frames: this.getFrames(),
                meta: this.meta,
            };
        };
        ExceptionPayload.prototype.getFrames = function () {
            var _this = this;
            return this.stack
                .slice(1)
                .map(function (frame) {
                var _a, _b;
                var funcNameParts = (_b = (_a = frame.functionName) === null || _a === void 0 ? void 0 : _a.split('.')) !== null && _b !== void 0 ? _b : ['unknown', 'unknown'];
                var methodName = funcNameParts.pop();
                var className = funcNameParts.pop();
                if (typeof className === 'undefined') {
                    className = 'unknown';
                }
                return {
                    file_name: _this.replaceRemotePathWithLocalPath(frame.getFileName()),
                    line_number: frame.getLineNumber(),
                    class: className,
                    method: methodName,
                    vendor_frame: frame.getFileName().includes('node_modules'),
                    snippet: [],
                };
            })
                .filter(function (obj) { return !obj.file_name.startsWith('node:'); })
                .filter(function (obj) { return !obj.file_name.includes('jest-circus'); })
                .filter(function (obj) { return obj.class !== 'Ray' && obj.method !== 'exception'; });
        };
        return ExceptionPayload;
    }(Payload));

    var HideAppPayload = (function (_super) {
        __extends(HideAppPayload, _super);
        function HideAppPayload() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        HideAppPayload.prototype.getType = function () {
            return 'hide_app';
        };
        return HideAppPayload;
    }(Payload));

    var HidePayload = (function (_super) {
        __extends(HidePayload, _super);
        function HidePayload() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        HidePayload.prototype.getType = function () {
            return 'hide';
        };
        return HidePayload;
    }(Payload));

    var Hostname = (function () {
        function Hostname() {
        }
        Hostname.get = function () {
            var _a;
            return (_a = Hostname.hostname) !== null && _a !== void 0 ? _a : 'remote';
        };
        Hostname.set = function (hostname) {
            Hostname.hostname = hostname;
        };
        Hostname.hostname = null;
        return Hostname;
    }());

    var HtmlPayload = (function (_super) {
        __extends(HtmlPayload, _super);
        function HtmlPayload(html) {
            if (html === void 0) { html = ''; }
            var _this = _super.call(this) || this;
            _this.html = html;
            return _this;
        }
        HtmlPayload.prototype.getType = function () {
            return 'custom';
        };
        HtmlPayload.prototype.getContent = function () {
            return {
                content: this.html,
                label: 'HTML',
            };
        };
        return HtmlPayload;
    }(Payload));

    var ImagePayload = (function (_super) {
        __extends(ImagePayload, _super);
        function ImagePayload(location) {
            var _this = _super.call(this) || this;
            _this.location = location;
            return _this;
        }
        ImagePayload.prototype.getType = function () {
            return 'custom';
        };
        ImagePayload.prototype.getContent = function () {
            var location = this.location.replace('"', '\\\\"');
            return {
                content: "<img src=\"".concat(location, "\" alt=\"\" />"),
                label: 'Image',
            };
        };
        return ImagePayload;
    }(Payload));

    var JsonStringPayload = (function (_super) {
        __extends(JsonStringPayload, _super);
        function JsonStringPayload(value) {
            var _this = _super.call(this) || this;
            _this.value = value;
            return _this;
        }
        JsonStringPayload.prototype.getType = function () {
            return 'json_string';
        };
        JsonStringPayload.prototype.getContent = function () {
            return {
                value: JSON.stringify(this.value),
            };
        };
        return JsonStringPayload;
    }(Payload));

    var LogPayload = (function (_super) {
        __extends(LogPayload, _super);
        function LogPayload(values) {
            var _this = _super.call(this) || this;
            if (!Array.isArray(values)) {
                values = [values];
            }
            _this.values = values;
            return _this;
        }
        LogPayload.createForArguments = function (args) {
            var dumpedArguments = args.map(function (argument) {
                return ArgumentConverter.convertToPrimitive(argument).value;
            });
            return new this(dumpedArguments);
        };
        LogPayload.prototype.getType = function () {
            return 'log';
        };
        LogPayload.prototype.getContent = function () {
            return {
                values: this.values,
            };
        };
        return LogPayload;
    }(Payload));

    function randomInteger(minimum, maximum) {
        if (maximum === undefined) {
            maximum = minimum;
            minimum = 0;
        }
        if (typeof minimum !== 'number' || typeof maximum !== 'number') {
            throw new TypeError('Expected all arguments to be numbers');
        }
        return Math.floor(Math.random() * (maximum - minimum + 1) + minimum);
    }
    var sleep = function (seconds) {
        return usleep(seconds * 1000);
    };
    var usleep = function (milliseconds) {
        var start = new Date().getTime();
        while (new Date().getTime() < start + milliseconds) { }
    };
    var encodeHtmlEntities = function (str) {
        var escapeChars = {
            '¢': 'cent',
            '£': 'pound',
            '¥': 'yen',
            '€': 'euro',
            '©': 'copy',
            '®': 'reg',
            '<': 'lt',
            '>': 'gt',
            '"': 'quot',
            '&': 'amp',
            "'": '#39',
        };
        var chars = Object.keys(escapeChars);
        var regex = new RegExp("[".concat(chars.join(''), "]"), 'g');
        return str.replace(regex, function (m) { return "&".concat(escapeChars[m], ";"); });
    };
    var spacesToHtmlSpaces = function (spaces) {
        return '&nbsp;'.repeat(spaces.length);
    };
    var encodeNewLinesToHtml = function (str) {
        return str.replace(/(\r\n|\r|\n)/g, '<br>');
    };
    var formatHtmlForDisplay = function (html, options) {
        if (options === void 0) { options = { encodeEntities: true }; }
        if (options.encodeEntities) {
            html = encodeHtmlEntities(html);
        }
        return encodeNewLinesToHtml(html.replace(/^(\s+)/gm, function (m) { return "".concat(spacesToHtmlSpaces(m)); }));
    };
    var nonCryptoUuidV4 = function () {
        var v4options = {
            random: [
                randomInteger(1, 255),
                randomInteger(1, 255),
                randomInteger(1, 255),
                randomInteger(1, 255),
                randomInteger(1, 255),
                randomInteger(1, 255),
                randomInteger(1, 255),
                randomInteger(1, 255),
                randomInteger(1, 255),
                randomInteger(1, 255),
                randomInteger(1, 255),
                randomInteger(1, 255),
                randomInteger(1, 255),
                randomInteger(1, 255),
                randomInteger(1, 255),
                randomInteger(1, 255),
            ],
        };
        return uuid.v4(v4options).toString();
    };
    var end = function (arr) { return (arr.length ? arr[arr.length - 1] : false); };

    var MeasurePayload = (function (_super) {
        __extends(MeasurePayload, _super);
        function MeasurePayload(name, stopwatchEvent) {
            var _this = _super.call(this) || this;
            _this.isNewTimer = false;
            _this.totalTime = 0;
            _this.maxMemoryUsageDuringTotalTime = 0;
            _this.timeSinceLastCall = 0;
            _this.maxMemoryUsageSinceLastCall = 0;
            _this.name = name;
            _this.totalTime = stopwatchEvent.getDuration();
            _this.maxMemoryUsageDuringTotalTime = stopwatchEvent.getMemory();
            var periods = stopwatchEvent.getPeriods();
            if (periods.length > 1) {
                _this.timeSinceLastCall = end(periods);
                _this.maxMemoryUsageSinceLastCall = 0;
            }
            return _this;
        }
        MeasurePayload.prototype.getType = function () {
            return 'measure';
        };
        MeasurePayload.prototype.concernsNewTimer = function () {
            this.isNewTimer = true;
            this.totalTime = 0;
            this.maxMemoryUsageDuringTotalTime = 0;
            this.timeSinceLastCall = 0;
            this.maxMemoryUsageSinceLastCall = 0;
            return this;
        };
        MeasurePayload.prototype.getContent = function () {
            return {
                name: this.name,
                is_new_timer: this.isNewTimer,
                total_time: this.totalTime,
                max_memory_usage_during_total_time: this.maxMemoryUsageDuringTotalTime,
                time_since_last_call: this.timeSinceLastCall,
                max_memory_usage_since_last_call: this.maxMemoryUsageSinceLastCall,
            };
        };
        return MeasurePayload;
    }(Payload));

    /**
     * Utility function that works like `Object.apply`, but copies getters and setters properly as well.  Additionally gives
     * the option to exclude properties by name.
     */
    const copyProps = (dest, src, exclude = []) => {
        const props = Object.getOwnPropertyDescriptors(src);
        for (let prop of exclude)
            delete props[prop];
        Object.defineProperties(dest, props);
    };
    /**
     * Returns the full chain of prototypes up until Object.prototype given a starting object.  The order of prototypes will
     * be closest to farthest in the chain.
     */
    const protoChain = (obj, currentChain = [obj]) => {
        const proto = Object.getPrototypeOf(obj);
        if (proto === null)
            return currentChain;
        return protoChain(proto, [...currentChain, proto]);
    };
    /**
     * Identifies the nearest ancestor common to all the given objects in their prototype chains.  For most unrelated
     * objects, this function should return Object.prototype.
     */
    const nearestCommonProto = (...objs) => {
        if (objs.length === 0)
            return undefined;
        let commonProto = undefined;
        const protoChains = objs.map(obj => protoChain(obj));
        while (protoChains.every(protoChain => protoChain.length > 0)) {
            const protos = protoChains.map(protoChain => protoChain.pop());
            const potentialCommonProto = protos[0];
            if (protos.every(proto => proto === potentialCommonProto))
                commonProto = potentialCommonProto;
            else
                break;
        }
        return commonProto;
    };
    /**
     * Creates a new prototype object that is a mixture of the given prototypes.  The mixing is achieved by first
     * identifying the nearest common ancestor and using it as the prototype for a new object.  Then all properties/methods
     * downstream of this prototype (ONLY downstream) are copied into the new object.
     *
     * The resulting prototype is more performant than softMixProtos(...), as well as ES5 compatible.  However, it's not as
     * flexible as updates to the source prototypes aren't captured by the mixed result.  See softMixProtos for why you may
     * want to use that instead.
     */
    const hardMixProtos = (ingredients, constructor, exclude = []) => {
        var _a;
        const base = (_a = nearestCommonProto(...ingredients)) !== null && _a !== void 0 ? _a : Object.prototype;
        const mixedProto = Object.create(base);
        // Keeps track of prototypes we've already visited to avoid copying the same properties multiple times.  We init the
        // list with the proto chain below the nearest common ancestor because we don't want any of those methods mixed in
        // when they will already be accessible via prototype access.
        const visitedProtos = protoChain(base);
        for (let prototype of ingredients) {
            let protos = protoChain(prototype);
            // Apply the prototype chain in reverse order so that old methods don't override newer ones.
            for (let i = protos.length - 1; i >= 0; i--) {
                let newProto = protos[i];
                if (visitedProtos.indexOf(newProto) === -1) {
                    copyProps(mixedProto, newProto, ['constructor', ...exclude]);
                    visitedProtos.push(newProto);
                }
            }
        }
        mixedProto.constructor = constructor;
        return mixedProto;
    };
    const unique = (arr) => arr.filter((e, i) => arr.indexOf(e) == i);

    // Keeps track of constituent classes for every mixin class created by ts-mixer.
    const mixins = new Map();
    const getMixinsForClass = (clazz) => mixins.get(clazz);
    const registerMixins = (mixedClass, constituents) => mixins.set(mixedClass, constituents);

    const mergeObjectsOfDecorators = (o1, o2) => {
        var _a, _b;
        const allKeys = unique([...Object.getOwnPropertyNames(o1), ...Object.getOwnPropertyNames(o2)]);
        const mergedObject = {};
        for (let key of allKeys)
            mergedObject[key] = unique([...((_a = o1 === null || o1 === void 0 ? void 0 : o1[key]) !== null && _a !== void 0 ? _a : []), ...((_b = o2 === null || o2 === void 0 ? void 0 : o2[key]) !== null && _b !== void 0 ? _b : [])]);
        return mergedObject;
    };
    const mergePropertyAndMethodDecorators = (d1, d2) => {
        var _a, _b, _c, _d;
        return ({
            property: mergeObjectsOfDecorators((_a = d1 === null || d1 === void 0 ? void 0 : d1.property) !== null && _a !== void 0 ? _a : {}, (_b = d2 === null || d2 === void 0 ? void 0 : d2.property) !== null && _b !== void 0 ? _b : {}),
            method: mergeObjectsOfDecorators((_c = d1 === null || d1 === void 0 ? void 0 : d1.method) !== null && _c !== void 0 ? _c : {}, (_d = d2 === null || d2 === void 0 ? void 0 : d2.method) !== null && _d !== void 0 ? _d : {}),
        });
    };
    const mergeDecorators = (d1, d2) => {
        var _a, _b, _c, _d, _e, _f;
        return ({
            class: unique([...(_a = d1 === null || d1 === void 0 ? void 0 : d1.class) !== null && _a !== void 0 ? _a : [], ...(_b = d2 === null || d2 === void 0 ? void 0 : d2.class) !== null && _b !== void 0 ? _b : []]),
            static: mergePropertyAndMethodDecorators((_c = d1 === null || d1 === void 0 ? void 0 : d1.static) !== null && _c !== void 0 ? _c : {}, (_d = d2 === null || d2 === void 0 ? void 0 : d2.static) !== null && _d !== void 0 ? _d : {}),
            instance: mergePropertyAndMethodDecorators((_e = d1 === null || d1 === void 0 ? void 0 : d1.instance) !== null && _e !== void 0 ? _e : {}, (_f = d2 === null || d2 === void 0 ? void 0 : d2.instance) !== null && _f !== void 0 ? _f : {}),
        });
    };
    const decorators = new Map();
    const findAllConstituentClasses = (...classes) => {
        var _a;
        const allClasses = new Set();
        const frontier = new Set([...classes]);
        while (frontier.size > 0) {
            for (let clazz of frontier) {
                const protoChainClasses = protoChain(clazz.prototype).map(proto => proto.constructor);
                const mixinClasses = (_a = getMixinsForClass(clazz)) !== null && _a !== void 0 ? _a : [];
                const potentiallyNewClasses = [...protoChainClasses, ...mixinClasses];
                const newClasses = potentiallyNewClasses.filter(c => !allClasses.has(c));
                for (let newClass of newClasses)
                    frontier.add(newClass);
                allClasses.add(clazz);
                frontier.delete(clazz);
            }
        }
        return [...allClasses];
    };
    const deepDecoratorSearch = (...classes) => {
        const decoratorsForClassChain = findAllConstituentClasses(...classes)
            .map(clazz => decorators.get(clazz))
            .filter(decorators => !!decorators);
        if (decoratorsForClassChain.length == 0)
            return {};
        if (decoratorsForClassChain.length == 1)
            return decoratorsForClassChain[0];
        return decoratorsForClassChain.reduce((d1, d2) => mergeDecorators(d1, d2));
    };

    function Mixin(...constructors) {
        var _a, _b, _c;
        const prototypes = constructors.map(constructor => constructor.prototype);
        function MixedClass(...args) {
            for (const constructor of constructors)
                // @ts-ignore: potentially abstract class
                copyProps(this, new constructor(...args));
        }
        MixedClass.prototype = hardMixProtos(prototypes, MixedClass)
            ;
        Object.setPrototypeOf(MixedClass, hardMixProtos(constructors, null, ['prototype'])
            );
        let DecoratedMixedClass = MixedClass;
        {
            const classDecorators = deepDecoratorSearch(...constructors)
                ;
            for (let decorator of (_a = classDecorators === null || classDecorators === void 0 ? void 0 : classDecorators.class) !== null && _a !== void 0 ? _a : []) {
                const result = decorator(DecoratedMixedClass);
                if (result) {
                    DecoratedMixedClass = result;
                }
            }
            applyPropAndMethodDecorators((_b = classDecorators === null || classDecorators === void 0 ? void 0 : classDecorators.static) !== null && _b !== void 0 ? _b : {}, DecoratedMixedClass);
            applyPropAndMethodDecorators((_c = classDecorators === null || classDecorators === void 0 ? void 0 : classDecorators.instance) !== null && _c !== void 0 ? _c : {}, DecoratedMixedClass.prototype);
        }
        registerMixins(DecoratedMixedClass, constructors);
        return DecoratedMixedClass;
    }
    const applyPropAndMethodDecorators = (propAndMethodDecorators, target) => {
        const propDecorators = propAndMethodDecorators.property;
        const methodDecorators = propAndMethodDecorators.method;
        if (propDecorators)
            for (let key in propDecorators)
                for (let decorator of propDecorators[key])
                    decorator(target, key);
        if (methodDecorators)
            for (let key in methodDecorators)
                for (let decorator of methodDecorators[key])
                    decorator(target, key, Object.getOwnPropertyDescriptor(target, key));
    };

    var NewScreenPayload = (function (_super) {
        __extends(NewScreenPayload, _super);
        function NewScreenPayload(name) {
            var _this = _super.call(this) || this;
            _this.name = name;
            return _this;
        }
        NewScreenPayload.prototype.getType = function () {
            return 'new_screen';
        };
        NewScreenPayload.prototype.getContent = function () {
            return {
                name: this.name,
            };
        };
        return NewScreenPayload;
    }(Payload));

    var NotifyPayload = (function (_super) {
        __extends(NotifyPayload, _super);
        function NotifyPayload(text) {
            var _this = _super.call(this) || this;
            _this.text = text;
            return _this;
        }
        NotifyPayload.prototype.getType = function () {
            return 'notify';
        };
        NotifyPayload.prototype.getContent = function () {
            return {
                value: this.text,
            };
        };
        return NotifyPayload;
    }(Payload));

    var BoolPayload = (function (_super) {
        __extends(BoolPayload, _super);
        function BoolPayload(value) {
            var _this = _super.call(this) || this;
            _this.value = value;
            return _this;
        }
        BoolPayload.prototype.getType = function () {
            return 'custom';
        };
        BoolPayload.prototype.getContent = function () {
            return {
                content: this.value,
                label: 'Boolean',
            };
        };
        return BoolPayload;
    }(Payload));

    var NullPayload = (function (_super) {
        __extends(NullPayload, _super);
        function NullPayload() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        NullPayload.prototype.getType = function () {
            return 'custom';
        };
        NullPayload.prototype.getContent = function () {
            return {
                content: null,
                label: 'Null',
            };
        };
        return NullPayload;
    }(Payload));

    var PayloadFactory = (function () {
        function PayloadFactory(values) {
            this.values = values;
        }
        PayloadFactory.createForValues = function (args) {
            return new this(args).getPayloads();
        };
        PayloadFactory.registerPayloadFinder = function (callable) {
            this.payloadFinder = callable;
        };
        PayloadFactory.prototype.getPayloads = function () {
            var _this = this;
            return this.values.map(function (value) {
                return _this.getPayload(value);
            });
        };
        PayloadFactory.prototype.getPayload = function (value) {
            if (typeof value === 'boolean') {
                return new BoolPayload(value);
            }
            if (value === null) {
                return new NullPayload();
            }
            var convertedResult = ArgumentConverter.convertToPrimitive(value);
            if (convertedResult.isHtml) {
                return new HtmlPayload(convertedResult.value);
            }
            return new LogPayload(convertedResult.value);
        };
        PayloadFactory.payloadFinder = null;
        return PayloadFactory;
    }());

    var RayColors = (function () {
        function RayColors() {
        }
        RayColors.prototype.color = function (name) {
            return this;
        };
        RayColors.prototype.green = function () {
            return this.color('green');
        };
        RayColors.prototype.orange = function () {
            return this.color('orange');
        };
        RayColors.prototype.red = function () {
            return this.color('red');
        };
        RayColors.prototype.purple = function () {
            return this.color('purple');
        };
        RayColors.prototype.blue = function () {
            return this.color('blue');
        };
        RayColors.prototype.gray = function () {
            return this.color('gray');
        };
        return RayColors;
    }());

    var Settings = (function () {
        function Settings(settings) {
            this.enable = true;
            this._host = 'localhost';
            this._port = 23517;
            this._scheme = 'http';
            this.remote_path = null;
            this.local_path = null;
            this.always_send_raw_values = false;
            this.intercept_console_log = false;
            this.enabled_callback = null;
            this.sent_payload_callback = null;
            this.sending_payload_callback = null;
            this.originalSettings = Object.assign({}, settings);
            for (var prop in settings) {
                this[prop] = settings[prop];
            }
        }
        Object.defineProperty(Settings.prototype, "host", {
            get: function () {
                return this._host;
            },
            set: function (value) {
                this._host = value;
                Ray$1.useClient(new Client(this.port, this.host, this.scheme));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Settings.prototype, "port", {
            get: function () {
                return this._port;
            },
            set: function (value) {
                this._port = value;
                Ray$1.useClient(new Client(this.port, this.host, this.scheme));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Settings.prototype, "scheme", {
            get: function () {
                return this._scheme;
            },
            set: function (value) {
                this._scheme = value;
                Ray$1.useClient(new Client(this.port, this.host, this.scheme));
            },
            enumerable: false,
            configurable: true
        });
        Settings.prototype.toObject = function () {
            return this.originalSettings;
        };
        return Settings;
    }());

    var RaySizes = (function () {
        function RaySizes() {
        }
        RaySizes.prototype.size = function (size) {
            return this;
        };
        RaySizes.prototype.small = function () {
            return this.size('sm');
        };
        RaySizes.prototype.large = function () {
            return this.size('lg');
        };
        return RaySizes;
    }());

    var RemovePayload = (function (_super) {
        __extends(RemovePayload, _super);
        function RemovePayload() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        RemovePayload.prototype.getType = function () {
            return 'remove';
        };
        return RemovePayload;
    }(Payload));

    var Request = (function () {
        function Request(uuid, payloads, meta) {
            if (meta === void 0) { meta = []; }
            this.uuid = uuid;
            this.payloads = payloads;
            this.meta = meta;
        }
        Request.prototype.toArray = function () {
            return {
                uuid: this.uuid,
                payloads: this.payloads.map(function (payload) { return payload.toArray(); }),
                meta: this.meta,
            };
        };
        Request.prototype.toJson = function () {
            return JSON.stringify(this.toArray());
        };
        return Request;
    }());

    var ShowAppPayload = (function (_super) {
        __extends(ShowAppPayload, _super);
        function ShowAppPayload() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ShowAppPayload.prototype.getType = function () {
            return 'show_app';
        };
        return ShowAppPayload;
    }(Payload));

    var SizePayload = (function (_super) {
        __extends(SizePayload, _super);
        function SizePayload(size) {
            var _this = _super.call(this) || this;
            _this.size = size;
            return _this;
        }
        SizePayload.prototype.getType = function () {
            return 'size';
        };
        SizePayload.prototype.getContent = function () {
            return {
                size: this.size,
            };
        };
        return SizePayload;
    }(Payload));

    var StopwatchEvent = (function () {
        function StopwatchEvent(sw, lapTime) {
            if (lapTime === void 0) { lapTime = null; }
            var _a;
            this.laps = [];
            this.name = (_a = sw.name) === null || _a === void 0 ? void 0 : _a.slice(0);
            this.laps = sw.laps.slice(0);
            this.startedAt = sw.startedAt;
            this.endedAt = sw.endedAt;
            this.lapTime = lapTime !== null && lapTime !== void 0 ? lapTime : new Date().getTime();
        }
        StopwatchEvent.prototype.getDuration = function () {
            return this.laps.reduce(function (prev, cur) { return cur + prev; }, 0);
        };
        StopwatchEvent.prototype.getMemory = function () {
            return 0;
        };
        StopwatchEvent.prototype.getPeriods = function () {
            return this.laps.slice();
        };
        StopwatchEvent.prototype.getPreviousDuration = function () {
            return end(this.laps) - (new Date().getTime() - this.lapTime);
        };
        return StopwatchEvent;
    }());

    var Stopwatch = (function () {
        function Stopwatch(name) {
            if (name === void 0) { name = undefined; }
            this.laps = [];
            this.startedAt = 0;
            this.endedAt = 0;
            this.name = name;
            this.sw = new stopwatchNode.StopWatch(name);
            this.laps = [];
            this.startedAt = 0;
            this.endedAt = 0;
        }
        Stopwatch.prototype.initialize = function (name) {
            this.name = name;
            this.sw = new stopwatchNode.StopWatch(name);
            this.laps = [];
            this.startedAt = 0;
            this.endedAt = 0;
        };
        Stopwatch.prototype.start = function (name) {
            this.startedAt = new Date().getTime();
            this.sw.start(name);
            return new StopwatchEvent(this);
        };
        Stopwatch.prototype.lap = function () {
            var lapTime = new Date().getTime();
            var duration = lapTime - this.startedAt;
            this.laps.push(duration - this.totalDuration());
            return new StopwatchEvent(this, lapTime);
        };
        Stopwatch.prototype.stop = function () {
            this.sw.stop();
            this.endedAt = new Date().getTime();
            var duration = this.endedAt - this.startedAt;
            this.laps.push(duration - this.totalDuration());
            return new StopwatchEvent(this);
        };
        Stopwatch.prototype.totalDuration = function () {
            return this.laps.reduce(function (prev, cur) {
                return cur + prev;
            }, 0);
        };
        Stopwatch.prototype.reset = function () {
            this.initialize(this.name);
            return this;
        };
        Stopwatch.prototype.getLaps = function () {
            return this.laps;
        };
        return Stopwatch;
    }());

    var TablePayload = (function (_super) {
        __extends(TablePayload, _super);
        function TablePayload(values, label) {
            if (label === void 0) { label = 'Table'; }
            var _this = _super.call(this) || this;
            _this.values = values;
            _this.label = label;
            return _this;
        }
        TablePayload.prototype.getType = function () {
            return 'table';
        };
        TablePayload.prototype.getContent = function () {
            var values = this.getValues();
            return {
                values: values,
                label: this.label,
            };
        };
        TablePayload.prototype.getValues = function () {
            if (Array.isArray(this.values)) {
                return this.values.map(function (item) {
                    return ArgumentConverter.convertToPrimitive(item).value;
                });
            }
            var values = {};
            for (var prop in this.values) {
                values[prop] = ArgumentConverter.convertToPrimitive(this.values[prop]).value;
            }
            return values;
        };
        return TablePayload;
    }(Payload));

    var TracePayload = (function (_super) {
        __extends(TracePayload, _super);
        function TracePayload(frames) {
            var _this = _super.call(this) || this;
            _this.startFromIndexNum = null;
            _this.limitNum = null;
            _this.frames = RemovesRayFrames.removeRayFrames(frames);
            return _this;
        }
        TracePayload.prototype.startFromIndex = function (index) {
            this.startFromIndexNum = index;
            return this;
        };
        TracePayload.prototype.limit = function (limit) {
            this.limitNum = limit;
            return this;
        };
        TracePayload.prototype.getType = function () {
            return 'trace';
        };
        TracePayload.prototype.getContent = function () {
            var _this = this;
            var _a;
            var frames = this.frames.map(function (frame) {
                var funcNameParts = frame.getFunctionName().replace('Proxy.', '').split('.').slice(0);
                var className = funcNameParts.length ? funcNameParts.shift() : '';
                var methodName = funcNameParts.join('.');
                return {
                    file_name: _this.replaceRemotePathWithLocalPath(frame.getFileName()),
                    line_number: frame.getLineNumber(),
                    class: className,
                    method: methodName,
                    vendor_frame: frame.getFileName().includes('node_modules'),
                };
            });
            if (this.limitNum !== null) {
                frames = frames.slice((_a = this.startFromIndexNum) !== null && _a !== void 0 ? _a : 0, this.limitNum);
            }
            return { frames: frames };
        };
        return TracePayload;
    }(Payload));

    var XmlPayload = (function (_super) {
        __extends(XmlPayload, _super);
        function XmlPayload(value) {
            var _this = _super.call(this) || this;
            _this.value = value;
            return _this;
        }
        XmlPayload.prototype.getType = function () {
            return 'custom';
        };
        XmlPayload.prototype.getContent = function () {
            var content = this.formatXmlForDisplay(this.value);
            return {
                content: content,
                label: 'XML',
            };
        };
        XmlPayload.prototype.formatXmlForDisplay = function (xml) {
            var content = this.formatAndIndentXml(xml);
            return this.encodeXml(content);
        };
        XmlPayload.prototype.encodeXml = function (xml) {
            return formatHtmlForDisplay(xml, { encodeEntities: true });
        };
        XmlPayload.prototype.formatAndIndentXml = function (xml) {
            return formatXml(xml.toString(), {
                indentation: '    ',
                collapseContent: true,
                lineSeparator: '\n',
            });
        };
        return XmlPayload;
    }(Payload));

    var HtmlMarkupPayload = (function (_super) {
        __extends(HtmlMarkupPayload, _super);
        function HtmlMarkupPayload(value, options) {
            if (options === void 0) { options = { highlight: 'none' }; }
            var _this = _super.call(this) || this;
            _this.value = value;
            _this.options = options;
            return _this;
        }
        HtmlMarkupPayload.prototype.getType = function () {
            return 'custom';
        };
        HtmlMarkupPayload.prototype.getContent = function () {
            var content = this.formatMarkupForDisplay(this.value);
            return {
                content: content,
                label: 'Markup',
            };
        };
        HtmlMarkupPayload.prototype.formatMarkupForDisplay = function (markup) {
            var content = this.formatAndIndentMarkup(markup);
            return this.highlightHtmlMarkup(formatHtmlForDisplay(content, { encodeEntities: true }));
        };
        HtmlMarkupPayload.prototype.formatAndIndentMarkup = function (markup) {
            return formatXml(markup.toString(), {
                indentation: '    ',
                collapseContent: true,
                lineSeparator: '\n',
            });
        };
        HtmlMarkupPayload.prototype.highlightHtmlMarkup = function (markup) {
            return markup
                .replace(/&quot;/g, '"')
                .replace(/="([^"]+)"/g, "=<span style='color:#16A34A;'>&quot;$1&quot;</span>")
                .replace(/(&lt;[A-Za-z\d-]+)(\s|&nbsp;|&gt;)/g, '<span style="color:#1D4ED8;">$1</span>$2')
                .replace(/(&lt;\/[A-Za-z\d-]+)(&gt;)/g, '<span style="color:#1D4ED8;">$1$2</span>');
        };
        return HtmlMarkupPayload;
    }(Payload));

    var TextPayload = (function (_super) {
        __extends(TextPayload, _super);
        function TextPayload(text) {
            var _this = _super.call(this) || this;
            _this.text = text;
            return _this;
        }
        TextPayload.prototype.getType = function () {
            return 'custom';
        };
        TextPayload.prototype.getContent = function () {
            return {
                content: this.formatContent(),
                label: 'Text',
            };
        };
        TextPayload.prototype.formatContent = function () {
            return formatHtmlForDisplay(this.text, { encodeEntities: true });
        };
        return TextPayload;
    }(Payload));

    var CacheStore = (function () {
        function CacheStore(clock) {
            this.store = [];
            this.clock = clock;
        }
        CacheStore.prototype.hit = function () {
            this.store.push(this.clock.now());
            return this;
        };
        CacheStore.prototype.clear = function () {
            this.store = [];
            return this;
        };
        CacheStore.prototype.count = function () {
            return this.store.length;
        };
        CacheStore.prototype.countLastSecond = function () {
            var _this = this;
            var lastSecond = this.clock.now().modify('-1 second');
            var amount = 0;
            this.store.forEach(function (item) {
                if (_this.isBetween(item, lastSecond, _this.clock.now())) {
                    amount++;
                }
            });
            return amount;
        };
        CacheStore.prototype.isBetween = function (toCheck, start, end) {
            return toCheck.getTimestamp() >= start.getTimestamp() && toCheck.getTimestamp() <= end.getTimestamp();
        };
        return CacheStore;
    }());

    var Clock = (function () {
        function Clock() {
        }
        return Clock;
    }());

    var DateImmutable = (function () {
        function DateImmutable(date) {
            if (date === void 0) { date = null; }
            this.date = date !== null && date !== void 0 ? date : new Date();
            this.dateStr = this.date.toISOString();
            this.dateTs = this.date.getTime();
        }
        Object.defineProperty(DateImmutable.prototype, "date", {
            get: function () {
                return dayjs(this.dateStr).toDate();
            },
            set: function (value) {
                this.dateTs = value.getTime();
                this.dateStr = value.toISOString();
            },
            enumerable: false,
            configurable: true
        });
        DateImmutable.createFrom = function (date) {
            return new DateImmutable(date);
        };
        DateImmutable.prototype.getTimestamp = function () {
            return Math.floor(this.dateTs / 1000);
        };
        DateImmutable.prototype.modify = function (str) {
            var strParts = str.split(' ');
            var parts = [];
            for (var idx = 0; idx < strParts.length; idx++) {
                parts.push({
                    value: Number(strParts[idx]),
                    unit: strParts[idx + 1],
                });
                idx++;
            }
            var tempDate = dayjs(this.getTimestamp() * 1000);
            parts.forEach(function (part) {
                tempDate = tempDate.add(part.value * 1000);
            });
            return DateImmutable.createFrom(tempDate.toDate());
        };
        return DateImmutable;
    }());

    var SystemClock = (function (_super) {
        __extends(SystemClock, _super);
        function SystemClock() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        SystemClock.prototype.now = function () {
            return new DateImmutable();
        };
        return SystemClock;
    }(Clock));

    var RateLimiter = (function () {
        function RateLimiter(maxCalls, maxPerSecond) {
            if (maxCalls === void 0) { maxCalls = null; }
            if (maxPerSecond === void 0) { maxPerSecond = null; }
            this.notified = false;
            this.maxCalls = maxCalls;
            this.maxPerSecond = maxPerSecond;
            this.cache = new CacheStore(new SystemClock());
        }
        RateLimiter.disabled = function () {
            return new RateLimiter(null, null);
        };
        RateLimiter.prototype.hit = function () {
            this.cache.hit();
            return this;
        };
        RateLimiter.prototype.max = function (maxCalls) {
            if (maxCalls === void 0) { maxCalls = null; }
            this.maxCalls = maxCalls;
            return this;
        };
        RateLimiter.prototype.perSecond = function (callsPerSecond) {
            if (callsPerSecond === void 0) { callsPerSecond = null; }
            this.maxPerSecond = callsPerSecond;
            return this;
        };
        RateLimiter.prototype.isMaxReached = function () {
            if (this.maxCalls === null) {
                return false;
            }
            var reached = this.cache.count() >= this.maxCalls;
            if (!reached) {
                this.notified = false;
            }
            return reached;
        };
        RateLimiter.prototype.isMaxPerSecondReached = function () {
            if (this.maxPerSecond === null) {
                return false;
            }
            var reached = this.cache.countLastSecond() >= this.maxPerSecond;
            if (reached === false) {
                this.notified = false;
            }
            return reached;
        };
        RateLimiter.prototype.clear = function () {
            this.maxCalls = null;
            this.maxPerSecond = null;
            this.cache.clear();
            return this;
        };
        RateLimiter.prototype.isNotified = function () {
            return this.notified;
        };
        RateLimiter.prototype.notify = function () {
            this.notified = true;
        };
        RateLimiter.prototype.getCache = function () {
            return this.cache;
        };
        return RateLimiter;
    }());

    var Limiters = (function () {
        function Limiters() {
            this.counters = {};
        }
        Limiters.prototype.initialize = function (origin, limit) {
            var fingerprint = "".concat(origin.file, ":").concat(origin.line_number);
            if (typeof this.counters[fingerprint] === 'undefined') {
                this.counters[fingerprint] = { counter: 0, limit: limit, valid: true };
            }
            return this.counters[fingerprint];
        };
        Limiters.prototype.increment = function (origin) {
            var name = "".concat(origin.file, ":").concat(origin.line_number);
            if (typeof this.counters[name] === 'undefined') {
                return { counter: 0, limit: 0, valid: false };
            }
            var _a = this.counters[name], counter = _a.counter, limit = _a.limit, valid = _a.valid;
            this.counters[name] = { counter: counter + 1, limit: limit, valid: valid };
            return this.counters[name];
        };
        Limiters.prototype.canSendPayload = function (origin) {
            var name = "".concat(origin.file, ":").concat(origin.line_number);
            if (typeof this.counters[name] === 'undefined') {
                return true;
            }
            var _a = this.counters[name], counter = _a.counter, limit = _a.limit, valid = _a.valid;
            return valid && (counter < limit || limit <= 0);
        };
        return Limiters;
    }());

    var LabelPayload = (function (_super) {
        __extends(LabelPayload, _super);
        function LabelPayload(label) {
            var _this = _super.call(this) || this;
            _this.label = label;
            return _this;
        }
        LabelPayload.prototype.getType = function () {
            return 'label';
        };
        LabelPayload.prototype.getContent = function () {
            return {
                label: this.label,
            };
        };
        return LabelPayload;
    }(Payload));

    var SeparatorPayload = (function (_super) {
        __extends(SeparatorPayload, _super);
        function SeparatorPayload() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        SeparatorPayload.prototype.getType = function () {
            return 'separator';
        };
        return SeparatorPayload;
    }(Payload));

    var ScreenColorPayload = (function (_super) {
        __extends(ScreenColorPayload, _super);
        function ScreenColorPayload(color) {
            var _this = _super.call(this) || this;
            _this.color = color;
            return _this;
        }
        ScreenColorPayload.prototype.getType = function () {
            return 'screen_color';
        };
        ScreenColorPayload.prototype.getContent = function () {
            return {
                color: this.color,
            };
        };
        return ScreenColorPayload;
    }(Payload));

    var Ray$1 = (function (_super) {
        __extends(Ray, _super);
        function Ray(settings, client, uuid, inCallback) {
            if (client === void 0) { client = null; }
            if (uuid === void 0) { uuid = null; }
            if (inCallback === void 0) { inCallback = false; }
            var _this = this;
            var _a, _b, _c;
            _this = _super.call(this) || this;
            _this.inCallback = false;
            _this.limitOrigin = null;
            _this.canSendPayload = true;
            if (Ray.defaultSettings.not_defined === true) {
                Ray.defaultSettings = {
                    enable: true,
                    host: 'localhost',
                    port: 23517,
                    scheme: 'http',
                    local_path: null,
                    remote_path: null,
                    always_send_raw_values: false,
                    enabled_callback: null,
                    sending_payload_callback: null,
                    sent_payload_callback: null,
                    not_defined: false,
                };
            }
            _this.inCallback = inCallback;
            _this.settings = new Settings(Ray.defaultSettings);
            if (Ray.enabled === null) {
                Ray.enabled = _this.settings.enable !== false;
            }
            Ray.client = (_a = client !== null && client !== void 0 ? client : Ray.client) !== null && _a !== void 0 ? _a : new Client(_this.settings.port, _this.settings.host);
            Ray._rateLimiter = (_b = Ray._rateLimiter) !== null && _b !== void 0 ? _b : RateLimiter.disabled();
            _this.uuid = (_c = uuid !== null && uuid !== void 0 ? uuid : Ray.fakeUuid) !== null && _c !== void 0 ? _c : nonCryptoUuidV4();
            if (_this.settings.intercept_console_log && !_this.interceptor().active()) {
                _this.interceptor().enable();
            }
            _this.loadMacros();
            return _this;
        }
        Ray.create = function (client, uuid) {
            if (client === void 0) { client = null; }
            if (uuid === void 0) { uuid = null; }
            if (Ray.defaultSettings.not_defined === true) {
                Ray.defaultSettings = {
                    enable: true,
                    host: 'localhost',
                    port: 23517,
                    scheme: 'http',
                    local_path: null,
                    remote_path: null,
                    always_send_raw_values: false,
                    not_defined: false,
                    intercept_console_log: false,
                    enabled_callback: null,
                    sending_payload_callback: null,
                    sent_payload_callback: null,
                };
            }
            var settings = new Settings(Ray.defaultSettings);
            return new this(settings, client, uuid);
        };
        Ray.useDefaultSettings = function (settings) {
            if (Ray.defaultSettings.not_defined === true) {
                Ray.defaultSettings = {
                    enable: true,
                    host: 'localhost',
                    port: 23517,
                    scheme: 'http',
                    local_path: null,
                    remote_path: null,
                    always_send_raw_values: false,
                    enabled_callback: null,
                    sending_payload_callback: null,
                    sent_payload_callback: null,
                    not_defined: false,
                };
            }
            Ray.defaultSettings = Object.assign({}, Ray.defaultSettings, settings);
            Ray.defaultSettings.not_defined = false;
            Ray.client = new Client(this.defaultSettings.port, this.defaultSettings.host);
            return this;
        };
        Ray.prototype.loadMacros = function () {
            for (var name_1 in Ray.macros) {
                var handler = Ray.macros[name_1];
                this[name_1] = handler.bind(this);
            }
            return this;
        };
        Ray.prototype.interceptor = function () {
            return Ray.interceptor;
        };
        Ray.prototype.client = function () {
            return Ray.client;
        };
        Ray.prototype.enable = function () {
            Ray.enabled = true;
            return this;
        };
        Ray.prototype.disable = function () {
            Ray.enabled = false;
            return this;
        };
        Ray.prototype.enabled = function () {
            if (typeof this.settings.enabled_callback === 'function') {
                return Ray.enabled && this.settings.enabled_callback();
            }
            return Ray.enabled;
        };
        Ray.prototype.disabled = function () {
            return !this.enabled();
        };
        Ray.useClient = function (client) {
            this.client = client;
        };
        Ray.prototype.project = function (projectName) {
            Ray.projectName = projectName;
            return this;
        };
        Ray.prototype.newScreen = function (name) {
            if (name === void 0) { name = ''; }
            var payload = new NewScreenPayload(name);
            return this.sendRequest(payload);
        };
        Ray.prototype.clearAll = function () {
            var payload = new ClearAllPayload();
            return this.sendRequest(payload);
        };
        Ray.prototype.clearScreen = function () {
            return this.newScreen();
        };
        Ray.prototype.color = function (color) {
            var payload = new ColorPayload(color);
            return this.sendRequest(payload);
        };
        Ray.prototype.confetti = function () {
            var payload = new ConfettiPayload();
            return this.sendRequest(payload);
        };
        Ray.prototype.screenColor = function (color) {
            var payload = new ScreenColorPayload(color);
            return this.sendRequest(payload);
        };
        Ray.prototype.label = function (label) {
            var payload = new LabelPayload(label);
            return this.sendRequest(payload);
        };
        Ray.prototype.size = function (size) {
            var payload = new SizePayload(size);
            return this.sendRequest(payload);
        };
        Ray.prototype.remove = function () {
            var payload = new RemovePayload();
            return this.sendRequest(payload);
        };
        Ray.prototype.hide = function () {
            var payload = new HidePayload();
            return this.sendRequest(payload);
        };
        Ray.prototype.notify = function (text) {
            var payload = new NotifyPayload(text);
            return this.sendRequest(payload);
        };
        Ray.prototype.toJson = function () {
            var values = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                values[_i] = arguments[_i];
            }
            var payloads = values.map(function (value) { return new JsonStringPayload(value); });
            return this.sendRequest(payloads);
        };
        Ray.prototype.json = function () {
            var jsons = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                jsons[_i] = arguments[_i];
            }
            var payloads = jsons.map(function (json) { return new DecodedJsonPayload(json); });
            return this.sendRequest(payloads);
        };
        Ray.prototype.file = function (filename) {
            console.error("file() unsupport on web (".concat(filename, ")"));
            return this;
        };
        Ray.prototype.image = function (location) {
            var payload = new ImagePayload(location);
            return this.sendRequest(payload);
        };
        Ray.prototype.die = function (status) {
            if (status === void 0) { status = ''; }
            throw new Error("Ray.die() called: ".concat(status ? status : 'no message'));
        };
        Ray.prototype.className = function (object) {
            return this.send(object.constructor.name);
        };
        Ray.prototype.error = function (err) {
            var payload = new ErrorPayload(err, 'Error');
            this.sendRequest(payload);
            this.red();
            return this;
        };
        Ray.prototype.event = function (eventName, data) {
            if (data === void 0) { data = []; }
            var payload = new EventPayload(eventName, data);
            return this.sendRequest(payload);
        };
        Ray.prototype.exception = function (err, meta) {
            if (meta === void 0) { meta = {}; }
            var payload = new ExceptionPayload(err, meta);
            this.sendRequest(payload);
            this.red();
            return this;
        };
        Ray.prototype.showWhen = function (booleanOrCallable) {
            if (typeof booleanOrCallable === 'function') {
                booleanOrCallable = booleanOrCallable();
            }
            if (!booleanOrCallable) {
                this.remove();
            }
            return this;
        };
        Ray.prototype.showIf = function (booleanOrCallable) {
            return this.showWhen(booleanOrCallable);
        };
        Ray.prototype.removeWhen = function (booleanOrCallable) {
            if (typeof booleanOrCallable === 'function') {
                booleanOrCallable = booleanOrCallable();
            }
            if (booleanOrCallable) {
                this.remove();
            }
            return this;
        };
        Ray.prototype.removeIf = function (booleanOrCallable) {
            return this.removeWhen(booleanOrCallable);
        };
        Ray.prototype.ban = function () {
            return this.send('🕶');
        };
        Ray.prototype.charles = function () {
            return this.send('🎶 🎹 🎷 🕺');
        };
        Ray.prototype.table = function (values, label) {
            if (label === void 0) { label = 'Table'; }
            var payload = new TablePayload(values, label);
            return this.sendRequest(payload);
        };
        Ray.prototype.count = function (name) {
            var _a, _b, _c;
            if (name === void 0) { name = null; }
            var fingerprint = md5("".concat((_a = this.getCaller()) === null || _a === void 0 ? void 0 : _a.getFileName()).concat((_b = this.getCaller()) === null || _b === void 0 ? void 0 : _b.getLineNumber()));
            var _d = Ray.counters.increment((_c = name !== null && name !== void 0 ? name : fingerprint) !== null && _c !== void 0 ? _c : 'none'), ray = _d[0], times = _d[1];
            var message = "Called ";
            if (name) {
                message += "'".concat(name, "' ");
            }
            message += "".concat(times, " ").concat(times === 1 ? 'time' : 'times', ".");
            ray.sendCustom(message, 'Count');
            return ray;
        };
        Ray.prototype.clearCounters = function () {
            Ray.counters.clear();
            return this;
        };
        Ray.prototype.pause = function () {
            return __awaiter(this, void 0, void 0, function () {
                var lockName, payload;
                var _this = this;
                return __generator(this, function (_a) {
                    Ray.lockCounter++;
                    lockName = md5("".concat(new Date().getTime(), "-").concat(Ray.lockCounter));
                    payload = new CreateLockPayload(lockName);
                    this.sendRequest(payload);
                    return [2, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                            var exists, err_1;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        sleep(1);
                                        _a.label = 1;
                                    case 1:
                                        _a.trys.push([1, 3, , 4]);
                                        return [4, Ray.client.lockExists(lockName)];
                                    case 2:
                                        exists = _a.sent();
                                        return [3, 4];
                                    case 3:
                                        err_1 = _a.sent();
                                        reject(err_1);
                                        return [2, false];
                                    case 4:
                                        if (exists !== true && exists && exists.stop_execution) {
                                            reject(false);
                                            return [2, false];
                                        }
                                        _a.label = 5;
                                    case 5:
                                        if (exists.active) return [3, 0];
                                        _a.label = 6;
                                    case 6:
                                        resolve(this);
                                        return [2];
                                }
                            });
                        }); })];
                });
            });
        };
        Ray.prototype.stopTime = function (stopwatchName) {
            if (stopwatchName === void 0) { stopwatchName = ''; }
            if (stopwatchName === '') {
                Ray.stopWatches = {};
                return this;
            }
            if (typeof Ray.stopWatches[stopwatchName] !== 'undefined') {
                delete Ray.stopWatches[stopwatchName];
            }
            return this;
        };
        Ray.prototype.caller = function () {
            var backtrace = StackTrace.getSync();
            var payload = new CallerPayload(backtrace);
            return this.sendRequest(payload);
        };
        Ray.prototype.trace = function () {
            var backtrace = StackTrace.getSync();
            var payload = new TracePayload(backtrace);
            return this.sendRequest(payload);
        };
        Ray.prototype.measure = function (stopwatchName) {
            if (stopwatchName === void 0) { stopwatchName = 'default'; }
            if (stopwatchName instanceof Function) {
                return this.measureClosure(stopwatchName);
            }
            if (typeof Ray.stopWatches[stopwatchName] === 'undefined') {
                var stopwatch_1 = this.getStopwatch(stopwatchName);
                Ray.stopWatches[stopwatchName] = stopwatch_1;
                var event_1 = stopwatch_1.start(stopwatchName);
                var payload_1 = this.getMeasurePayload(stopwatchName, event_1);
                payload_1.concernsNewTimer();
                return this.sendRequest(payload_1);
            }
            var stopwatch = Ray.stopWatches[stopwatchName];
            var event = stopwatch.lap();
            var payload = this.getMeasurePayload(stopwatchName, event);
            return this.sendRequest(payload);
        };
        Ray.prototype.measureClosure = function (closure) {
            var stopwatch = this.getStopwatch('closure');
            stopwatch.start('closure');
            closure();
            var event = stopwatch.stop();
            var payload = this.getMeasurePayload('closure', event);
            return this.sendRequest(payload);
        };
        Ray.prototype.getStopwatch = function (name) {
            return new Stopwatch(name);
        };
        Ray.prototype.getMeasurePayload = function (name, event) {
            return new MeasurePayload(name, event);
        };
        Ray.prototype.separator = function () {
            var payload = new SeparatorPayload();
            return this.sendRequest(payload);
        };
        Ray.prototype.xml = function (xml) {
            var payload = new XmlPayload(xml);
            return this.sendRequest(payload);
        };
        Ray.prototype.html = function (html) {
            if (html === void 0) { html = ''; }
            var payload = new HtmlPayload(html);
            return this.sendRequest(payload);
        };
        Ray.prototype.text = function (text) {
            if (text === void 0) { text = ''; }
            var payload = new TextPayload(text);
            return this.sendRequest(payload);
        };
        Ray.prototype.date = function (date) {
            var payload = new DatePayload(date);
            return this.sendRequest(payload);
        };
        Ray.prototype.raw = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (!args.length) {
                return this;
            }
            var payloads = args.map(function (arg) { return LogPayload.createForArguments([arg]); });
            return this.sendRequest(payloads);
        };
        Ray.prototype.send = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (!args.length) {
                return this;
            }
            if (this.settings.always_send_raw_values) {
                return this.raw.apply(this, args);
            }
            var payloads = PayloadFactory.createForValues(args);
            return this.sendRequest(payloads);
        };
        Ray.prototype.pass = function (argument) {
            this.send(argument);
            return argument;
        };
        Ray.prototype.showApp = function () {
            var payload = new ShowAppPayload();
            return this.sendRequest(payload);
        };
        Ray.prototype.hideApp = function () {
            var payload = new HideAppPayload();
            return this.sendRequest(payload);
        };
        Ray.prototype.macro = function (name, handler) {
            Ray.macros[name] = handler;
            this[name] = handler.bind(this);
            return this;
        };
        Ray.prototype.htmlMarkup = function (html, options) {
            if (options === void 0) { options = {}; }
            var payload = new HtmlMarkupPayload(html, options);
            return this.sendRequest(payload);
        };
        Ray.prototype.if = function (boolOrCallable, callback) {
            if (callback === void 0) { callback = null; }
            if (typeof boolOrCallable === 'function') {
                boolOrCallable = boolOrCallable();
            }
            if (boolOrCallable && callback !== null) {
                callback(this);
            }
            if (callback === null) {
                this.canSendPayload = boolOrCallable;
            }
            return this;
        };
        Ray.prototype.limit = function (count) {
            var frame = this.getOriginFrame();
            this.limitOrigin = {
                function_name: frame === null || frame === void 0 ? void 0 : frame.getFunctionName(),
                file: frame === null || frame === void 0 ? void 0 : frame.getFileName(),
                line_number: frame === null || frame === void 0 ? void 0 : frame.getLineNumber(),
                hostname: Hostname.get(),
            };
            Ray.limiters.initialize(this.limitOrigin, count);
            return this;
        };
        Ray.prototype.once = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var frame = this.getOriginFrame();
            this.limitOrigin = {
                function_name: frame === null || frame === void 0 ? void 0 : frame.getFunctionName(),
                file: frame === null || frame === void 0 ? void 0 : frame.getFileName(),
                line_number: frame === null || frame === void 0 ? void 0 : frame.getLineNumber(),
                hostname: Hostname.get(),
            };
            Ray.limiters.initialize(this.limitOrigin, 1);
            if (args.length > 0) {
                return this.send.apply(this, args);
            }
            return this;
        };
        Ray.prototype.sendCustom = function (content, label) {
            if (label === void 0) { label = ''; }
            var payload = new CustomPayload(content, label);
            return this.sendRequest(payload);
        };
        Ray.prototype.getOriginFrame = function () {
            var st = StackTrace.getSync();
            var startFrameIndex = st.findIndex(function (frame) { var _a; return (_a = frame.functionName) === null || _a === void 0 ? void 0 : _a.includes('Ray.sendRequest'); });
            if (startFrameIndex === -1) {
                startFrameIndex = 0;
            }
            var callerFrames = RemovesRayFrames.removeRayFrames(st.slice(startFrameIndex).filter(function (frame) { var _a; return !((_a = frame.functionName) === null || _a === void 0 ? void 0 : _a.includes('Ray.')); }));
            return callerFrames.slice(0).shift();
        };
        Ray.prototype.getCaller = function () {
            var st = StackTrace.getSync();
            var startFrameIndex = st.findIndex(function (frame) { var _a; return (_a = frame.functionName) === null || _a === void 0 ? void 0 : _a.includes('Ray.getCaller'); });
            if (startFrameIndex === -1) {
                startFrameIndex = 0;
            }
            var callerFrames = st.slice(startFrameIndex);
            if (callerFrames.length === 1) {
                return callerFrames.shift();
            }
            return callerFrames.slice(2).shift();
        };
        Ray.prototype.getOriginData = function () {
            var frame = this.getOriginFrame();
            return {
                function_name: frame === null || frame === void 0 ? void 0 : frame.getFunctionName(),
                file: frame === null || frame === void 0 ? void 0 : frame.getFileName(),
                line_number: frame === null || frame === void 0 ? void 0 : frame.getLineNumber(),
                hostname: Hostname.get(),
            };
        };
        Ray.prototype.sendRequest = function (payloads, meta) {
            var _this = this;
            var _a;
            if (meta === void 0) { meta = []; }
            if (!this.enabled()) {
                return this;
            }
            if (!this.canSendPayload) {
                return this;
            }
            if (this.limitOrigin !== null) {
                if (!Ray.limiters.canSendPayload(this.limitOrigin)) {
                    return this;
                }
                Ray.limiters.increment(this.limitOrigin);
            }
            if (!Array.isArray(payloads)) {
                payloads = [payloads];
            }
            if (this.rateLimiter().isMaxReached() || this.rateLimiter().isMaxPerSecondReached()) {
                this.notifyWhenRateLimitReached();
                return this;
            }
            var allMeta = Object.assign({}, {
                node_ray_package_version: PACKAGE_VERSION,
                project_name: Ray.projectName,
            }, meta);
            payloads.forEach(function (payload) {
                payload.data.origin = _this.getOriginData();
                payload.remotePath = _this.settings.remote_path;
                payload.localPath = _this.settings.local_path;
            });
            if (this.settings.sending_payload_callback !== null && !this.inCallback) {
                this.inCallback = true;
                this.settings.sending_payload_callback(new Ray(this.settings, this.client(), this.uuid, true), payloads);
                this.inCallback = false;
            }
            var request = new Request(this.uuid, payloads, allMeta);
            (_a = Ray.client) === null || _a === void 0 ? void 0 : _a.send(request);
            this.rateLimiter().hit();
            if (this.settings.sent_payload_callback !== null && !this.inCallback) {
                this.inCallback = true;
                this.settings.sent_payload_callback(this);
                this.inCallback = false;
            }
            return this;
        };
        Ray.prototype.rateLimiter = function () {
            return Ray._rateLimiter;
        };
        Ray.prototype.notifyWhenRateLimitReached = function () {
            if (this.rateLimiter().isNotified()) {
                return;
            }
            var customPayload = new CustomPayload('Rate limit has been reached...', 'Rate limit');
            var request = new Request(this.uuid, [customPayload], []);
            Ray.client.send(request);
            this.rateLimiter().notify();
        };
        Ray.lockCounter = 0;
        Ray.defaultSettings = { not_defined: true };
        Ray.projectName = '';
        Ray.counters = new Counters();
        Ray.limiters = new Limiters();
        Ray.interceptor = new ConsoleInterceptor();
        Ray.stopWatches = {};
        Ray.enabled = null;
        Ray.macros = {};
        Ray._rateLimiter = RateLimiter.disabled();
        return Ray;
    }(Mixin(RayColors, RaySizes)));
    var ray$2 = function () {
        var _a;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return (_a = Ray$1.create()).send.apply(_a, args);
    };

    web_cjs.Ray = Ray$1;
    web_cjs.ray = ray$2;

    const { Ray, ray: ray$1 } = web_cjs;

    var web = { Ray, ray: ray$1 };

    class AlpineRay extends web.Ray {
        constructor() {
            super(...arguments);
            this.trackRays = {
                store: {},
            };
            this.window = null;
        }
        alpine() {
            return this.window.Alpine;
        }
        init(rayInstance = null, window = null) {
            var _a, _b, _c;
            this.rayInstance = (_b = (_a = rayInstance !== null && rayInstance !== void 0 ? rayInstance : this.rayInstance) !== null && _a !== void 0 ? _a : globalThis.ray()) !== null && _b !== void 0 ? _b : ray();
            this.window = (_c = window !== null && window !== void 0 ? window : this.window) !== null && _c !== void 0 ? _c : getWindow();
        }
        watchStore(name) {
            var _a, _b;
            this.init();
            if (typeof this.trackRays.store[name] === 'undefined') {
                this.trackRays.store[name] = (_b = (_a = this.rayInstance) !== null && _a !== void 0 ? _a : globalThis.ray()) !== null && _b !== void 0 ? _b : ray();
            }
            const data = this.alpine().store(name);
            this.alpine().effect(() => {
                this.trackRays.store[name].table(data);
            });
        }
        unwatchStore(name) {
            if (typeof this.trackRays.store[name] !== 'undefined') {
                delete this.trackRays.store[name];
            }
        }
    }
    AlpineRay.$version = '2.1.1';
    const ray = (...args) => {
        return AlpineRay.create().send(...args);
    };
    globalThis.ray = function (...args) {
        return ray(...args);
    };
    globalThis.AlpineRay = web.Ray;

    function getAlpineRayConfig(window = null) {
        window = window !== null && window !== void 0 ? window : getWindow();
        const config = window.alpineRayConfig || {};
        return {
            interceptErrors: (config === null || config === void 0 ? void 0 : config.interceptErrors) || false,
            logComponentsInit: (config === null || config === void 0 ? void 0 : config.logComponentsInit) || false,
            logCustomEvents: (config === null || config === void 0 ? void 0 : config.logCustomEvents) || false,
            logEvents: (config === null || config === void 0 ? void 0 : config.logEvents) || false,
        };
    }

    const isWindows = typeof process === 'object' &&
      process &&
      process.platform === 'win32';
    var path$1 = isWindows ? { sep: '\\' } : { sep: '/' };

    var balancedMatch = balanced$1;
    function balanced$1(a, b, str) {
      if (a instanceof RegExp) a = maybeMatch(a, str);
      if (b instanceof RegExp) b = maybeMatch(b, str);

      var r = range(a, b, str);

      return r && {
        start: r[0],
        end: r[1],
        pre: str.slice(0, r[0]),
        body: str.slice(r[0] + a.length, r[1]),
        post: str.slice(r[1] + b.length)
      };
    }

    function maybeMatch(reg, str) {
      var m = str.match(reg);
      return m ? m[0] : null;
    }

    balanced$1.range = range;
    function range(a, b, str) {
      var begs, beg, left, right, result;
      var ai = str.indexOf(a);
      var bi = str.indexOf(b, ai + 1);
      var i = ai;

      if (ai >= 0 && bi > 0) {
        if(a===b) {
          return [ai, bi];
        }
        begs = [];
        left = str.length;

        while (i >= 0 && !result) {
          if (i == ai) {
            begs.push(i);
            ai = str.indexOf(a, i + 1);
          } else if (begs.length == 1) {
            result = [ begs.pop(), bi ];
          } else {
            beg = begs.pop();
            if (beg < left) {
              left = beg;
              right = bi;
            }

            bi = str.indexOf(b, i + 1);
          }

          i = ai < bi && ai >= 0 ? ai : bi;
        }

        if (begs.length) {
          result = [ left, right ];
        }
      }

      return result;
    }

    var balanced = balancedMatch;

    var braceExpansion = expandTop;

    var escSlash = '\0SLASH'+Math.random()+'\0';
    var escOpen = '\0OPEN'+Math.random()+'\0';
    var escClose = '\0CLOSE'+Math.random()+'\0';
    var escComma = '\0COMMA'+Math.random()+'\0';
    var escPeriod = '\0PERIOD'+Math.random()+'\0';

    function numeric(str) {
      return parseInt(str, 10) == str
        ? parseInt(str, 10)
        : str.charCodeAt(0);
    }

    function escapeBraces(str) {
      return str.split('\\\\').join(escSlash)
                .split('\\{').join(escOpen)
                .split('\\}').join(escClose)
                .split('\\,').join(escComma)
                .split('\\.').join(escPeriod);
    }

    function unescapeBraces(str) {
      return str.split(escSlash).join('\\')
                .split(escOpen).join('{')
                .split(escClose).join('}')
                .split(escComma).join(',')
                .split(escPeriod).join('.');
    }


    // Basically just str.split(","), but handling cases
    // where we have nested braced sections, which should be
    // treated as individual members, like {a,{b,c},d}
    function parseCommaParts(str) {
      if (!str)
        return [''];

      var parts = [];
      var m = balanced('{', '}', str);

      if (!m)
        return str.split(',');

      var pre = m.pre;
      var body = m.body;
      var post = m.post;
      var p = pre.split(',');

      p[p.length-1] += '{' + body + '}';
      var postParts = parseCommaParts(post);
      if (post.length) {
        p[p.length-1] += postParts.shift();
        p.push.apply(p, postParts);
      }

      parts.push.apply(parts, p);

      return parts;
    }

    function expandTop(str) {
      if (!str)
        return [];

      // I don't know why Bash 4.3 does this, but it does.
      // Anything starting with {} will have the first two bytes preserved
      // but *only* at the top level, so {},a}b will not expand to anything,
      // but a{},b}c will be expanded to [a}c,abc].
      // One could argue that this is a bug in Bash, but since the goal of
      // this module is to match Bash's rules, we escape a leading {}
      if (str.substr(0, 2) === '{}') {
        str = '\\{\\}' + str.substr(2);
      }

      return expand$1(escapeBraces(str), true).map(unescapeBraces);
    }

    function embrace(str) {
      return '{' + str + '}';
    }
    function isPadded(el) {
      return /^-?0\d/.test(el);
    }

    function lte(i, y) {
      return i <= y;
    }
    function gte(i, y) {
      return i >= y;
    }

    function expand$1(str, isTop) {
      var expansions = [];

      var m = balanced('{', '}', str);
      if (!m) return [str];

      // no need to expand pre, since it is guaranteed to be free of brace-sets
      var pre = m.pre;
      var post = m.post.length
        ? expand$1(m.post, false)
        : [''];

      if (/\$$/.test(m.pre)) {    
        for (var k = 0; k < post.length; k++) {
          var expansion = pre+ '{' + m.body + '}' + post[k];
          expansions.push(expansion);
        }
      } else {
        var isNumericSequence = /^-?\d+\.\.-?\d+(?:\.\.-?\d+)?$/.test(m.body);
        var isAlphaSequence = /^[a-zA-Z]\.\.[a-zA-Z](?:\.\.-?\d+)?$/.test(m.body);
        var isSequence = isNumericSequence || isAlphaSequence;
        var isOptions = m.body.indexOf(',') >= 0;
        if (!isSequence && !isOptions) {
          // {a},b}
          if (m.post.match(/,.*\}/)) {
            str = m.pre + '{' + m.body + escClose + m.post;
            return expand$1(str);
          }
          return [str];
        }

        var n;
        if (isSequence) {
          n = m.body.split(/\.\./);
        } else {
          n = parseCommaParts(m.body);
          if (n.length === 1) {
            // x{{a,b}}y ==> x{a}y x{b}y
            n = expand$1(n[0], false).map(embrace);
            if (n.length === 1) {
              return post.map(function(p) {
                return m.pre + n[0] + p;
              });
            }
          }
        }

        // at this point, n is the parts, and we know it's not a comma set
        // with a single entry.
        var N;

        if (isSequence) {
          var x = numeric(n[0]);
          var y = numeric(n[1]);
          var width = Math.max(n[0].length, n[1].length);
          var incr = n.length == 3
            ? Math.abs(numeric(n[2]))
            : 1;
          var test = lte;
          var reverse = y < x;
          if (reverse) {
            incr *= -1;
            test = gte;
          }
          var pad = n.some(isPadded);

          N = [];

          for (var i = x; test(i, y); i += incr) {
            var c;
            if (isAlphaSequence) {
              c = String.fromCharCode(i);
              if (c === '\\')
                c = '';
            } else {
              c = String(i);
              if (pad) {
                var need = width - c.length;
                if (need > 0) {
                  var z = new Array(need + 1).join('0');
                  if (i < 0)
                    c = '-' + z + c.slice(1);
                  else
                    c = z + c;
                }
              }
            }
            N.push(c);
          }
        } else {
          N = [];

          for (var j = 0; j < n.length; j++) {
            N.push.apply(N, expand$1(n[j], false));
          }
        }

        for (var j = 0; j < N.length; j++) {
          for (var k = 0; k < post.length; k++) {
            var expansion = pre + N[j] + post[k];
            if (!isTop || isSequence || expansion)
              expansions.push(expansion);
          }
        }
      }

      return expansions;
    }

    const minimatch = minimatch_1 = (p, pattern, options = {}) => {
      assertValidPattern(pattern);

      // shortcut: comments match nothing.
      if (!options.nocomment && pattern.charAt(0) === '#') {
        return false
      }

      return new Minimatch(pattern, options).match(p)
    };

    var minimatch_1 = minimatch;

    const path = path$1;
    minimatch.sep = path.sep;

    const GLOBSTAR = Symbol('globstar **');
    minimatch.GLOBSTAR = GLOBSTAR;
    const expand = braceExpansion;

    const plTypes = {
      '!': { open: '(?:(?!(?:', close: '))[^/]*?)'},
      '?': { open: '(?:', close: ')?' },
      '+': { open: '(?:', close: ')+' },
      '*': { open: '(?:', close: ')*' },
      '@': { open: '(?:', close: ')' }
    };

    // any single thing other than /
    // don't need to escape / when using new RegExp()
    const qmark = '[^/]';

    // * => any number of characters
    const star = qmark + '*?';

    // ** when dots are allowed.  Anything goes, except .. and .
    // not (^ or / followed by one or two dots followed by $ or /),
    // followed by anything, any number of times.
    const twoStarDot = '(?:(?!(?:\\\/|^)(?:\\.{1,2})($|\\\/)).)*?';

    // not a ^ or / followed by a dot,
    // followed by anything, any number of times.
    const twoStarNoDot = '(?:(?!(?:\\\/|^)\\.).)*?';

    // "abc" -> { a:true, b:true, c:true }
    const charSet = s => s.split('').reduce((set, c) => {
      set[c] = true;
      return set
    }, {});

    // characters that need to be escaped in RegExp.
    const reSpecials = charSet('().*{}+?[]^$\\!');

    // characters that indicate we have to add the pattern start
    const addPatternStartSet = charSet('[.(');

    // normalizes slashes.
    const slashSplit = /\/+/;

    minimatch.filter = (pattern, options = {}) =>
      (p, i, list) => minimatch(p, pattern, options);

    const ext = (a, b = {}) => {
      const t = {};
      Object.keys(a).forEach(k => t[k] = a[k]);
      Object.keys(b).forEach(k => t[k] = b[k]);
      return t
    };

    minimatch.defaults = def => {
      if (!def || typeof def !== 'object' || !Object.keys(def).length) {
        return minimatch
      }

      const orig = minimatch;

      const m = (p, pattern, options) => orig(p, pattern, ext(def, options));
      m.Minimatch = class Minimatch extends orig.Minimatch {
        constructor (pattern, options) {
          super(pattern, ext(def, options));
        }
      };
      m.Minimatch.defaults = options => orig.defaults(ext(def, options)).Minimatch;
      m.filter = (pattern, options) => orig.filter(pattern, ext(def, options));
      m.defaults = options => orig.defaults(ext(def, options));
      m.makeRe = (pattern, options) => orig.makeRe(pattern, ext(def, options));
      m.braceExpand = (pattern, options) => orig.braceExpand(pattern, ext(def, options));
      m.match = (list, pattern, options) => orig.match(list, pattern, ext(def, options));

      return m
    };





    // Brace expansion:
    // a{b,c}d -> abd acd
    // a{b,}c -> abc ac
    // a{0..3}d -> a0d a1d a2d a3d
    // a{b,c{d,e}f}g -> abg acdfg acefg
    // a{b,c}d{e,f}g -> abdeg acdeg abdeg abdfg
    //
    // Invalid sets are not expanded.
    // a{2..}b -> a{2..}b
    // a{b}c -> a{b}c
    minimatch.braceExpand = (pattern, options) => braceExpand(pattern, options);

    const braceExpand = (pattern, options = {}) => {
      assertValidPattern(pattern);

      // Thanks to Yeting Li <https://github.com/yetingli> for
      // improving this regexp to avoid a ReDOS vulnerability.
      if (options.nobrace || !/\{(?:(?!\{).)*\}/.test(pattern)) {
        // shortcut. no need to expand.
        return [pattern]
      }

      return expand(pattern)
    };

    const MAX_PATTERN_LENGTH = 1024 * 64;
    const assertValidPattern = pattern => {
      if (typeof pattern !== 'string') {
        throw new TypeError('invalid pattern')
      }

      if (pattern.length > MAX_PATTERN_LENGTH) {
        throw new TypeError('pattern is too long')
      }
    };

    // parse a component of the expanded set.
    // At this point, no pattern may contain "/" in it
    // so we're going to return a 2d array, where each entry is the full
    // pattern, split on '/', and then turned into a regular expression.
    // A regexp is made at the end which joins each array with an
    // escaped /, and another full one which joins each regexp with |.
    //
    // Following the lead of Bash 4.1, note that "**" only has special meaning
    // when it is the *only* thing in a path portion.  Otherwise, any series
    // of * is equivalent to a single *.  Globstar behavior is enabled by
    // default, and can be disabled by setting options.noglobstar.
    const SUBPARSE = Symbol('subparse');

    minimatch.makeRe = (pattern, options) =>
      new Minimatch(pattern, options || {}).makeRe();

    minimatch.match = (list, pattern, options = {}) => {
      const mm = new Minimatch(pattern, options);
      list = list.filter(f => mm.match(f));
      if (mm.options.nonull && !list.length) {
        list.push(pattern);
      }
      return list
    };

    // replace stuff like \* with *
    const globUnescape = s => s.replace(/\\(.)/g, '$1');
    const regExpEscape = s => s.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, '\\$&');

    class Minimatch {
      constructor (pattern, options) {
        assertValidPattern(pattern);

        if (!options) options = {};

        this.options = options;
        this.set = [];
        this.pattern = pattern;
        this.windowsPathsNoEscape = !!options.windowsPathsNoEscape ||
          options.allowWindowsEscape === false;
        if (this.windowsPathsNoEscape) {
          this.pattern = this.pattern.replace(/\\/g, '/');
        }
        this.regexp = null;
        this.negate = false;
        this.comment = false;
        this.empty = false;
        this.partial = !!options.partial;

        // make the set of regexps etc.
        this.make();
      }

      debug () {}

      make () {
        const pattern = this.pattern;
        const options = this.options;

        // empty patterns and comments match nothing.
        if (!options.nocomment && pattern.charAt(0) === '#') {
          this.comment = true;
          return
        }
        if (!pattern) {
          this.empty = true;
          return
        }

        // step 1: figure out negation, etc.
        this.parseNegate();

        // step 2: expand braces
        let set = this.globSet = this.braceExpand();

        if (options.debug) this.debug = (...args) => console.error(...args);

        this.debug(this.pattern, set);

        // step 3: now we have a set, so turn each one into a series of path-portion
        // matching patterns.
        // These will be regexps, except in the case of "**", which is
        // set to the GLOBSTAR object for globstar behavior,
        // and will not contain any / characters
        set = this.globParts = set.map(s => s.split(slashSplit));

        this.debug(this.pattern, set);

        // glob --> regexps
        set = set.map((s, si, set) => s.map(this.parse, this));

        this.debug(this.pattern, set);

        // filter out everything that didn't compile properly.
        set = set.filter(s => s.indexOf(false) === -1);

        this.debug(this.pattern, set);

        this.set = set;
      }

      parseNegate () {
        if (this.options.nonegate) return

        const pattern = this.pattern;
        let negate = false;
        let negateOffset = 0;

        for (let i = 0; i < pattern.length && pattern.charAt(i) === '!'; i++) {
          negate = !negate;
          negateOffset++;
        }

        if (negateOffset) this.pattern = pattern.slice(negateOffset);
        this.negate = negate;
      }

      // set partial to true to test if, for example,
      // "/a/b" matches the start of "/*/b/*/d"
      // Partial means, if you run out of file before you run
      // out of pattern, then that's fine, as long as all
      // the parts match.
      matchOne (file, pattern, partial) {
        var options = this.options;

        this.debug('matchOne',
          { 'this': this, file: file, pattern: pattern });

        this.debug('matchOne', file.length, pattern.length);

        for (var fi = 0,
            pi = 0,
            fl = file.length,
            pl = pattern.length
            ; (fi < fl) && (pi < pl)
            ; fi++, pi++) {
          this.debug('matchOne loop');
          var p = pattern[pi];
          var f = file[fi];

          this.debug(pattern, p, f);

          // should be impossible.
          // some invalid regexp stuff in the set.
          /* istanbul ignore if */
          if (p === false) return false

          if (p === GLOBSTAR) {
            this.debug('GLOBSTAR', [pattern, p, f]);

            // "**"
            // a/**/b/**/c would match the following:
            // a/b/x/y/z/c
            // a/x/y/z/b/c
            // a/b/x/b/x/c
            // a/b/c
            // To do this, take the rest of the pattern after
            // the **, and see if it would match the file remainder.
            // If so, return success.
            // If not, the ** "swallows" a segment, and try again.
            // This is recursively awful.
            //
            // a/**/b/**/c matching a/b/x/y/z/c
            // - a matches a
            // - doublestar
            //   - matchOne(b/x/y/z/c, b/**/c)
            //     - b matches b
            //     - doublestar
            //       - matchOne(x/y/z/c, c) -> no
            //       - matchOne(y/z/c, c) -> no
            //       - matchOne(z/c, c) -> no
            //       - matchOne(c, c) yes, hit
            var fr = fi;
            var pr = pi + 1;
            if (pr === pl) {
              this.debug('** at the end');
              // a ** at the end will just swallow the rest.
              // We have found a match.
              // however, it will not swallow /.x, unless
              // options.dot is set.
              // . and .. are *never* matched by **, for explosively
              // exponential reasons.
              for (; fi < fl; fi++) {
                if (file[fi] === '.' || file[fi] === '..' ||
                  (!options.dot && file[fi].charAt(0) === '.')) return false
              }
              return true
            }

            // ok, let's see if we can swallow whatever we can.
            while (fr < fl) {
              var swallowee = file[fr];

              this.debug('\nglobstar while', file, fr, pattern, pr, swallowee);

              // XXX remove this slice.  Just pass the start index.
              if (this.matchOne(file.slice(fr), pattern.slice(pr), partial)) {
                this.debug('globstar found match!', fr, fl, swallowee);
                // found a match.
                return true
              } else {
                // can't swallow "." or ".." ever.
                // can only swallow ".foo" when explicitly asked.
                if (swallowee === '.' || swallowee === '..' ||
                  (!options.dot && swallowee.charAt(0) === '.')) {
                  this.debug('dot detected!', file, fr, pattern, pr);
                  break
                }

                // ** swallows a segment, and continue.
                this.debug('globstar swallow a segment, and continue');
                fr++;
              }
            }

            // no match was found.
            // However, in partial mode, we can't say this is necessarily over.
            // If there's more *pattern* left, then
            /* istanbul ignore if */
            if (partial) {
              // ran out of file
              this.debug('\n>>> no match, partial?', file, fr, pattern, pr);
              if (fr === fl) return true
            }
            return false
          }

          // something other than **
          // non-magic patterns just have to match exactly
          // patterns with magic have been turned into regexps.
          var hit;
          if (typeof p === 'string') {
            hit = f === p;
            this.debug('string match', p, f, hit);
          } else {
            hit = f.match(p);
            this.debug('pattern match', p, f, hit);
          }

          if (!hit) return false
        }

        // Note: ending in / means that we'll get a final ""
        // at the end of the pattern.  This can only match a
        // corresponding "" at the end of the file.
        // If the file ends in /, then it can only match a
        // a pattern that ends in /, unless the pattern just
        // doesn't have any more for it. But, a/b/ should *not*
        // match "a/b/*", even though "" matches against the
        // [^/]*? pattern, except in partial mode, where it might
        // simply not be reached yet.
        // However, a/b/ should still satisfy a/*

        // now either we fell off the end of the pattern, or we're done.
        if (fi === fl && pi === pl) {
          // ran out of pattern and filename at the same time.
          // an exact hit!
          return true
        } else if (fi === fl) {
          // ran out of file, but still had pattern left.
          // this is ok if we're doing the match as part of
          // a glob fs traversal.
          return partial
        } else /* istanbul ignore else */ if (pi === pl) {
          // ran out of pattern, still have file left.
          // this is only acceptable if we're on the very last
          // empty segment of a file with a trailing slash.
          // a/* should match a/b/
          return (fi === fl - 1) && (file[fi] === '')
        }

        // should be unreachable.
        /* istanbul ignore next */
        throw new Error('wtf?')
      }

      braceExpand () {
        return braceExpand(this.pattern, this.options)
      }

      parse (pattern, isSub) {
        assertValidPattern(pattern);

        const options = this.options;

        // shortcuts
        if (pattern === '**') {
          if (!options.noglobstar)
            return GLOBSTAR
          else
            pattern = '*';
        }
        if (pattern === '') return ''

        let re = '';
        let hasMagic = !!options.nocase;
        let escaping = false;
        // ? => one single character
        const patternListStack = [];
        const negativeLists = [];
        let stateChar;
        let inClass = false;
        let reClassStart = -1;
        let classStart = -1;
        let cs;
        let pl;
        let sp;
        // . and .. never match anything that doesn't start with .,
        // even when options.dot is set.
        const patternStart = pattern.charAt(0) === '.' ? '' // anything
        // not (start or / followed by . or .. followed by / or end)
        : options.dot ? '(?!(?:^|\\\/)\\.{1,2}(?:$|\\\/))'
        : '(?!\\.)';

        const clearStateChar = () => {
          if (stateChar) {
            // we had some state-tracking character
            // that wasn't consumed by this pass.
            switch (stateChar) {
              case '*':
                re += star;
                hasMagic = true;
              break
              case '?':
                re += qmark;
                hasMagic = true;
              break
              default:
                re += '\\' + stateChar;
              break
            }
            this.debug('clearStateChar %j %j', stateChar, re);
            stateChar = false;
          }
        };

        for (let i = 0, c; (i < pattern.length) && (c = pattern.charAt(i)); i++) {
          this.debug('%s\t%s %s %j', pattern, i, re, c);

          // skip over any that are escaped.
          if (escaping) {
            /* istanbul ignore next - completely not allowed, even escaped. */
            if (c === '/') {
              return false
            }

            if (reSpecials[c]) {
              re += '\\';
            }
            re += c;
            escaping = false;
            continue
          }

          switch (c) {
            /* istanbul ignore next */
            case '/': {
              // Should already be path-split by now.
              return false
            }

            case '\\':
              clearStateChar();
              escaping = true;
            continue

            // the various stateChar values
            // for the "extglob" stuff.
            case '?':
            case '*':
            case '+':
            case '@':
            case '!':
              this.debug('%s\t%s %s %j <-- stateChar', pattern, i, re, c);

              // all of those are literals inside a class, except that
              // the glob [!a] means [^a] in regexp
              if (inClass) {
                this.debug('  in class');
                if (c === '!' && i === classStart + 1) c = '^';
                re += c;
                continue
              }

              // if we already have a stateChar, then it means
              // that there was something like ** or +? in there.
              // Handle the stateChar, then proceed with this one.
              this.debug('call clearStateChar %j', stateChar);
              clearStateChar();
              stateChar = c;
              // if extglob is disabled, then +(asdf|foo) isn't a thing.
              // just clear the statechar *now*, rather than even diving into
              // the patternList stuff.
              if (options.noext) clearStateChar();
            continue

            case '(':
              if (inClass) {
                re += '(';
                continue
              }

              if (!stateChar) {
                re += '\\(';
                continue
              }

              patternListStack.push({
                type: stateChar,
                start: i - 1,
                reStart: re.length,
                open: plTypes[stateChar].open,
                close: plTypes[stateChar].close
              });
              // negation is (?:(?!js)[^/]*)
              re += stateChar === '!' ? '(?:(?!(?:' : '(?:';
              this.debug('plType %j %j', stateChar, re);
              stateChar = false;
            continue

            case ')':
              if (inClass || !patternListStack.length) {
                re += '\\)';
                continue
              }

              clearStateChar();
              hasMagic = true;
              pl = patternListStack.pop();
              // negation is (?:(?!js)[^/]*)
              // The others are (?:<pattern>)<type>
              re += pl.close;
              if (pl.type === '!') {
                negativeLists.push(pl);
              }
              pl.reEnd = re.length;
            continue

            case '|':
              if (inClass || !patternListStack.length) {
                re += '\\|';
                continue
              }

              clearStateChar();
              re += '|';
            continue

            // these are mostly the same in regexp and glob
            case '[':
              // swallow any state-tracking char before the [
              clearStateChar();

              if (inClass) {
                re += '\\' + c;
                continue
              }

              inClass = true;
              classStart = i;
              reClassStart = re.length;
              re += c;
            continue

            case ']':
              //  a right bracket shall lose its special
              //  meaning and represent itself in
              //  a bracket expression if it occurs
              //  first in the list.  -- POSIX.2 2.8.3.2
              if (i === classStart + 1 || !inClass) {
                re += '\\' + c;
                continue
              }

              // handle the case where we left a class open.
              // "[z-a]" is valid, equivalent to "\[z-a\]"
              // split where the last [ was, make sure we don't have
              // an invalid re. if so, re-walk the contents of the
              // would-be class to re-translate any characters that
              // were passed through as-is
              // TODO: It would probably be faster to determine this
              // without a try/catch and a new RegExp, but it's tricky
              // to do safely.  For now, this is safe and works.
              cs = pattern.substring(classStart + 1, i);
              try {
                RegExp('[' + cs + ']');
              } catch (er) {
                // not a valid class!
                sp = this.parse(cs, SUBPARSE);
                re = re.substring(0, reClassStart) + '\\[' + sp[0] + '\\]';
                hasMagic = hasMagic || sp[1];
                inClass = false;
                continue
              }

              // finish up the class.
              hasMagic = true;
              inClass = false;
              re += c;
            continue

            default:
              // swallow any state char that wasn't consumed
              clearStateChar();

              if (reSpecials[c] && !(c === '^' && inClass)) {
                re += '\\';
              }

              re += c;
              break

          } // switch
        } // for

        // handle the case where we left a class open.
        // "[abc" is valid, equivalent to "\[abc"
        if (inClass) {
          // split where the last [ was, and escape it
          // this is a huge pita.  We now have to re-walk
          // the contents of the would-be class to re-translate
          // any characters that were passed through as-is
          cs = pattern.slice(classStart + 1);
          sp = this.parse(cs, SUBPARSE);
          re = re.substring(0, reClassStart) + '\\[' + sp[0];
          hasMagic = hasMagic || sp[1];
        }

        // handle the case where we had a +( thing at the *end*
        // of the pattern.
        // each pattern list stack adds 3 chars, and we need to go through
        // and escape any | chars that were passed through as-is for the regexp.
        // Go through and escape them, taking care not to double-escape any
        // | chars that were already escaped.
        for (pl = patternListStack.pop(); pl; pl = patternListStack.pop()) {
          let tail;
          tail = re.slice(pl.reStart + pl.open.length);
          this.debug('setting tail', re, pl);
          // maybe some even number of \, then maybe 1 \, followed by a |
          tail = tail.replace(/((?:\\{2}){0,64})(\\?)\|/g, (_, $1, $2) => {
            /* istanbul ignore else - should already be done */
            if (!$2) {
              // the | isn't already escaped, so escape it.
              $2 = '\\';
            }

            // need to escape all those slashes *again*, without escaping the
            // one that we need for escaping the | character.  As it works out,
            // escaping an even number of slashes can be done by simply repeating
            // it exactly after itself.  That's why this trick works.
            //
            // I am sorry that you have to see this.
            return $1 + $1 + $2 + '|'
          });

          this.debug('tail=%j\n   %s', tail, tail, pl, re);
          const t = pl.type === '*' ? star
            : pl.type === '?' ? qmark
            : '\\' + pl.type;

          hasMagic = true;
          re = re.slice(0, pl.reStart) + t + '\\(' + tail;
        }

        // handle trailing things that only matter at the very end.
        clearStateChar();
        if (escaping) {
          // trailing \\
          re += '\\\\';
        }

        // only need to apply the nodot start if the re starts with
        // something that could conceivably capture a dot
        const addPatternStart = addPatternStartSet[re.charAt(0)];

        // Hack to work around lack of negative lookbehind in JS
        // A pattern like: *.!(x).!(y|z) needs to ensure that a name
        // like 'a.xyz.yz' doesn't match.  So, the first negative
        // lookahead, has to look ALL the way ahead, to the end of
        // the pattern.
        for (let n = negativeLists.length - 1; n > -1; n--) {
          const nl = negativeLists[n];

          const nlBefore = re.slice(0, nl.reStart);
          const nlFirst = re.slice(nl.reStart, nl.reEnd - 8);
          let nlAfter = re.slice(nl.reEnd);
          const nlLast = re.slice(nl.reEnd - 8, nl.reEnd) + nlAfter;

          // Handle nested stuff like *(*.js|!(*.json)), where open parens
          // mean that we should *not* include the ) in the bit that is considered
          // "after" the negated section.
          const openParensBefore = nlBefore.split('(').length - 1;
          let cleanAfter = nlAfter;
          for (let i = 0; i < openParensBefore; i++) {
            cleanAfter = cleanAfter.replace(/\)[+*?]?/, '');
          }
          nlAfter = cleanAfter;

          const dollar = nlAfter === '' && isSub !== SUBPARSE ? '$' : '';
          re = nlBefore + nlFirst + nlAfter + dollar + nlLast;
        }

        // if the re is not "" at this point, then we need to make sure
        // it doesn't match against an empty path part.
        // Otherwise a/* will match a/, which it should not.
        if (re !== '' && hasMagic) {
          re = '(?=.)' + re;
        }

        if (addPatternStart) {
          re = patternStart + re;
        }

        // parsing just a piece of a larger pattern.
        if (isSub === SUBPARSE) {
          return [re, hasMagic]
        }

        // skip the regexp for non-magical patterns
        // unescape anything in it, though, so that it'll be
        // an exact match against a file etc.
        if (!hasMagic) {
          return globUnescape(pattern)
        }

        const flags = options.nocase ? 'i' : '';
        try {
          return Object.assign(new RegExp('^' + re + '$', flags), {
            _glob: pattern,
            _src: re,
          })
        } catch (er) /* istanbul ignore next - should be impossible */ {
          // If it was an invalid regular expression, then it can't match
          // anything.  This trick looks for a character after the end of
          // the string, which is of course impossible, except in multi-line
          // mode, but it's not a /m regex.
          return new RegExp('$.')
        }
      }

      makeRe () {
        if (this.regexp || this.regexp === false) return this.regexp

        // at this point, this.set is a 2d array of partial
        // pattern strings, or "**".
        //
        // It's better to use .match().  This function shouldn't
        // be used, really, but it's pretty convenient sometimes,
        // when you just want to work with a regex.
        const set = this.set;

        if (!set.length) {
          this.regexp = false;
          return this.regexp
        }
        const options = this.options;

        const twoStar = options.noglobstar ? star
          : options.dot ? twoStarDot
          : twoStarNoDot;
        const flags = options.nocase ? 'i' : '';

        // coalesce globstars and regexpify non-globstar patterns
        // if it's the only item, then we just do one twoStar
        // if it's the first, and there are more, prepend (\/|twoStar\/)? to next
        // if it's the last, append (\/twoStar|) to previous
        // if it's in the middle, append (\/|\/twoStar\/) to previous
        // then filter out GLOBSTAR symbols
        let re = set.map(pattern => {
          pattern = pattern.map(p =>
            typeof p === 'string' ? regExpEscape(p)
            : p === GLOBSTAR ? GLOBSTAR
            : p._src
          ).reduce((set, p) => {
            if (!(set[set.length - 1] === GLOBSTAR && p === GLOBSTAR)) {
              set.push(p);
            }
            return set
          }, []);
          pattern.forEach((p, i) => {
            if (p !== GLOBSTAR || pattern[i-1] === GLOBSTAR) {
              return
            }
            if (i === 0) {
              if (pattern.length > 1) {
                pattern[i+1] = '(?:\\\/|' + twoStar + '\\\/)?' + pattern[i+1];
              } else {
                pattern[i] = twoStar;
              }
            } else if (i === pattern.length - 1) {
              pattern[i-1] += '(?:\\\/|' + twoStar + ')?';
            } else {
              pattern[i-1] += '(?:\\\/|\\\/' + twoStar + '\\\/)' + pattern[i+1];
              pattern[i+1] = GLOBSTAR;
            }
          });
          return pattern.filter(p => p !== GLOBSTAR).join('/')
        }).join('|');

        // must match entire pattern
        // ending in a * or ** will make it less strict.
        re = '^(?:' + re + ')$';

        // can match anything, as long as it's not this.
        if (this.negate) re = '^(?!' + re + ').*$';

        try {
          this.regexp = new RegExp(re, flags);
        } catch (ex) /* istanbul ignore next - should be impossible */ {
          this.regexp = false;
        }
        return this.regexp
      }

      match (f, partial = this.partial) {
        this.debug('match', f, this.pattern);
        // short-circuit in the case of busted things.
        // comments, etc.
        if (this.comment) return false
        if (this.empty) return f === ''

        if (f === '/' && partial) return true

        const options = this.options;

        // windows: need to use /, not \
        if (path.sep !== '/') {
          f = f.split(path.sep).join('/');
        }

        // treat the test path as a set of pathparts.
        f = f.split(slashSplit);
        this.debug(this.pattern, 'split', f);

        // just ONE of the pattern sets in this.set needs to match
        // in order for it to be valid.  If negating, then just one
        // match means that we have failed.
        // Either way, return on the first hit.

        const set = this.set;
        this.debug(this.pattern, 'set', set);

        // Find the basename of the path by looking for the last non-empty segment
        let filename;
        for (let i = f.length - 1; i >= 0; i--) {
          filename = f[i];
          if (filename) break
        }

        for (let i = 0; i < set.length; i++) {
          const pattern = set[i];
          let file = f;
          if (options.matchBase && pattern.length === 1) {
            file = [filename];
          }
          const hit = this.matchOne(file, pattern, partial);
          if (hit) {
            if (options.flipNegate) return true
            return !this.negate
          }
        }

        // didn't get any hits.  this is success if it's a negative
        // pattern, failure otherwise.
        if (options.flipNegate) return false
        return this.negate
      }

      static defaults (def) {
        return minimatch.defaults(def).Minimatch
      }
    }

    minimatch.Minimatch = Minimatch;

    var minimatch$1 = minimatch_1;

    function getMatches(patterns, values) {
        const result = [];
        for (const pattern of patterns) {
            for (const value of values) {
                if (minimatch$1(value, pattern)) {
                    result.push(value);
                }
            }
        }
        return result;
    }
    const AlpineRayMagicMethod = {
        trackRays: {},
        trackCounters: {},
        initCustomEventListeners(config = null, window = null, rayInstance = null) {
            config = config !== null && config !== void 0 ? config : getAlpineRayConfig(window);
            if (Array.isArray((config === null || config === void 0 ? void 0 : config.logEvents) || false)) {
                const eventRegex = new RegExp(/(?:@|x-on:)([\w-_.]+)=/g);
                const html = window.document.querySelector('body').outerHTML;
                const matches = html.matchAll(eventRegex);
                const eventNames = [];
                for (const match of matches) {
                    eventNames.push(match[1]);
                }
                getMatches(config.logEvents, eventNames).forEach(name => {
                    var _a;
                    if (!(config === null || config === void 0 ? void 0 : config.logEvents.includes(name)) && !(config === null || config === void 0 ? void 0 : config.logEvents.includes('*'))) {
                        return;
                    }
                    const nameParts = name.split('.');
                    const eventName = (_a = nameParts[0]) !== null && _a !== void 0 ? _a : name;
                    const lastNamePart = nameParts[nameParts.length - 1];
                    window.addEventListener(eventName, e => {
                        var _a;
                        if (eventName.includes('-') || (nameParts.length === 2 && lastNamePart === 'window')) {
                            rayInstance().table({
                                event: name,
                                payload: (_a = e.detail) !== null && _a !== void 0 ? _a : null,
                            }, 'alpine.js');
                        }
                    });
                });
            }
        },
        initErrorHandlers(config = null, window = null, rayInstance = null) {
            window = window !== null && window !== void 0 ? window : getWindow();
            config = config !== null && config !== void 0 ? config : getAlpineRayConfig(window);
            rayInstance = rayInstance !== null && rayInstance !== void 0 ? rayInstance : ray;
            if (!(config.interceptErrors || false)) {
                return this;
            }
            const errorHandlerCallback = (errorEvent) => {
                var _a;
                if (errorEvent.error || errorEvent.reason) {
                    const data = errorEvent.reason || errorEvent.error;
                    const { el, expression } = data;
                    const parentComponent = findParentComponent(el);
                    if (!parentComponent) {
                        return;
                    }
                    const parentComponentOuterHTML = highlightHtmlMarkup(parentComponent.outerHTML).replace(encodeHtmlEntities$1(expression), `<span class="text-red-700 bg-red-300 p-1">${encodeHtmlEntities$1(expression)}</span>`);
                    const componentData = (_a = parentComponent.__x) !== null && _a !== void 0 ? _a : { $data: {} };
                    rayInstance().table({
                        errorType: `alpine.js error`,
                        errorReason: data.toString(),
                        expression: `<code>${expression}</code>`,
                        srcElement: el.tagName.toLowerCase(),
                        componentHtml: `<code>${parentComponentOuterHTML}</code>`,
                        componentData: filterObjectKeys(componentData.$data, ['$el', '$watch', '$refs', '$nextTick']),
                    }, 'ERROR');
                }
            };
            window.addEventListener('error', errorHandlerCallback);
            window.addEventListener('unhandledrejection', errorHandlerCallback);
            return this;
        },
        init(config = null, window = null, rayInstance = null) {
            window = window !== null && window !== void 0 ? window : getWindow();
            config = config !== null && config !== void 0 ? config : getAlpineRayConfig(window);
            rayInstance = rayInstance !== null && rayInstance !== void 0 ? rayInstance : ray;
            this.initCustomEventListeners(config, window, rayInstance);
            this.initErrorHandlers(config, window, rayInstance);
            return this;
        },
        register(Alpine = null, window = null, rayInstance = null) {
            window = window !== null && window !== void 0 ? window : getWindow();
            Alpine = Alpine !== null && Alpine !== void 0 ? Alpine : window.Alpine;
            rayInstance = rayInstance !== null && rayInstance !== void 0 ? rayInstance : ray;
            checkForAxios(window);
            Alpine.directive('ray', (el, { expression }, { evaluateLater, effect }) => {
                const result = evaluateLater(expression);
                effect(() => {
                    result(data => {
                        const tableData = {
                            'element-tag': el.tagName.toLowerCase(),
                            'element-id': null,
                            'element-ref': null,
                            'element-name': null,
                            'last-changed': new Date().toLocaleString(),
                            'change-counter': 0,
                            data,
                        };
                        let ident = null;
                        if (el.getAttribute('id')) {
                            tableData['element-id'] = el.getAttribute('id');
                            ident = el.getAttribute('id');
                        }
                        if (el.getAttribute('name')) {
                            tableData['element-name'] = el.getAttribute('name');
                            if (!ident) {
                                ident = el.getAttribute('name');
                            }
                        }
                        if (el.getAttribute('x-ref')) {
                            tableData['element-ref'] = el.getAttribute('x-ref');
                            if (!ident) {
                                ident = el.getAttribute('x-ref');
                            }
                        }
                        for (const name in tableData) {
                            if (name !== 'data' && tableData[name] === null) {
                                delete tableData[name];
                            }
                        }
                        if (ident) {
                            if (typeof this.trackRays[ident] === 'undefined') {
                                this.trackRays[ident] = rayInstance();
                                this.trackCounters[ident] = 0;
                            }
                            tableData['change-counter'] = ++this.trackCounters[ident];
                            tableData['data'] = `<div class="bg-red-400 p-1 rounded-md">${tableData['data']}</div>`;
                            this.trackRays[ident].table(tableData, 'alpine.js');
                            rayInstance = this.trackRays[ident];
                            this.trackRays[ident] = rayInstance().table(tableData, 'x-ray');
                            setTimeout(() => {
                                tableData['data'] = tableData['data'].replace('bg-red-400', '');
                                this.trackRays[ident] = rayInstance().table(tableData, 'x-ray');
                            }, 3000);
                        }
                        else {
                            rayInstance().table(tableData, 'x-ray');
                        }
                    });
                });
            });
            const rayCallback = (...params) => rayInstance(...params);
            Alpine.magic('ray', () => rayCallback);
        },
    };

    function pluginCallback (Alpine, window = null) {
        AlpineRayMagicMethod.init(null, window).register(Alpine, window);
    }

    const win = getWindow();
    win.document.addEventListener('alpine:init', () => {
        pluginCallback(win.Alpine, win);
    });

}));
//# sourceMappingURL=standalone.js.map
